/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 19)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern17 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern17 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern17 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern17 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern17 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern17 (x3, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x9 = XEXP (x1, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_V4SFmode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[2] = x11;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x11 = XVECEXP (x4, 0, 4);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x12 = XVECEXP (x4, 0, 5);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x13 = XVECEXP (x4, 0, 6);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x14 = XVECEXP (x4, 0, 7);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 8);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x16 = XVECEXP (x4, 0, 9);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x17 = XVECEXP (x4, 0, 10);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x18 = XVECEXP (x4, 0, 11);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x19 = XVECEXP (x4, 0, 12);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x4, 0, 13);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x21 = XVECEXP (x4, 0, 14);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XVECEXP (x4, 0, 15);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != USE
          || !nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16QImode))
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case 4:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != CLOBBER)
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!scratch_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 1;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x8;
      return 0;

    case ROTATE:
      if (GET_MODE (x8) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode)
          || !contiguous_bitmask_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[4] = x11;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      return 1;

    case LSHIFTRT:
      res = pattern91 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case ASHIFT:
      res = pattern91 (x5);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE
      || !memory_operand (operands[0], E_BLKmode)
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  switch (GET_CODE (x3))
    {
    case MEM:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 32)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_BLKmode)
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 0
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 0);
      operands[3] = x13;
      x14 = XEXP (x4, 0);
      operands[0] = x14;
      x15 = XEXP (x6, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x7, 0);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          return pattern120 (x5, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern120 (x5, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 6)
        return -1;
      x17 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x18 = XEXP (x12, 0);
      operands[3] = x18;
      x14 = XEXP (x4, 0);
      operands[1] = x14;
      x19 = XEXP (x17, 0);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      x20 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x20))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
        case PLUS:
          operands[2] = x20;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern121 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 2;

            case 4:
              if (pattern121 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 3;

            case 12:
              if (pattern121 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 4;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x21 = XEXP (x20, 0);
          operands[2] = x21;
          if (!setmem_operand (operands[2], E_QImode))
            return -1;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern122 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 5;

            case 4:
              if (pattern122 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 6;

            case 12:
              if (pattern122 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern168 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != USE)
    return -1;
  return 0;
}

int
pattern202 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern214 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern214 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern221 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern251 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern270 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern274 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern281 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern293 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern27 (x1))
    {
    case 0:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1035; /* vec_widen_smult_even_v1qi */

    case 1:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1036; /* vec_widen_smult_even_v2qi */

    case 2:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1037; /* vec_widen_smult_even_v4qi */

    case 3:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1038; /* vec_widen_smult_even_v8qi */

    case 4:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1039; /* vec_widen_smult_even_v16qi */

    case 5:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1040; /* vec_widen_smult_even_v1hi */

    case 6:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1041; /* vec_widen_smult_even_v2hi */

    case 7:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1042; /* vec_widen_smult_even_v4hi */

    case 8:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1043; /* vec_widen_smult_even_v8hi */

    case 9:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1044; /* vec_widen_smult_even_v1si */

    case 10:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1045; /* vec_widen_smult_even_v2si */

    case 11:
      if (!
#line 1550 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1046; /* vec_widen_smult_even_v4si */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x8 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      switch (XWINT (x8, 0))
        {
        case 0L:
          switch (XWINT (x9, 0))
            {
            case 3L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern219 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 769 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 549; /* vpdi1v2di */

                case E_V2DFmode:
                  if (pattern219 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 769 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 550; /* vpdi1v2df */

                default:
                  return -1;
                }

            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern219 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 896 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 565; /* *vmrhg */

                case E_V2DFmode:
                  if (pattern219 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 896 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 566; /* *vmrhg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1L:
          switch (XWINT (x9, 0))
            {
            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern219 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 551; /* vpdi4v2di */

                case E_V2DFmode:
                  if (pattern219 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 552; /* vpdi4v2df */

                default:
                  return -1;
                }

            case 3L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern219 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 906 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 567; /* *vmrlg */

                case E_V2DFmode:
                  if (pattern219 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 906 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 568; /* *vmrlg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      x8 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      switch (XWINT (x8, 0))
        {
        case 2L:
          switch (XWINT (x9, 0))
            {
            case 3L:
              if (XWINT (x10, 0) != 4L
                  || XWINT (x11, 0) != 5L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern219 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 793 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 553; /* vpdi4_2v4si */

                case E_V4SFmode:
                  if (pattern219 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 793 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 554; /* vpdi4_2v4sf */

                default:
                  return -1;
                }

            case 6L:
              if (XWINT (x10, 0) != 3L
                  || XWINT (x11, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern219 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 886 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 563; /* *vmrlf */

                case E_V4SFmode:
                  if (pattern219 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 886 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 564; /* *vmrlf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          if (XWINT (x10, 0) != 1L)
            return -1;
          switch (XWINT (x9, 0))
            {
            case 4L:
              if (XWINT (x11, 0) != 5L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern219 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 864 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 559; /* *vmrhf */

                case E_V4SFmode:
                  if (pattern219 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 864 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 560; /* *vmrhf */

                default:
                  return -1;
                }

            case 2L:
              if (XWINT (x11, 0) != 3L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern106 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                      || !
#line 875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 561; /* *vmrhf_halfv4si */

                case E_V4SFmode:
                  if (pattern106 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                      || !
#line 875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 562; /* *vmrhf_halfv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 16:
      if (pattern127 (x3) != 0)
        return -1;
      x12 = XVECEXP (x3, 0, 8);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x3, 0, 9);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x14 = XVECEXP (x3, 0, 10);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x3, 0, 11);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x3, 0, 12);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x3, 0, 13);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x3, 0, 14);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x3, 0, 15);
      if (GET_CODE (x19) != CONST_INT
          || pattern219 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      switch (XWINT (x8, 0))
        {
        case 0L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 16L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 17L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 2L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 18L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 3L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 19L
              || XWINT (x12, 0) != 4L
              || XWINT (x13, 0) != 20L
              || XWINT (x14, 0) != 5L
              || XWINT (x15, 0) != 21L
              || XWINT (x16, 0) != 6L
              || XWINT (x17, 0) != 22L
              || XWINT (x18, 0) != 7L
              || XWINT (x19, 0) != 23L
              || !
#line 810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 555; /* *vmrhb */

        case 8L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 24L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 9L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 25L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 10L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 26L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 11L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 27L
              || XWINT (x12, 0) != 12L
              || XWINT (x13, 0) != 28L
              || XWINT (x14, 0) != 13L
              || XWINT (x15, 0) != 29L
              || XWINT (x16, 0) != 14L
              || XWINT (x17, 0) != 30L
              || XWINT (x18, 0) != 15L
              || XWINT (x19, 0) != 31L
              || !
#line 827 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 556; /* *vmrlb */

        default:
          return -1;
        }

    case 8:
      if (pattern127 (x3) != 0
          || pattern219 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      switch (XWINT (x8, 0))
        {
        case 0L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 8L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 9L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 2L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 10L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 3L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 11L
              || !
#line 840 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 557; /* *vmrhh */

        case 4L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 12L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 5L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 13L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 6L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 14L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 7L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 15L
              || !
#line 853 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 558; /* *vmrlh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4129 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return 1584; /* *extzvdi_nocc_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4129 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return -1;
  *pnum_clobbers = 1;
  return 1585; /* *extzvdi_clobbercc_lshiftrt */
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == EQ)
    {
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  if (!s390_signed_integer_comparison (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) == PC)
    {
      x8 = XEXP (x2, 2);
      switch (pattern172 (x8))
        {
        case 0:
          if ((
#line 1605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1495; /* *icmp_and_br_signed_di */
            }
          break;

        case 1:
          if (
#line 1605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            {
              *pnum_clobbers = 1;
              return 1496; /* *icmp_and_br_signed_si */
            }
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  switch (pattern171 (x2))
    {
    case 0:
      if (!(
#line 1547 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1491; /* *cmp_and_br_signed_di */

    case 1:
      if (!
#line 1547 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
        return -1;
      *pnum_clobbers = 1;
      return 1492; /* *cmp_and_br_signed_si */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if ((
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1580; /* *extzvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1581; /* *extzvdi_clobbercc */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return 1582; /* *extzvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4115 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      *pnum_clobbers = 1;
      return 1583; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern173 (x2, 
E_V16QImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 114; /* vec_andcv16qi3 */

        case E_V8HImode:
          if (pattern173 (x2, 
E_V8HImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 115; /* vec_andcv8hi3 */

        case E_V4SImode:
          if (pattern173 (x2, 
E_V4SImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 116; /* vec_andcv4si3 */

        case E_V2DImode:
          if (pattern173 (x2, 
E_V2DImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 117; /* vec_andcv2di3 */

        case E_V2DFmode:
          if (pattern173 (x2, 
E_V2DFmode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 118; /* vec_andcv2df3 */

        case E_V1TImode:
          if (pattern173 (x2, 
E_V1TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 119; /* vec_andcv1ti3 */

        case E_TImode:
          if (pattern173 (x2, 
E_TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 120; /* vec_andcti3 */

        case E_V4SFmode:
          if (pattern173 (x2, 
E_V4SFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 121; /* vec_andcv4sf3 */

        case E_V1TFmode:
          if (pattern173 (x2, 
E_V1TFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 122; /* vec_andcv1tf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern3 (x2, 
E_V1QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 652; /* andv1qi3 */

            case E_V2QImode:
              if (pattern3 (x2, 
E_V2QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 653; /* andv2qi3 */

            case E_V4QImode:
              if (pattern3 (x2, 
E_V4QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 654; /* andv4qi3 */

            case E_V8QImode:
              if (pattern3 (x2, 
E_V8QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 655; /* andv8qi3 */

            case E_V16QImode:
              if (pattern3 (x2, 
E_V16QImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 656; /* andv16qi3 */

            case E_V1HImode:
              if (pattern3 (x2, 
E_V1HImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 657; /* andv1hi3 */

            case E_V2HImode:
              if (pattern3 (x2, 
E_V2HImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 658; /* andv2hi3 */

            case E_V4HImode:
              if (pattern3 (x2, 
E_V4HImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 659; /* andv4hi3 */

            case E_V8HImode:
              if (pattern3 (x2, 
E_V8HImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 660; /* andv8hi3 */

            case E_V1SImode:
              if (pattern3 (x2, 
E_V1SImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 661; /* andv1si3 */

            case E_V2SImode:
              if (pattern3 (x2, 
E_V2SImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 662; /* andv2si3 */

            case E_V4SImode:
              if (pattern3 (x2, 
E_V4SImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 663; /* andv4si3 */

            case E_V1DImode:
              if (pattern3 (x2, 
E_V1DImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 664; /* andv1di3 */

            case E_V2DImode:
              if (pattern3 (x2, 
E_V2DImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 665; /* andv2di3 */

            case E_V1SFmode:
              if (pattern3 (x2, 
E_V1SFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 666; /* andv1sf3 */

            case E_V2SFmode:
              if (pattern3 (x2, 
E_V2SFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 667; /* andv2sf3 */

            case E_V4SFmode:
              if (pattern3 (x2, 
E_V4SFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 668; /* andv4sf3 */

            case E_V1DFmode:
              if (pattern3 (x2, 
E_V1DFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 669; /* andv1df3 */

            case E_V2DFmode:
              if (pattern3 (x2, 
E_V2DFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 670; /* andv2df3 */

            case E_V1TFmode:
              if (pattern3 (x2, 
E_V1TFmode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 671; /* andv1tf3 */

            case E_V1TImode:
              if (pattern3 (x2, 
E_V1TImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 672; /* andv1ti3 */

            case E_TImode:
              if (pattern3 (x2, 
E_TImode) != 0
                  || !
#line 1184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 673; /* andti3 */

            case E_HImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 7856 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2011; /* *andhi3_zarch */
                }
              if (!
#line 7873 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2012; /* *andhi3_esa */

            case E_QImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 7901 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2013; /* *andqi3_zarch */
                }
              if (!
#line 7918 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2014; /* *andqi3_esa */

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (pnum_clobbers == NULL
              || pattern141 (x1) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_DImode)
              || !rtx_equal_p (x3, operands[0])
              || !
#line 4628 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
            return -1;
          *pnum_clobbers = 1;
          return 1658; /* *insv_rnsbg_noshift */

        default:
          return -1;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != GE)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern221 (x2, 
E_V1SImode, 
E_V1SFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1219; /* *vec_cmpeqv1sf_signaling_nocc */

        case E_V2SImode:
          if (pattern221 (x2, 
E_V2SImode, 
E_V2SFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1220; /* *vec_cmpeqv2sf_signaling_nocc */

        case E_V4SImode:
          if (pattern221 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1221; /* *vec_cmpeqv4sf_signaling_nocc */

        case E_V1DImode:
          if (pattern221 (x2, 
E_V1DImode, 
E_V1DFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1222; /* *vec_cmpeqv1df_signaling_nocc */

        case E_V2DImode:
          if (pattern221 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1223; /* *vec_cmpeqv2df_signaling_nocc */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x2) != E_V1TImode
              || GET_MODE (x3) != E_V1TImode
              || GET_MODE (x6) != E_V1TImode)
            return -1;
          switch (pattern166 ())
            {
            case 0:
              if (!
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
                return -1;
              return 1224; /* *vec_cmpeqv1tf_signaling_nocc */

            case 1:
              if (!
#line 2101 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
                return -1;
              return 1225; /* *vec_cmpeqtf_signaling_nocc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || pattern141 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !
#line 4645 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
        return -1;
      *pnum_clobbers = 1;
      return 1659; /* *insv_rnsbg_srl */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      return recog_19 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_20 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 696; /* iorv1qi3 */
          break;

        case 1:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 697; /* iorv2qi3 */
          break;

        case 2:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 698; /* iorv4qi3 */
          break;

        case 3:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 699; /* iorv8qi3 */
          break;

        case 4:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 700; /* iorv16qi3 */
          break;

        case 5:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 701; /* iorv1hi3 */
          break;

        case 6:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 702; /* iorv2hi3 */
          break;

        case 7:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 703; /* iorv4hi3 */
          break;

        case 8:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 704; /* iorv8hi3 */
          break;

        case 9:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 705; /* iorv1si3 */
          break;

        case 10:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 706; /* iorv2si3 */
          break;

        case 11:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 707; /* iorv4si3 */
          break;

        case 12:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 708; /* iorv1di3 */
          break;

        case 13:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 709; /* iorv2di3 */
          break;

        case 14:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 710; /* iorv1sf3 */
          break;

        case 15:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 711; /* iorv2sf3 */
          break;

        case 16:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 712; /* iorv4sf3 */
          break;

        case 17:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 713; /* iorv1df3 */
          break;

        case 18:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 714; /* iorv2df3 */
          break;

        case 19:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 715; /* iorv1tf3 */
          break;

        case 20:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 716; /* iorv1ti3 */
          break;

        case 21:
          if (
#line 1204 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 717; /* iorti3 */
          break;

        case 22:
          if (
#line 8073 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2020; /* *iordi3 */
            }
          break;

        case 23:
          if (
#line 8210 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2025; /* *iorhi3_zarch */
            }
          if (
#line 8226 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2026; /* *iorhi3_esa */
            }
          break;

        case 24:
          if (
#line 8253 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2027; /* *iorqi3_zarch */
            }
          if (
#line 8271 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2028; /* *iorqi3_esa */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern129 (x3) == 0
          && 
#line 4587 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1656; /* *rosbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (
#line 8154 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        {
          *pnum_clobbers = 1;
          return 2023; /* *iorsi3_zarch */
        }
      if (!
#line 8182 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2024; /* *iorsi3_esa */

    case ASHIFT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern29 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1648; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 1650; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case MOD:
              if (pattern130 (x3, 
DIV) != 0
                  || pattern201 (x3) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[2] = x11;
                  if (!general_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (!rtx_equal_p (x12, operands[2])
                      || !
#line 7373 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 1985; /* divmodtidi3 */

                case SIGN_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (GET_CODE (x12) != SIGN_EXTEND
                      || GET_MODE (x12) != E_DImode)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[2] = x13;
                  if (!nonimmediate_operand (operands[2], E_SImode))
                    return -1;
                  x14 = XEXP (x12, 0);
                  if (!rtx_equal_p (x14, operands[2])
                      || !
#line 7391 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 1986; /* divmodtisi3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != TRUNCATE)
                return -1;
              x15 = XEXP (x8, 0);
              switch (GET_CODE (x15))
                {
                case UMOD:
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != ZERO_EXTEND)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != UDIV)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != ZERO_EXTEND)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2]))
                    return -1;
                  switch (XWINT (x7, 0))
                    {
                    case 64L:
                      if (pattern267 (x3, 
E_TImode, 
E_DImode) != 0
                          || !
#line 7452 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 1987; /* udivmodtidi3 */

                    case 32L:
                      if (pattern267 (x3, 
E_DImode, 
E_SImode) != 0
                          || !
#line 7572 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                        return -1;
                      return 1989; /* udivmoddisi3 */

                    default:
                      return -1;
                    }

                case MOD:
                  if (GET_MODE (x15) != E_DImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != SIGN_EXTEND
                      || GET_MODE (x16) != E_DImode
                      || XWINT (x7, 0) != 32L)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != DIV
                      || GET_MODE (x10) != E_DImode)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != SIGN_EXTEND
                      || GET_MODE (x17) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode
                      || GET_MODE (x6) != E_DImode
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  if (!nonimmediate_operand (operands[2], E_SImode)
                      || GET_MODE (x5) != E_DImode
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2])
                      || !
#line 7511 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return -1;
                  return 1988; /* divmoddisi3 */

                default:
                  return -1;
                }

            case CLZ:
              if (pnum_clobbers == NULL
                  || pattern130 (x3, 
XOR) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != LSHIFTRT)
                return -1;
              x22 = XEXP (x12, 1);
              if (GET_CODE (x22) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x22), 4)
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XEXP (x22, 0);
              if (GET_CODE (x23) != CLZ
                  || GET_MODE (x23) != E_DImode
                  || pattern201 (x3) != 0)
                return -1;
              x14 = XEXP (x12, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x24 = XEXP (x23, 0);
              if (!rtx_equal_p (x24, operands[1])
                  || !
#line 9297 "../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2155; /* clztidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern29 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1652; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1654; /* *rosbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern33 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 634; /* absv1qi2 */

        case 1:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 635; /* absv2qi2 */

        case 2:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 636; /* absv4qi2 */

        case 3:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 637; /* absv8qi2 */

        case 4:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 638; /* absv16qi2 */

        case 5:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 639; /* absv1hi2 */

        case 6:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 640; /* absv2hi2 */

        case 7:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 641; /* absv4hi2 */

        case 8:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 642; /* absv8hi2 */

        case 9:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 643; /* absv1si2 */

        case 10:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 644; /* absv2si2 */

        case 11:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 645; /* absv4si2 */

        case 12:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 646; /* absv1di2 */

        case 13:
          if (!
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 647; /* absv2di2 */

        case 14:
          if (!(
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1126; /* absv1sf2 */

        case 15:
          if (!(
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1127; /* absv2sf2 */

        case 16:
          if (!(
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1128; /* absv4sf2 */

        case 17:
          if (!
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1129; /* absv1df2 */

        case 18:
          if (!
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1130; /* absv2df2 */

        case 19:
          if (!(
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1131; /* absv1tf2 */

        case 20:
          if ((
#line 1819 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1132; /* abstf2_vr */
          if ((
#line 9084 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2115; /* *abstf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9095 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2121; /* *abstf2 */

        case 21:
          if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2105; /* absdi2 */

        case 22:
          *pnum_clobbers = 1;
          return 2106; /* abssi2 */

        case 23:
          if ((
#line 9084 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2116; /* *absfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9095 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2122; /* *absfprx22 */

        case 24:
          if (
#line 9084 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2117; /* *absdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9095 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2123; /* *absdf2 */

        case 25:
          if (
#line 9084 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2118; /* *abssf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9095 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2124; /* *abssf2 */

        case 26:
          if (!(
#line 9084 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2119; /* *abstd2_nocc */

        case 27:
          if (!(
#line 9084 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2120; /* *absdd2_nocc */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 9007 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2100; /* *absdi2_sign */

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (pattern251 (x10, 
ZERO_EXTEND, 
PLUS) != 0)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x10, 0);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[1])
              || !
#line 5894 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 1850; /* *adddi3_zero_cc */

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!scratch_operand (operands[0], E_DImode)
              || !
#line 5907 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 1851; /* *adddi3_zero_cconly */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_74 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && scratch_operand (operands[0], E_DImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 6033 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1859; /* *adddi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 6073 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1863; /* *adddi3_carry2_cconly */
                }
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && scratch_operand (operands[0], E_SImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 6033 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 1860; /* *addsi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 6073 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 1864; /* *addsi3_carry2_cconly */
                }
              break;

            case E_TFmode:
              x6 = XEXP (x3, 1);
              if (pattern224 (x6, 
E_TFmode) == 0
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 1890; /* *addtf3_cconly */
              break;

            case E_FPRX2mode:
              x6 = XEXP (x3, 1);
              if (pattern224 (x6, 
E_FPRX2mode) == 0
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 1891; /* *addfprx23_cconly */
              break;

            case E_DFmode:
              x6 = XEXP (x3, 1);
              if (pattern224 (x6, 
E_DFmode) == 0
                  && 
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 1892; /* *adddf3_cconly */
              break;

            case E_SFmode:
              x6 = XEXP (x3, 1);
              if (pattern224 (x6, 
E_SFmode) == 0
                  && 
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 1893; /* *addsf3_cconly */
              break;

            case E_TDmode:
              x6 = XEXP (x3, 1);
              if (pattern224 (x6, 
E_TDmode) == 0
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 1894; /* *addtd3_cconly */
              break;

            case E_DDmode:
              x6 = XEXP (x3, 1);
              if (pattern224 (x6, 
E_DDmode) == 0
                  && (
#line 6294 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 1895; /* *adddd3_cconly */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x10) != E_DImode)
                return -1;
              if (general_operand (operands[2], E_DImode)
                  && (
#line 6091 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1865; /* *adddi3_cc */
              if (!const_int_operand (operands[2], E_DImode)
                  || !(
#line 6147 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1871; /* *adddi3_imm_cc */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x10) != E_SImode)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6091 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return 1866; /* *addsi3_cc */
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 6147 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))))
                return -1;
              return 1872; /* *addsi3_imm_cc */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern146 (x1))
            {
            case 0:
              if (!(
#line 6113 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1867; /* *adddi3_cconly */

            case 1:
              if (!
#line 6113 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 1868; /* *addsi3_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x6, 0);
      if (GET_CODE (x15) != PLUS)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x17 = XEXP (x8, 0);
          operands[2] = x17;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern279 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6214 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1874; /* *addvdi3_ccoverflow */

            case E_DImode:
              if (pattern279 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6214 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 1875; /* *addvsi3_ccoverflow */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x8;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern280 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6237 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1876; /* *addvdi3_ccoverflow_const */

            case E_DImode:
              if (pattern280 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6237 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 1877; /* *addvsi3_ccoverflow_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          switch (pattern212 (x1))
            {
            case 0:
              x6 = XEXP (x3, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 6772 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1938; /* *adddi3_alc_carry1_cc */
              if (rtx_equal_p (x6, operands[2])
                  && (
#line 6807 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1942; /* *adddi3_alc_carry2_cc */
              break;

            case 1:
              x6 = XEXP (x3, 1);
              if (rtx_equal_p (x6, operands[1])
                  && 
#line 6772 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                return 1939; /* *addsi3_alc_carry1_cc */
              if (rtx_equal_p (x6, operands[2])
                  && 
#line 6807 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                return 1943; /* *addsi3_alc_carry2_cc */
              break;

            default:
              break;
            }
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern237 (x5, 
E_DImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 6788 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1940; /* *adddi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 6822 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1944; /* *adddi3_alc_carry2_cconly */
                }
              break;

            case E_SImode:
              if (pattern237 (x5, 
E_SImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 6788 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 1941; /* *addsi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 6822 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 1945; /* *addsi3_alc_carry2_cconly */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_CODE (x9) != SET)
        return -1;
      switch (pattern212 (x1))
        {
        case 0:
          if (!(
#line 6838 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1946; /* *adddi3_alc_cc */

        case 1:
          if (!
#line 6838 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          return 1947; /* *addsi3_alc_cc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1)
    return -1;
  switch (GET_MODE (x3))
    {
    case E_DImode:
      if (!(
#line 10707 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 2232; /* *basr_r_via_thunk */

    case E_SImode:
      if (!(
#line 10707 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 2233; /* *basr_r_via_thunk */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x3))
        {
        case CLOBBER:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != COMPARE
              || GET_MODE (x5) != E_CCUmode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCUmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern96 (x9, 
E_SImode, 
0, 
USE) != 0)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          x13 = XEXP (x7, 0);
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern287 (
E_DImode) != 0
                  || !
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1542; /* *cmpstrdi */

            case E_SImode:
              if (pattern287 (
E_SImode) != 0
                  || !
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1543; /* *cmpstrsi */

            default:
              return -1;
            }

        case SET:
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern96 (x9, 
E_CCmode, 
33, 
CLOBBER) != 0)
            return -1;
          switch (pattern123 (x1))
            {
            case 0:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1544; /* *movstr */

            case 1:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1545; /* *movstr */

            case 2:
              if (!(
#line 3753 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1562; /* *setmem_long */

            case 3:
              if (!(
#line 3753 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1563; /* *setmem_long */

            case 4:
              if (!
#line 3781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1566; /* *setmem_long_31z */

            case 5:
              if (!(
#line 3766 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1564; /* *setmem_long_and */

            case 6:
              if (!(
#line 3766 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1565; /* *setmem_long_and */

            case 7:
              if (!
#line 3793 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
                return -1;
              return 1567; /* *setmem_long_and_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x9 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x14 = XEXP (x2, 1);
      switch (GET_CODE (x14))
        {
        case SUBREG:
        case MEM:
          if (pattern74 (x1) != 0)
            return -1;
          switch (pattern193 (x1))
            {
            case 0:
              if (!(
#line 3392 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1546; /* *cpymem_short */

            case 1:
              if (!(
#line 3392 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1547; /* *cpymem_short */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern73 (x1) != 0)
            return -1;
          switch (pattern193 (x1))
            {
            case 0:
              if (!(
#line 3838 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1568; /* *cmpmem_short */

            case 1:
              if (!(
#line 3838 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1569; /* *cmpmem_short */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1800; /* *trunctftd2 */

            case 1:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1801; /* *truncfprx2td2 */

            case 2:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1802; /* *truncdftd2 */

            case 3:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1803; /* *truncsftd2 */

            case 4:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1804; /* *trunctfdd2 */

            case 5:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1805; /* *truncfprx2dd2 */

            case 6:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1806; /* *truncdfdd2 */

            case 7:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1807; /* *truncsfdd2 */

            case 8:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1808; /* *trunctfsd2 */

            case 9:
              if (!(
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1809; /* *truncfprx2sd2 */

            case 10:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1810; /* *truncdfsd2 */

            case 11:
              if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1811; /* *truncsfsd2 */

            case 12:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1812; /* *trunctdtf2 */

            case 13:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1816; /* *truncddtf2 */

            case 14:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1820; /* *truncsdtf2 */

            case 15:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1813; /* *trunctdfprx22 */

            case 16:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1817; /* *truncddfprx22 */

            case 17:
              if (!(
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1821; /* *truncsdfprx22 */

            case 18:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1814; /* *trunctddf2 */

            case 19:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1818; /* *truncdddf2 */

            case 20:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1822; /* *truncsddf2 */

            case 21:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1815; /* *trunctdsf2 */

            case 22:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1819; /* *truncddsf2 */

            case 23:
              if (!
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1823; /* *truncsdsf2 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1824; /* *extendtftd2 */

            case 1:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1825; /* *extendfprx2td2 */

            case 2:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1826; /* *extenddftd2 */

            case 3:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1827; /* *extendsftd2 */

            case 4:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1828; /* *extendtfdd2 */

            case 5:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1829; /* *extendfprx2dd2 */

            case 6:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1830; /* *extenddfdd2 */

            case 7:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1831; /* *extendsfdd2 */

            case 8:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1832; /* *extendtfsd2 */

            case 9:
              if (!(
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1833; /* *extendfprx2sd2 */

            case 10:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1834; /* *extenddfsd2 */

            case 11:
              if (!
#line 5736 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1835; /* *extendsfsd2 */

            case 12:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1836; /* *extendtdtf2 */

            case 13:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1840; /* *extendddtf2 */

            case 14:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1844; /* *extendsdtf2 */

            case 15:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1837; /* *extendtdfprx22 */

            case 16:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1841; /* *extendddfprx22 */

            case 17:
              if (!(
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1845; /* *extendsdfprx22 */

            case 18:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1838; /* *extendtddf2 */

            case 19:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1842; /* *extenddddf2 */

            case 20:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1846; /* *extendsddf2 */

            case 21:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1839; /* *extendtdsf2 */

            case 22:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1843; /* *extendddsf2 */

            case 23:
              if (!
#line 5744 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 1847; /* *extendsdsf2 */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 9729 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2189; /* *brxg_64bit */

            case 1:
              if (!
#line 9815 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2191; /* *brx_31bit */

            case 2:
              if (!
#line 9772 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2190; /* *brx_64bit */

            case 3:
              return 2192; /* doloop_si64 */

            case 4:
              if (!
#line 9913 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2193; /* doloop_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x2;
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (nonimmediate_operand (operands[0], E_TFmode))
            {
              if (GET_CODE (x2) == SUBREG
                  && known_eq (SUBREG_BYTE (x2), 0)
                  && GET_MODE (x2) == E_TFmode)
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (general_operand (operands[1], E_FPRX2mode)
                      && 
#line 665 "../../gcc/config/s390/vector.md"
(!(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))))
                    return gen_split_37 (insn, operands);
                }
              operands[1] = x2;
              if (general_operand (operands[1], E_TFmode))
                {
                  if ((
#line 2627 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return gen_split_155 (insn, operands);
                  if ((
#line 2643 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return gen_split_158 (insn, operands);
                }
            }
          operands[1] = x2;
          if (memory_operand (operands[1], E_TFmode)
              && register_operand (operands[0], E_TFmode))
            {
              if ((
#line 2659 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_161 (insn, operands);
              if ((
#line 2675 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_164 (insn, operands);
            }
          if (!register_operand (operands[1], E_TFmode)
              || !memory_operand (operands[0], E_TFmode)
              || !(
#line 2691 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return NULL;
          return gen_split_167 (insn, operands);

        case VEC_DUPLICATE:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_38 (insn, operands);

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_39 (insn, operands);

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x2) != E_V4SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_40 (insn, operands);

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_41 (insn, operands);

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x2) != E_V2DImode
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_42 (insn, operands);

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
                return NULL;
              return gen_split_43 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          if (pattern8 (x1) != 0
              || !(
#line 1857 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 1859 "../../gcc/config/s390/vector.md"
( 1)))
            return NULL;
          return gen_split_48 (insn, operands);

        case SMIN:
          if (pattern8 (x1) != 0
              || !(
#line 1893 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 1895 "../../gcc/config/s390/vector.md"
( 1)))
            return NULL;
          return gen_split_49 (insn, operands);

        case IF_THEN_ELSE:
          return split_3 (x1, insn);

        case COMPARE:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 33)
            return NULL;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_VOIDmode))
            return NULL;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!memory_operand (operands[1], E_VOIDmode)
              || !
#line 1412 "../../gcc/config/s390/s390.md"
(reload_completed
   && s390_match_ccmode (insn, CCUmode)
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
            return NULL;
          return gen_split_141 (insn, operands);

        case UNSPEC:
          if (XVECLEN (x2, 0) != 1)
            return NULL;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x6 = XVECEXP (x2, 0, 0);
          operands[1] = x6;
          switch (XINT (x2, 1))
            {
            case 30:
              switch (pattern80 (x2))
                {
                case 0:
                  if (!
#line 1969 "../../gcc/config/s390/s390.md"
( reload_completed))
                    return NULL;
                  return gen_split_146 (insn, operands);

                case 1:
                  if (!(
#line 1976 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 1978 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return NULL;
                  return gen_split_147 (insn, operands);

                default:
                  return NULL;
                }

            case 5:
              if (GET_MODE (x2) != E_SImode
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 3587 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_181 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != LSHIFTRT)
            return NULL;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != ASHIFT)
            return NULL;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          x10 = XEXP (x5, 1);
          operands[4] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern181 (x2, 
E_DImode) != 0
                  || !(
#line 4426 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return NULL;
              return gen_split_198 (insn, operands);

            case E_SImode:
              if (pattern181 (x2, 
E_SImode) != 0
                  || !
#line 4426 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
                return NULL;
              return gen_split_199 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!memory_operand (operands[1], E_QImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !(
#line 5077 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5079 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return NULL;
              return gen_split_208 (insn, operands);

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !(
#line 5109 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5111 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return NULL;
              return gen_split_209 (insn, operands);

            default:
              return NULL;
            }

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_CODE (x2))
            {
            case EQ:
              switch (GET_MODE (operands[0]))
                {
                case E_V1TImode:
                  if (pattern3 (x2, 
E_V1TImode) == 0
                      && (
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1963 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_50 (insn, operands);
                  break;

                case E_TImode:
                  if (pattern3 (x2, 
E_TImode) == 0
                      && (
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1963 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_51 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case GT:
              switch (GET_MODE (operands[0]))
                {
                case E_V1TImode:
                  if (pattern3 (x2, 
E_V1TImode) == 0
                      && (
#line 1983 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1985 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_52 (insn, operands);
                  break;

                case E_TImode:
                  if (pattern3 (x2, 
E_TImode) == 0
                      && (
#line 1983 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1985 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_53 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case GTU:
              switch (GET_MODE (operands[0]))
                {
                case E_V1TImode:
                  if (pattern3 (x2, 
E_V1TImode) == 0
                      && (
#line 2017 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2019 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_54 (insn, operands);
                  break;

                case E_TImode:
                  if (pattern3 (x2, 
E_TImode) == 0
                      && (
#line 2017 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2019 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                    return gen_split_55 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          operands[1] = x2;
          switch (pattern45 (x2))
            {
            case 0:
              if (!(
#line 6994 "../../gcc/config/s390/s390.md"
(reload_completed) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return NULL;
              return gen_split_219 (insn, operands);

            case 1:
              if (!
#line 6994 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_220 (insn, operands);

            default:
              return NULL;
            }

        case NOT:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !
#line 702 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return NULL;
              return gen_split_231 (insn, operands);

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !nonimmediate_operand (operands[1], E_SImode))
                return NULL;
              return gen_split_232 (insn, operands);

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode))
                return NULL;
              return gen_split_233 (insn, operands);

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode))
                return NULL;
              return gen_split_234 (insn, operands);

            default:
              return NULL;
            }

        case BSWAP:
          if (GET_MODE (x2) != E_HImode)
            return NULL;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_HImode))
            return NULL;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_HImode))
            return NULL;
          return gen_split_248 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_4 (x1, insn);

        case 3:
          x11 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x11) != SET)
            return NULL;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != CLOBBER)
            return NULL;
          x13 = XEXP (x11, 1);
          switch (GET_CODE (x13))
            {
            case VEC_SELECT:
              if (GET_MODE (x13) != E_V8HImode)
                return NULL;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != PARALLEL
                  || XVECLEN (x14, 0) != 8)
                return NULL;
              x15 = XVECEXP (x14, 0, 0);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return NULL;
              x16 = XVECEXP (x14, 0, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
                return NULL;
              x17 = XVECEXP (x14, 0, 2);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
                return NULL;
              x18 = XVECEXP (x14, 0, 3);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x19 = XVECEXP (x14, 0, 4);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              x20 = XVECEXP (x14, 0, 5);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return NULL;
              x21 = XVECEXP (x14, 0, 6);
              if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x22 = XVECEXP (x14, 0, 7);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x23 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x23) != CLOBBER
                  || pattern264 (x1) != 0
                  || !(
#line 1021 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1026 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
                return NULL;
              return gen_split_45 (insn, operands);

            case IF_THEN_ELSE:
              x24 = XEXP (x13, 0);
              if (!s390_brx_operator (x24, E_VOIDmode))
                return NULL;
              operands[6] = x24;
              x25 = XEXP (x24, 0);
              if (GET_CODE (x25) != PLUS)
                return NULL;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != LABEL_REF)
                return NULL;
              x26 = XEXP (x13, 2);
              if (GET_CODE (x26) != PC)
                return NULL;
              x27 = XEXP (x11, 0);
              if (GET_CODE (x27) != PC)
                return NULL;
              x23 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x23) != SET)
                return NULL;
              x28 = XEXP (x23, 1);
              if (GET_CODE (x28) != PLUS)
                return NULL;
              switch (pattern230 (x1))
                {
                case 0:
                  if (!(
#line 9691 "../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return NULL;
                  return gen_split_241 (insn, operands);

                case 1:
                  if (!
#line 9691 "../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress))
                    return NULL;
                  return gen_split_242 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 4:
          x11 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x11) != SET)
            return NULL;
          x29 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x29) != CLOBBER)
            return NULL;
          x13 = XEXP (x11, 1);
          switch (GET_CODE (x13))
            {
            case SUBREG:
            case MEM:
              if (pattern74 (x1) != 0)
                return NULL;
              switch (pattern195 (x1))
                {
                case 0:
                  if (!
#line 3403 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_177 (insn, operands);

                case 1:
                  if (!
#line 3415 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_178 (insn, operands);

                case 2:
                  if (!
#line 3429 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return NULL;
                  return gen_split_179 (insn, operands);

                case 3:
                  if (!
#line 3443 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_180 (insn, operands);

                default:
                  return NULL;
                }

            case COMPARE:
              if (pattern73 (x1) != 0)
                return NULL;
              switch (pattern195 (x1))
                {
                case 0:
                  if (!
#line 3850 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_186 (insn, operands);

                case 1:
                  if (!
#line 3863 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_187 (insn, operands);

                case 2:
                  if (!
#line 3878 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return NULL;
                  return gen_split_188 (insn, operands);

                case 3:
                  if (!
#line 3893 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_189 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              switch (pattern78 (x1))
                {
                case 0:
                  if (!(
#line 9729 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 9738 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_243 (insn, operands);

                case 1:
                  if (!(
#line 9815 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 9824 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_245 (insn, operands);

                case 2:
                  if (!(
#line 9772 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 9781 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_244 (insn, operands);

                case 3:
                  if (!
#line 9880 "../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2]))))
                    return NULL;
                  return gen_split_246 (insn, operands);

                case 4:
                  if (!(
#line 9913 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 9922 "../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2])))))
                    return NULL;
                  return gen_split_247 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x11 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x11) != SET)
            return NULL;
          x13 = XEXP (x11, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x23 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x23) != USE)
            return NULL;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != USE
              || pattern102 (x1) != 0)
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case CONST_INT:
              if (!const_int_operand (operands[1], E_VOIDmode))
                return NULL;
              x29 = XVECEXP (x1, 0, 3);
              x30 = XEXP (x29, 0);
              if (GET_CODE (x30) != SCRATCH)
                return NULL;
              x31 = XEXP (x12, 0);
              operands[2] = x31;
              if (!immediate_operand (operands[2], E_VOIDmode)
                  || !
#line 3656 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_182 (insn, operands);

            case REG:
            case SUBREG:
              if (!register_operand (operands[1], E_VOIDmode))
                return NULL;
              x31 = XEXP (x12, 0);
              switch (GET_CODE (x31))
                {
                case SUBREG:
                case MEM:
                  operands[2] = x31;
                  if (!memory_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x29 = XVECEXP (x1, 0, 3);
                  x30 = XEXP (x29, 0);
                  if (GET_CODE (x30) != SCRATCH
                      || !
#line 3670 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_183 (insn, operands);

                case CONST:
                  if (GET_MODE (x31) != E_BLKmode)
                    return NULL;
                  x32 = XEXP (x31, 0);
                  if (GET_CODE (x32) != UNSPEC
                      || XVECLEN (x32, 0) != 1
                      || XINT (x32, 1) != 17
                      || GET_MODE (x32) != E_BLKmode)
                    return NULL;
                  x33 = XVECEXP (x32, 0, 0);
                  if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return NULL;
                  x29 = XVECEXP (x1, 0, 3);
                  x30 = XEXP (x29, 0);
                  switch (GET_CODE (x30))
                    {
                    case SCRATCH:
                      if (!
#line 3686 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                        return NULL;
                      return gen_split_184 (insn, operands);

                    case REG:
                    case SUBREG:
                      operands[2] = x30;
                      if (!register_operand (operands[2], E_VOIDmode)
                          || !
#line 3702 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return NULL;
                      return gen_split_185 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
