/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern14 (x3, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern14 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern14 (x3, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern28 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern28 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x1) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 14;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 15;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 16;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x1) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 17;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 18;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 19;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 20;

    case E_DImode:
      if (pattern32 (x1, pnum_clobbers, 
E_DImode) != 0)
        return -1;
      return 21;

    case E_SImode:
      if (pattern32 (x1, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      return 22;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 23;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 24;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 25;

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || GET_MODE (x1) != E_TDmode
          || !register_operand (operands[1], E_TDmode))
        return -1;
      return 26;

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x1) != E_DDmode
          || !register_operand (operands[1], E_DDmode))
        return -1;
      return 27;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return 0;
}

int
pattern114 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1)
      || !setmem_operand (operands[2], i3)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern126 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !const0_operand (operands[2], E_TFmode))
        return -1;
      return 0;

    case E_FPRX2mode:
      if (!register_operand (operands[1], E_FPRX2mode)
          || !const0_operand (operands[2], E_FPRX2mode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !const0_operand (operands[2], E_DFmode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !const0_operand (operands[2], E_SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i1)
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  x8 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      return pattern142 (x6, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern142 (x6, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern142 (x6, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          return 0;

        case E_V2QImode:
          return 1;

        case E_V4QImode:
          return 2;

        case E_V8QImode:
          return 3;

        case E_V16QImode:
          return 4;

        default:
          return -1;
        }

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          return 5;

        case E_V2HImode:
          return 6;

        case E_V4HImode:
          return 7;

        case E_V8HImode:
          return 8;

        default:
          return -1;
        }

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          return 9;

        case E_V2SImode:
          return 10;

        case E_V4SImode:
          return 11;

        default:
          return -1;
        }

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1DImode:
          return 12;

        case E_V2DImode:
          return 13;

        default:
          return -1;
        }

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SFmode:
          return 14;

        case E_V2SFmode:
          return 15;

        case E_V4SFmode:
          return 16;

        default:
          return -1;
        }

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1DFmode:
          return 17;

        case E_V2DFmode:
          return 18;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern186 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 4
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_CCUmode))
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern250 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || GET_MODE (x1) != i2)
    return -1;
  return 0;
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !nonsym_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern282 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || pattern281 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern288 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (1));
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x10) != E_BLKmode)
    return -1;
  x11 = XEXP (x9, 0);
  operands[3] = x11;
  x12 = XEXP (x10, 1);
  operands[4] = x12;
  if (!memory_operand (operands[4], E_BLKmode))
    return -1;
  x13 = XVECEXP (x8, 0, 1);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern27 (x1))
    {
    case 0:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1047; /* vec_widen_umult_even_v1qi */

    case 1:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1048; /* vec_widen_umult_even_v2qi */

    case 2:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1049; /* vec_widen_umult_even_v4qi */

    case 3:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1050; /* vec_widen_umult_even_v8qi */

    case 4:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1051; /* vec_widen_umult_even_v16qi */

    case 5:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1052; /* vec_widen_umult_even_v1hi */

    case 6:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1053; /* vec_widen_umult_even_v2hi */

    case 7:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1054; /* vec_widen_umult_even_v4hi */

    case 8:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1055; /* vec_widen_umult_even_v8hi */

    case 9:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1056; /* vec_widen_umult_even_v1si */

    case 10:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1057; /* vec_widen_umult_even_v2si */

    case 11:
      if (!
#line 1560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1058; /* vec_widen_umult_even_v4si */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 71:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern17 (x3, 
E_V8HImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 33; /* vec_zpermv8hi */

        case E_V4SImode:
          if (pattern17 (x3, 
E_V4SImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 34; /* vec_zpermv4si */

        case E_V4SFmode:
          if (pattern17 (x3, 
E_V4SFmode) != 0
              || !(
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 35; /* vec_zpermv4sf */

        case E_V2DImode:
          if (pattern17 (x3, 
E_V2DImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 36; /* vec_zpermv2di */

        case E_V2DFmode:
          if (pattern17 (x3, 
E_V2DFmode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 37; /* vec_zpermv2df */

        case E_V16QImode:
          if (pattern17 (x3, 
E_V16QImode) != 0
              || !
#line 746 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 539; /* vec_permv16qi */

        default:
          return -1;
        }

    case 81:
      if (pattern50 (x3) != 0
          || !
#line 677 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 112; /* vacq */

    case 82:
      if (pattern50 (x3) != 0
          || !
#line 690 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 113; /* vacccq */

    case 88:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 136; /* vec_gfmsum_accumv16qi */

        case 1:
          if (!
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 137; /* vec_gfmsum_accumv8hi */

        case 2:
          if (!
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 138; /* vec_gfmsum_accumv4si */

        default:
          return -1;
        }

    case 89:
      if (pattern53 (x3, 
E_V2DImode, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode)
          || !
#line 880 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 139; /* vec_gfmsum_accum_128 */

    case 52:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 140; /* vec_vmalv16qi */

        case 1:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 141; /* vec_vmalv8hi */

        case 2:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 142; /* vec_vmalv4si */

        default:
          return -1;
        }

    case 53:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 143; /* vec_vmahv16qi */

        case 1:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 144; /* vec_vmahv8hi */

        case 2:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 145; /* vec_vmahv4si */

        default:
          return -1;
        }

    case 54:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 146; /* vec_vmalhv16qi */

        case 1:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 147; /* vec_vmalhv8hi */

        case 2:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 148; /* vec_vmalhv4si */

        default:
          return -1;
        }

    case 55:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 149; /* vec_vmaev16qi */

        case 1:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 150; /* vec_vmaev8hi */

        case 2:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 151; /* vec_vmaev4si */

        default:
          return -1;
        }

    case 56:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 152; /* vec_vmalev16qi */

        case 1:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 153; /* vec_vmalev8hi */

        case 2:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 154; /* vec_vmalev4si */

        default:
          return -1;
        }

    case 57:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 155; /* vec_vmaov16qi */

        case 1:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 156; /* vec_vmaov8hi */

        case 2:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 157; /* vec_vmaov4si */

        default:
          return -1;
        }

    case 58:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 158; /* vec_vmalov16qi */

        case 1:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 159; /* vec_vmalov8hi */

        case 2:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 160; /* vec_vmalov4si */

        default:
          return -1;
        }

    case 97:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 192; /* vec_sldv16qi */

        case 1:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 193; /* vec_sldv8hi */

        case 2:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 194; /* vec_sldv4si */

        case 3:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 195; /* vec_sldv2di */

        case 4:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 196; /* vec_sldv1ti */

        case 5:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 197; /* vec_sldti */

        case 6:
          if (!
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 198; /* vec_sldv2df */

        case 7:
          if (!(
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 199; /* vec_sldv4sf */

        case 8:
          if (!(
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 200; /* vec_sldv1tf */

        case 9:
          if (!(
#line 1075 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 32 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 201; /* vec_sldtf */

        default:
          return -1;
        }

    case 98:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 202; /* vec_sldbv16qi */

        case 1:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 203; /* vec_sldbv8hi */

        case 2:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 204; /* vec_sldbv4si */

        case 3:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 205; /* vec_sldbv2di */

        case 4:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 206; /* vec_sldbv1ti */

        case 5:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 207; /* vec_sldbti */

        case 6:
          if (!
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 208; /* vec_sldbv2df */

        case 7:
          if (!(
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 209; /* vec_sldbv4sf */

        case 8:
          if (!(
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 210; /* vec_sldbv1tf */

        case 9:
          if (!(
#line 1098 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 32 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 211; /* vec_sldbtf */

        default:
          return -1;
        }

    case 99:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 212; /* vec_srdbv16qi */

        case 1:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 213; /* vec_srdbv8hi */

        case 2:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 214; /* vec_srdbv4si */

        case 3:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 215; /* vec_srdbv2di */

        case 4:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 216; /* vec_srdbv1ti */

        case 5:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 217; /* vec_srdbti */

        case 6:
          if (!
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 218; /* vec_srdbv2df */

        case 7:
          if (!(
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 219; /* vec_srdbv4sf */

        case 8:
          if (!(
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 220; /* vec_srdbv1tf */

        case 9:
          if (!(
#line 1110 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 32 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 221; /* vec_srdbtf */

        default:
          return -1;
        }

    case 105:
      if (pattern50 (x3) != 0
          || !
#line 1185 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 262; /* vsbiq */

    case 106:
      if (pattern50 (x3) != 0
          || !
#line 1198 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 263; /* vsbcbiq */

    case 108:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern17 (x3, 
E_V16QImode) != 0
              || !
#line 1290 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 278; /* vfaev16qi */

        case E_V8HImode:
          if (pattern17 (x3, 
E_V8HImode) != 0
              || !
#line 1290 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 279; /* vfaev8hi */

        case E_V4SImode:
          if (pattern17 (x3, 
E_V4SImode) != 0
              || !
#line 1290 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 280; /* vfaev4si */

        default:
          return -1;
        }

    case 110:
      switch (pattern57 (x3))
        {
        case 0:
          if (!
#line 1390 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 284; /* vfeev16qi */

        case 1:
          if (!
#line 1390 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 285; /* vfeev8hi */

        case 2:
          if (!
#line 1390 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 286; /* vfeev4si */

        case 3:
          if (!
#line 1401 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 287; /* vfeezv16qi */

        case 4:
          if (!
#line 1401 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 288; /* vfeezv8hi */

        case 5:
          if (!
#line 1401 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 289; /* vfeezv4si */

        default:
          return -1;
        }

    case 112:
      switch (pattern57 (x3))
        {
        case 0:
          if (!
#line 1449 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 290; /* vfenev16qi */

        case 1:
          if (!
#line 1449 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 291; /* vfenev8hi */

        case 2:
          if (!
#line 1449 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 292; /* vfenev4si */

        case 3:
          if (!
#line 1462 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 293; /* vfenezv16qi */

        case 4:
          if (!
#line 1462 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 294; /* vfenezv8hi */

        case 5:
          if (!
#line 1462 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 295; /* vfenezv4si */

        default:
          return -1;
        }

    case 120:
      if (pattern58 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1718 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 311; /* vcdgb */

    case 121:
      if (pattern58 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1750 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 312; /* vcdlgb */

    case 122:
      if (pattern58 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1781 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 313; /* vcgdb */

    case 123:
      if (pattern58 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1814 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 314; /* vclgdb */

    case 124:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_mask_operand (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 315; /* vec_fpintv1sf */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 316; /* vec_fpintv2sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 317; /* vec_fpintv4sf */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 318; /* vec_fpintv1df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 319; /* vec_fpintv2df */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 320; /* vec_fpintv1tf */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode)
              || !(
#line 1849 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 321; /* vec_fpinttf */

        default:
          return -1;
        }

    case 126:
      if (pattern58 (x3, 
E_V4SFmode, 
E_V2DFmode) != 0
          || !
#line 1895 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 323; /* vflrd */

    case 130:
      switch (pattern59 (x3))
        {
        case 0:
          if (!
#line 2152 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 380; /* vfminv4sf */

        case 1:
          if (!
#line 2152 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 381; /* vfminv2df */

        case 2:
          if (!
#line 2152 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 382; /* vfminv1tf */

        case 3:
          if (!
#line 2152 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 383; /* vfmintf */

        default:
          return -1;
        }

    case 131:
      switch (pattern59 (x3))
        {
        case 0:
          if (!
#line 2162 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 384; /* vfmaxv4sf */

        case 1:
          if (!
#line 2162 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 385; /* vfmaxv2df */

        case 2:
          if (!
#line 2162 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 386; /* vfmaxv1tf */

        case 3:
          if (!
#line 2162 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 387; /* vfmaxtf */

        default:
          return -1;
        }

    case 90:
      return recog_12 (x1, insn, pnum_clobbers);

    case 135:
      if (pattern53 (x3, 
E_V4SFmode, 
E_V8HImode) != 0)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode)
          || !
#line 2251 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 410; /* vcrnfs_v8hi */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (!general_operand (operands[1], E_FPRX2mode)
          || !nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !
#line 661 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 537; /* fprx2_to_tf */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 71
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_V16QImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern284 (x2, 
E_V16QImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 540; /* *vec_permv16qi */

        case E_V8HImode:
          if (pattern284 (x2, 
E_V8HImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 541; /* *vec_permv8hi */

        case E_V4SImode:
          if (pattern284 (x2, 
E_V4SImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 542; /* *vec_permv4si */

        case E_V2DImode:
          if (pattern284 (x2, 
E_V2DImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 543; /* *vec_permv2di */

        case E_V2DFmode:
          if (pattern284 (x2, 
E_V2DFmode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 544; /* *vec_permv2df */

        case E_V1TImode:
          if (pattern284 (x2, 
E_V1TImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 545; /* *vec_permv1ti */

        case E_TImode:
          if (pattern284 (x2, 
E_TImode) != 0
              || !
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 546; /* *vec_permti */

        case E_V4SFmode:
          if (pattern284 (x2, 
E_V4SFmode) != 0
              || !(
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 547; /* *vec_permv4sf */

        case E_V1TFmode:
          if (pattern284 (x2, 
E_V1TFmode) != 0
              || !(
#line 756 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 38 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 548; /* *vec_permv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ROTATE:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1592; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1593; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1598; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1599; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1594; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1595; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1600; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1601; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1596; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1597; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1602; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1603; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x4;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != CONST_INT
              || XWINT (x7, 0) != 2147483647L)
            return -1;
          if (
#line 4935 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 1678; /* *llgt_sidi */
          if (pnum_clobbers == NULL
              || !
#line 4945 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1679; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x4))
        {
        case LSHIFTRT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!nonzero_shift_count_operand (operands[2], E_DImode))
            return -1;
          if (
#line 4397 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1630; /* *trunc_sidi_and_subreg_lshrt_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4397 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1631; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 2);
          operands[2] = x8;
          if (!nonzero_shift_count_operand (operands[2], E_SImode))
            return -1;
          if (
#line 4411 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1632; /* *trunc_sidi_and_subreg_ze_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4411 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1633; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern2 (x1))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 865; /* *lshrv1qi3 */
          if (register_operand (operands[2], E_V1QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 947; /* vlshrv1qi3 */
          break;

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 869; /* *lshrv2qi3 */
          if (register_operand (operands[2], E_V2QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 948; /* vlshrv2qi3 */
          break;

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 873; /* *lshrv4qi3 */
          if (register_operand (operands[2], E_V4QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 949; /* vlshrv4qi3 */
          break;

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 877; /* *lshrv8qi3 */
          if (register_operand (operands[2], E_V8QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 950; /* vlshrv8qi3 */
          break;

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 881; /* *lshrv16qi3 */
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 951; /* vlshrv16qi3 */
          break;

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 885; /* *lshrv1hi3 */
          if (register_operand (operands[2], E_V1HImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 952; /* vlshrv1hi3 */
          break;

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 889; /* *lshrv2hi3 */
          if (register_operand (operands[2], E_V2HImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 953; /* vlshrv2hi3 */
          break;

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 893; /* *lshrv4hi3 */
          if (register_operand (operands[2], E_V4HImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 954; /* vlshrv4hi3 */
          break;

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 897; /* *lshrv8hi3 */
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 955; /* vlshrv8hi3 */
          break;

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 901; /* *lshrv1si3 */
          if (register_operand (operands[2], E_V1SImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 956; /* vlshrv1si3 */
          break;

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 905; /* *lshrv2si3 */
          if (register_operand (operands[2], E_V2SImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 957; /* vlshrv2si3 */
          break;

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 909; /* *lshrv4si3 */
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 958; /* vlshrv4si3 */
          break;

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 913; /* *lshrv1di3 */
          if (register_operand (operands[2], E_V1DImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 959; /* vlshrv1di3 */
          break;

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 917; /* *lshrv2di3 */
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 1463 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 960; /* vlshrv2di3 */
          break;

        case 14:
          if (
#line 9351 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2159; /* *lshrdi3_31 */
          if (
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2161; /* *lshrdi3 */
          break;

        case 15:
          return 2163; /* *lshrsi3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_26 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
      || GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_DImode)
      || !
#line 4677 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0))
    return -1;
  return 1662; /* *insvdi_mem_reghigh */
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 3);
      operands[4] = x4;
      switch (XINT (x2, 1))
        {
        case 59:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!memory_operand (operands[3], E_BLKmode)
              || !const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern17 (x2, 
E_V4SImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 1; /* vec_gather_elementv4si */

            case E_V2DImode:
              if (pattern17 (x2, 
E_V2DImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 2; /* vec_gather_elementv2di */

            case E_V2DFmode:
              if (pattern126 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 3; /* vec_gather_elementv2df */

            case E_V4SFmode:
              if (pattern126 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
                return -1;
              return 4; /* vec_gather_elementv4sf */

            default:
              return -1;
            }

        case 94:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern54 (x2, 
E_V16QImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 176; /* verimv16qi */

            case E_V8HImode:
              if (pattern54 (x2, 
E_V8HImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 177; /* verimv8hi */

            case E_V4SImode:
              if (pattern54 (x2, 
E_V4SImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 178; /* verimv4si */

            case E_V2DImode:
              if (pattern54 (x2, 
E_V2DImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 179; /* verimv2di */

            default:
              return -1;
            }

        case 129:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[3], E_V16QImode)
                  || !
#line 1264 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 276; /* vec_msumv2di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 1275 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 277; /* vmslg */

            default:
              return -1;
            }

        case 116:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern54 (x2, 
E_V16QImode) != 0
                  || !
#line 1547 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 302; /* vstrcv16qi */

            case E_V8HImode:
              if (pattern54 (x2, 
E_V8HImode) != 0
                  || !
#line 1547 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 303; /* vstrcv8hi */

            case E_V4SImode:
              if (pattern54 (x2, 
E_V4SImode) != 0
                  || !
#line 1547 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 304; /* vstrcv4si */

            default:
              return -1;
            }

        case 31:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[2] = x5;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!immediate_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern249 (x2, 
E_DImode) != 0
                  || !
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1540; /* *strlendi */

            case E_SImode:
              if (pattern249 (x2, 
E_SImode) != 0
                  || !
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1541; /* *strlensi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_14 (x1, insn, pnum_clobbers);

    case 2:
      return recog_13 (x1, insn, pnum_clobbers);

    case 3:
      return recog_15 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_CONCAT)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern168 (x3, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 582 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 511; /* *vec_vllezlfv4si */

        case E_V4SFmode:
          if (pattern168 (x3, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 582 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 512; /* *vec_vllezlfv4sf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern107 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 2249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1254; /* *vec_load_pairv2di */

        case E_V2DFmode:
          if (pattern107 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 2249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1255; /* *vec_load_pairv2df */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern31 (x3, 
TRUNCATE))
        {
        case 0:
          if (!
#line 2437 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1342; /* vec_pack_trunc_v8hi */

        case 1:
          if (!
#line 2437 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1343; /* vec_pack_trunc_v4si */

        case 2:
          if (!
#line 2437 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1344; /* vec_pack_trunc_v2di */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      switch (pattern31 (x3, 
SS_TRUNCATE))
        {
        case 0:
          if (!
#line 2449 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1345; /* vec_pack_ssat_v8hi */

        case 1:
          if (!
#line 2449 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1346; /* vec_pack_ssat_v4si */

        case 2:
          if (!
#line 2449 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1347; /* vec_pack_ssat_v2di */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern31 (x3, 
US_TRUNCATE))
        {
        case 0:
          if (!
#line 2461 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1348; /* vec_pack_usat_v8hi */

        case 1:
          if (!
#line 2461 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1349; /* vec_pack_usat_v4si */

        case 2:
          if (!
#line 2461 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1350; /* vec_pack_usat_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (pattern285 (x10, 
E_DImode) != 0
          || !
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2187; /* *brx_stage1_di */

    case E_SImode:
      if (pattern285 (x10, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2188; /* *brx_stage1_si */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern88 (x4) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[3] = x9;
      if (!nonimmediate_operand (operands[3], E_DImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 4628 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
        return -1;
      return 1658; /* *insv_rnsbg_noshift */

    case SUBREG:
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 7968 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      *pnum_clobbers = 1;
      return 2017; /* *nc */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern218 (x3, 
E_TImode) != 0
                  || !
#line 6387 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 1896; /* *subti3 */

            case E_DImode:
              if (pattern218 (x3, 
E_DImode) != 0)
                return -1;
              if (
#line 6478 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return 1901; /* *subdi3_31z */
              if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 1903; /* *subdi3 */

            case E_SImode:
              if (pattern218 (x3, 
E_SImode) != 0)
                return -1;
              return 1904; /* *subsi3 */

            case E_TFmode:
              if (pattern218 (x3, 
E_TFmode) != 0
                  || !(
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1920; /* subtf3_fpr */

            case E_FPRX2mode:
              if (pattern218 (x3, 
E_FPRX2mode) != 0
                  || !(
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1921; /* subfprx23 */

            case E_DFmode:
              if (pattern218 (x3, 
E_DFmode) != 0
                  || !
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1922; /* subdf3 */

            case E_SFmode:
              if (pattern218 (x3, 
E_SFmode) != 0
                  || !
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1923; /* subsf3 */

            case E_TDmode:
              if (pattern218 (x3, 
E_TDmode) != 0
                  || !(
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1924; /* subtd3 */

            case E_DDmode:
              if (pattern218 (x3, 
E_DDmode) != 0
                  || !(
#line 6703 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1925; /* subdd3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern246 (x3, 
E_DImode) != 0)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6426 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 1897; /* *subdi3_sign */
              if (!memory_operand (operands[2], E_HImode)
                  || !
#line 6652 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                return -1;
              return 1917; /* *subdi3_sign */

            case E_SImode:
              if (pattern246 (x3, 
E_SImode) != 0
                  || !memory_operand (operands[2], E_HImode))
                return -1;
              return 1902; /* *subsi3_sign */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 6466 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1900; /* *subdi3_zero */

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern247 (x3, 
E_DImode) != 0
              || !
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1952; /* *subdi3_slb */

        case E_SImode:
          if (pattern247 (x3, 
E_SImode) != 0)
            return -1;
          return 1953; /* *subsi3_slb */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = recog_87 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case MEM:
      res = recog_88 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_89 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_90 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern38 (x1) == 0)
        {
          switch (GET_CODE (x3))
            {
            case SIGN_EXTEND:
              switch (pattern182 (x3))
                {
                case 0:
                  if (
#line 4006 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 1575; /* *cmpint_sign */
                  break;

                case 1:
                  if ((
#line 4880 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1675; /* *extendqidi2_short_displ */
                  break;

                case 2:
                  if (
#line 4880 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                    return 1676; /* *extendqisi2_short_displ */
                  break;

                default:
                  break;
                }
              break;

            case ZERO_EXTEND:
              if (GET_MODE (x3) == E_SImode
                  && register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x3, 0);
                  operands[1] = x4;
                  if (s_operand (operands[1], E_HImode)
                      && 
#line 5065 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return 1692; /* *zero_extendhisi2_31 */
                }
              break;

            default:
              break;
            }
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode))
                {
                  if (s390_alc_comparison (operands[1], E_DImode)
                      && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 1954; /* *sconddi */
                  if (s390_slb_comparison (operands[1], E_DImode)
                      && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 1956; /* *sconddi_neg */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (s390_alc_comparison (operands[1], E_SImode))
                    return 1955; /* *scondsi */
                  if (s390_slb_comparison (operands[1], E_SImode))
                    return 1957; /* *scondsi_neg */
                }
              break;

            default:
              break;
            }
        }
      break;

    case MULT:
      res = recog_91 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
      if (pnum_clobbers != NULL
          && XWINT (x3, 0) == 0L)
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == USE)
            {
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (memory_operand (operands[0], E_BLKmode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (const_int_operand (operands[1], E_VOIDmode)
                      && 
#line 8708 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
                    {
                      *pnum_clobbers = 1;
                      return 2065; /* *xc_zero */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x3;
      if (!address_operand (operands[1], E_QImode)
          || !
#line 2400 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
        return -1;
      return 1512; /* force_la_31 */

    case PC:
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10212 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2205; /* *casesi_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10231 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2206; /* casesi_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10231 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2207; /* casesi_jump_via_thunksi_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if (register_operand (operands[0], E_DImode)
          && (
#line 10249 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2208; /* casesi_jump_via_thunkdi */
        }
      if (!register_operand (operands[0], E_SImode)
          || !(
#line 10249 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2209; /* casesi_jump_via_thunksi */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_103 (x1, insn, pnum_clobbers);

    case CLOBBER:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1544; /* *movstr */

        case 1:
          if (!
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1545; /* *movstr */

        case 2:
          if (!(
#line 3753 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1562; /* *setmem_long */

        case 3:
          if (!(
#line 3753 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1563; /* *setmem_long */

        case 4:
          if (!
#line 3781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1566; /* *setmem_long_31z */

        case 5:
          if (!(
#line 3766 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1564; /* *setmem_long_and */

        case 6:
          if (!(
#line 3766 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1565; /* *setmem_long_and */

        case 7:
          if (!
#line 3793 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1567; /* *setmem_long_and_31z */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern12 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      x3 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x3, 1);
      operands[0] = x9;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      x11 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
          if (XWINT (x11, 0) != 0L)
            return -1;
          if (larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10274 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2210; /* casesi_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10274 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2211; /* casesi_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[3] = x11;
          if (register_operand (operands[3], E_DImode)
              && larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10291 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2212; /* casesi_jump_via_inlinethunkdi */
          if (!register_operand (operands[3], E_SImode)
              || !larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10291 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2213; /* casesi_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x12 = XEXP (x2, 0);
      if (GET_CODE (x12) != MEM
          || GET_MODE (x12) != E_QImode
          || pattern13 (x1, 
CLOBBER) != 0)
        return -1;
      x13 = XEXP (x12, 0);
      operands[0] = x13;
      x14 = XEXP (x2, 1);
      operands[1] = x14;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 10596 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2226; /* *basr_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 10596 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2227; /* *basr_via_thunksi */

        default:
          return -1;
        }

    case RETURN:
      if (pattern13 (x1, 
USE) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 11534 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2275; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 11534 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2276; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern44 (x2, 
10, 
1, 
UNSPEC_VOLATILE) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XVECEXP (x7, 0, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern217 (x7))
        {
        case 0:
          if (!(
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2249; /* atomic_fetch_anddi_iaf */

        case 1:
          if (!
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2253; /* atomic_fetch_andsi_iaf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern217 (x7))
        {
        case 0:
          if (!(
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2250; /* atomic_fetch_ordi_iaf */

        case 1:
          if (!
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2254; /* atomic_fetch_orsi_iaf */

        default:
          return -1;
        }

    case XOR:
      switch (pattern217 (x7))
        {
        case 0:
          if (!(
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2251; /* atomic_fetch_xordi_iaf */

        case 1:
          if (!
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2255; /* atomic_fetch_xorsi_iaf */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern217 (x7))
        {
        case 0:
          if (!(
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2252; /* atomic_fetch_adddi_iaf */

        case 1:
          if (!
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2256; /* atomic_fetch_addsi_iaf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern100 (x2))
    {
    case 0:
      if (all_ones_operand (operands[1], E_V1QImode)
          && const0_operand (operands[2], E_V1QImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_94 (insn, operands);
      if (!const0_operand (operands[1], E_V1QImode)
          || !all_ones_operand (operands[2], E_V1QImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_113 (insn, operands);

    case 1:
      if (all_ones_operand (operands[1], E_V2QImode)
          && const0_operand (operands[2], E_V2QImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_95 (insn, operands);
      if (!const0_operand (operands[1], E_V2QImode)
          || !all_ones_operand (operands[2], E_V2QImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_114 (insn, operands);

    case 2:
      if (all_ones_operand (operands[1], E_V4QImode)
          && const0_operand (operands[2], E_V4QImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_96 (insn, operands);
      if (!const0_operand (operands[1], E_V4QImode)
          || !all_ones_operand (operands[2], E_V4QImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_115 (insn, operands);

    case 3:
      if (all_ones_operand (operands[1], E_V8QImode)
          && const0_operand (operands[2], E_V8QImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_97 (insn, operands);
      if (!const0_operand (operands[1], E_V8QImode)
          || !all_ones_operand (operands[2], E_V8QImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_116 (insn, operands);

    case 4:
      if (all_ones_operand (operands[1], E_V16QImode)
          && const0_operand (operands[2], E_V16QImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_98 (insn, operands);
      if (!const0_operand (operands[1], E_V16QImode)
          || !all_ones_operand (operands[2], E_V16QImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_117 (insn, operands);

    case 5:
      if (all_ones_operand (operands[1], E_V1HImode)
          && const0_operand (operands[2], E_V1HImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_99 (insn, operands);
      if (!const0_operand (operands[1], E_V1HImode)
          || !all_ones_operand (operands[2], E_V1HImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_118 (insn, operands);

    case 6:
      if (all_ones_operand (operands[1], E_V2HImode)
          && const0_operand (operands[2], E_V2HImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_100 (insn, operands);
      if (!const0_operand (operands[1], E_V2HImode)
          || !all_ones_operand (operands[2], E_V2HImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_119 (insn, operands);

    case 7:
      if (all_ones_operand (operands[1], E_V4HImode)
          && const0_operand (operands[2], E_V4HImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_101 (insn, operands);
      if (!const0_operand (operands[1], E_V4HImode)
          || !all_ones_operand (operands[2], E_V4HImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_120 (insn, operands);

    case 8:
      if (all_ones_operand (operands[1], E_V8HImode)
          && const0_operand (operands[2], E_V8HImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_102 (insn, operands);
      if (!const0_operand (operands[1], E_V8HImode)
          || !all_ones_operand (operands[2], E_V8HImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_121 (insn, operands);

    case 9:
      if (all_ones_operand (operands[1], E_V1SImode)
          && const0_operand (operands[2], E_V1SImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_103 (insn, operands);
      if (!const0_operand (operands[1], E_V1SImode)
          || !all_ones_operand (operands[2], E_V1SImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_122 (insn, operands);

    case 10:
      if (all_ones_operand (operands[1], E_V2SImode)
          && const0_operand (operands[2], E_V2SImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_104 (insn, operands);
      if (!const0_operand (operands[1], E_V2SImode)
          || !all_ones_operand (operands[2], E_V2SImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_123 (insn, operands);

    case 11:
      if (all_ones_operand (operands[1], E_V4SImode)
          && const0_operand (operands[2], E_V4SImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_105 (insn, operands);
      if (!const0_operand (operands[1], E_V4SImode)
          || !all_ones_operand (operands[2], E_V4SImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_124 (insn, operands);

    case 12:
      if (all_ones_operand (operands[1], E_V1DImode)
          && const0_operand (operands[2], E_V1DImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_106 (insn, operands);
      if (!const0_operand (operands[1], E_V1DImode)
          || !all_ones_operand (operands[2], E_V1DImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_125 (insn, operands);

    case 13:
      if (all_ones_operand (operands[1], E_V2DImode)
          && const0_operand (operands[2], E_V2DImode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_107 (insn, operands);
      if (!const0_operand (operands[1], E_V2DImode)
          || !all_ones_operand (operands[2], E_V2DImode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_126 (insn, operands);

    case 14:
      if (all_ones_operand (operands[1], E_V1SFmode)
          && const0_operand (operands[2], E_V1SFmode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_108 (insn, operands);
      if (!const0_operand (operands[1], E_V1SFmode)
          || !all_ones_operand (operands[2], E_V1SFmode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_127 (insn, operands);

    case 15:
      if (all_ones_operand (operands[1], E_V2SFmode)
          && const0_operand (operands[2], E_V2SFmode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_109 (insn, operands);
      if (!const0_operand (operands[1], E_V2SFmode)
          || !all_ones_operand (operands[2], E_V2SFmode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_128 (insn, operands);

    case 16:
      if (all_ones_operand (operands[1], E_V4SFmode)
          && const0_operand (operands[2], E_V4SFmode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_110 (insn, operands);
      if (!const0_operand (operands[1], E_V4SFmode)
          || !all_ones_operand (operands[2], E_V4SFmode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_129 (insn, operands);

    case 17:
      if (all_ones_operand (operands[1], E_V1DFmode)
          && const0_operand (operands[2], E_V1DFmode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_111 (insn, operands);
      if (!const0_operand (operands[1], E_V1DFmode)
          || !all_ones_operand (operands[2], E_V1DFmode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_130 (insn, operands);

    case 18:
      if (all_ones_operand (operands[1], E_V2DFmode)
          && const0_operand (operands[2], E_V2DFmode)
          && 
#line 2359 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_112 (insn, operands);
      if (!const0_operand (operands[1], E_V2DFmode)
          || !all_ones_operand (operands[2], E_V2DFmode)
          || !
#line 2373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_131 (insn, operands);

    default:
      return NULL;
    }
}
