/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern3 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern3 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern3 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern3 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern3 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern3 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern3 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern3 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern3 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern3 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern3 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V4SFmode:
      if (pattern3 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 14;

    case E_V2DFmode:
      if (pattern3 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 15;

    case E_V1TFmode:
      if (pattern3 (x3, 
E_V1TFmode) != 0)
        return -1;
      return 16;

    case E_TFmode:
      if (pattern3 (x3, 
E_TFmode) != 0)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCRAWmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  return 0;
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !s390_comparison (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !s390_comparison (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern63 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  return pattern62 (x1); /* [-1, 1] */
}

int
pattern68 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i1
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  return 0;
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 1
      || GET_MODE (x11) != E_SImode)
    return -1;
  return pattern69 (x2); /* [-1, 23] */
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          return 1;

        case E_QImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern94 (x5); /* [-1, 1] */
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L
              || XWINT (x9, 0) != 4L
              || XWINT (x10, 0) != 5L
              || XWINT (x11, 0) != 6L
              || XWINT (x12, 0) != 7L)
            return -1;
          return 0;

        case 8L:
          if (XWINT (x6, 0) != 9L
              || XWINT (x7, 0) != 10L
              || XWINT (x8, 0) != 11L
              || XWINT (x9, 0) != 12L
              || XWINT (x10, 0) != 13L
              || XWINT (x11, 0) != 14L
              || XWINT (x12, 0) != 15L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L)
            return -1;
          return 2;

        case 4L:
          if (XWINT (x6, 0) != 5L
              || XWINT (x7, 0) != 6L
              || XWINT (x8, 0) != 7L)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L)
            return -1;
          return 4;

        case 2L:
          if (XWINT (x6, 0) != 3L)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  return 0;
}

int
pattern184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern216 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern216 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != MINUS)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XEXP (x3, 1);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_DImode:
          return pattern225 (x3, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern225 (x3, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !general_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !general_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern256 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  switch (SUBREG_BYTE (x7))
    {
    case 0:
      if (maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          return pattern255 (x2, 
E_TImode, 
E_DImode); /* [-1, 0] */

        case E_DImode:
          if (pattern255 (x2, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x7) != E_SImode
          || maybe_ne (SUBREG_BYTE (x4), 4)
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !register_operand (operands[2], E_TImode)
          || !register_operand (operands[3], E_TImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !addv_const_operand (operands[2], i2)
      || pattern278 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XVECEXP (x10, 0, 0);
  operands[1] = x11;
  if (!register_operand (operands[1], E_CCUmode))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern27 (x1))
    {
    case 0:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1071; /* vec_widen_umult_odd_v1qi */

    case 1:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1072; /* vec_widen_umult_odd_v2qi */

    case 2:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1073; /* vec_widen_umult_odd_v4qi */

    case 3:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1074; /* vec_widen_umult_odd_v8qi */

    case 4:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1075; /* vec_widen_umult_odd_v16qi */

    case 5:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1076; /* vec_widen_umult_odd_v1hi */

    case 6:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1077; /* vec_widen_umult_odd_v2hi */

    case 7:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1078; /* vec_widen_umult_odd_v4hi */

    case 8:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1079; /* vec_widen_umult_odd_v8hi */

    case 9:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1080; /* vec_widen_umult_odd_v1si */

    case 10:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1081; /* vec_widen_umult_odd_v2si */

    case 11:
      if (!
#line 1580 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1082; /* vec_widen_umult_odd_v4si */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern183 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 388; /* *vec_set_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern183 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 389; /* *vec_set_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern183 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 390; /* *vec_set_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern183 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 391; /* *vec_set_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern183 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2175 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 392; /* *vec_set_bswap_elemv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x6 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern197 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1QImode))))
                return -1;
              return 435; /* *vec_setv1qi */

            case E_V2QImode:
              if (pattern197 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2QImode))))
                return -1;
              return 436; /* *vec_setv2qi */

            case E_V4QImode:
              if (pattern197 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4QImode))))
                return -1;
              return 437; /* *vec_setv4qi */

            case E_V8QImode:
              if (pattern197 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8QImode))))
                return -1;
              return 438; /* *vec_setv8qi */

            case E_V16QImode:
              if (pattern197 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode))))
                return -1;
              return 439; /* *vec_setv16qi */

            case E_V1HImode:
              if (pattern197 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1HImode))))
                return -1;
              return 440; /* *vec_setv1hi */

            case E_V2HImode:
              if (pattern197 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2HImode))))
                return -1;
              return 441; /* *vec_setv2hi */

            case E_V4HImode:
              if (pattern197 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4HImode))))
                return -1;
              return 442; /* *vec_setv4hi */

            case E_V8HImode:
              if (pattern197 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode))))
                return -1;
              return 443; /* *vec_setv8hi */

            case E_V1SImode:
              if (pattern197 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SImode))))
                return -1;
              return 444; /* *vec_setv1si */

            case E_V2SImode:
              if (pattern197 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SImode))))
                return -1;
              return 445; /* *vec_setv2si */

            case E_V4SImode:
              if (pattern197 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode))))
                return -1;
              return 446; /* *vec_setv4si */

            case E_V1DImode:
              if (pattern197 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DImode))))
                return -1;
              return 447; /* *vec_setv1di */

            case E_V2DImode:
              if (pattern197 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode))))
                return -1;
              return 448; /* *vec_setv2di */

            case E_V1SFmode:
              if (pattern197 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SFmode))))
                return -1;
              return 449; /* *vec_setv1sf */

            case E_V2SFmode:
              if (pattern197 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SFmode))))
                return -1;
              return 450; /* *vec_setv2sf */

            case E_V4SFmode:
              if (pattern197 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode))))
                return -1;
              return 451; /* *vec_setv4sf */

            case E_V1DFmode:
              if (pattern197 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DFmode))))
                return -1;
              return 452; /* *vec_setv1df */

            case E_V2DFmode:
              if (pattern197 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 503 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode))))
                return -1;
              return 453; /* *vec_setv2df */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern197 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 454; /* *vec_setv1qi_plus */

            case E_V2QImode:
              if (pattern197 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 455; /* *vec_setv2qi_plus */

            case E_V4QImode:
              if (pattern197 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 456; /* *vec_setv4qi_plus */

            case E_V8QImode:
              if (pattern197 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 457; /* *vec_setv8qi_plus */

            case E_V16QImode:
              if (pattern197 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 458; /* *vec_setv16qi_plus */

            case E_V1HImode:
              if (pattern197 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 459; /* *vec_setv1hi_plus */

            case E_V2HImode:
              if (pattern197 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 460; /* *vec_setv2hi_plus */

            case E_V4HImode:
              if (pattern197 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 461; /* *vec_setv4hi_plus */

            case E_V8HImode:
              if (pattern197 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 462; /* *vec_setv8hi_plus */

            case E_V1SImode:
              if (pattern197 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 463; /* *vec_setv1si_plus */

            case E_V2SImode:
              if (pattern197 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 464; /* *vec_setv2si_plus */

            case E_V4SImode:
              if (pattern197 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 465; /* *vec_setv4si_plus */

            case E_V1DImode:
              if (pattern197 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 466; /* *vec_setv1di_plus */

            case E_V2DImode:
              if (pattern197 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 467; /* *vec_setv2di_plus */

            case E_V1SFmode:
              if (pattern197 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 468; /* *vec_setv1sf_plus */

            case E_V2SFmode:
              if (pattern197 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 469; /* *vec_setv2sf_plus */

            case E_V4SFmode:
              if (pattern197 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 470; /* *vec_setv4sf_plus */

            case E_V1DFmode:
              if (pattern197 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 471; /* *vec_setv1df_plus */

            case E_V2DFmode:
              if (pattern197 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 472; /* *vec_setv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!s390_unsigned_integer_comparison (x3, E_VOIDmode))
    return -1;
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      switch (pattern171 (x2))
        {
        case 0:
          if (!(
#line 1575 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1493; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1575 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1494; /* *cmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case PC:
      x8 = XEXP (x2, 2);
      switch (pattern172 (x8))
        {
        case 0:
          if (!(
#line 1633 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1497; /* *icmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1633 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1498; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x4, 1);
  operands[5] = x5;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pattern233 (x3, 
E_DImode) != 0
          || !(
#line 7073 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1961; /* *movdicc */

    case E_SImode:
      if (pattern233 (x3, 
E_SImode) != 0
          || !
#line 7073 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      return 1962; /* *movsicc */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SImode:
      if (pattern107 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (
#line 2127 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1240; /* *vec_cmpgev1sf_signaling_nocc */
      if (!(
#line 2135 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1247; /* *vec_cmpgev1sf_signaling_finite_nocc */

    case E_V2SImode:
      if (pattern107 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (
#line 2127 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1241; /* *vec_cmpgev2sf_signaling_nocc */
      if (!(
#line 2135 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1248; /* *vec_cmpgev2sf_signaling_finite_nocc */

    case E_V4SImode:
      if (pattern107 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (
#line 2127 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1242; /* *vec_cmpgev4sf_signaling_nocc */
      if (!(
#line 2135 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1249; /* *vec_cmpgev4sf_signaling_finite_nocc */

    case E_V1DImode:
      if (pattern107 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (
#line 2127 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1243; /* *vec_cmpgev1df_signaling_nocc */
      if (!
#line 2135 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1250; /* *vec_cmpgev1df_signaling_finite_nocc */

    case E_V2DImode:
      if (pattern107 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (
#line 2127 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1244; /* *vec_cmpgev2df_signaling_nocc */
      if (!
#line 2135 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1251; /* *vec_cmpgev2df_signaling_finite_nocc */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1TFmode:
          if (!register_operand (operands[1], E_V1TFmode)
              || !register_operand (operands[2], E_V1TFmode))
            return -1;
          if (
#line 2127 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1245; /* *vec_cmpgev1tf_signaling_nocc */
          if (!(
#line 2135 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1252; /* *vec_cmpgev1tf_signaling_finite_nocc */

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !register_operand (operands[2], E_TFmode))
            return -1;
          if (
#line 2127 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1246; /* *vec_cmpgetf_signaling_nocc */
          if (!(
#line 2135 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1253; /* *vec_cmpgetf_signaling_finite_nocc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (const_int_operand (operands[2], E_VOIDmode))
    {
      res = recog_37 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 4656 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 690 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1660; /* *insvdi_mem_reg */

    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !(
#line 4656 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 690 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
        return -1;
      return 1661; /* *insvsi_mem_reg */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_36 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x1, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (subreg_register_operand (operands[0], E_QImode)
              && memory_operand (operands[1], E_QImode))
            return 1515; /* movstrictqi */
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && subreg_register_operand (operands[0], E_HImode)
              && memory_operand (operands[1], E_HImode))
            {
              *pnum_clobbers = 1;
              return 1516; /* movstricthi */
            }
          break;

        case E_SImode:
          if (subreg_register_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode)
              && 
#line 2571 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 1517; /* movstrictsi */
          break;

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LABEL_REF:
      if (GET_CODE (x2) == PC)
        {
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          return 2194; /* *jump64 */
        }
      break;

    default:
      break;
    }
  operands[1] = x4;
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !general_operand (operands[1], E_TImode)
          || !
#line 1672 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1500; /* movti */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode))
        return -1;
      if ((
#line 2595 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return 1518; /* *movtf_64 */
      if (!(
#line 2612 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 671 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1521; /* *movtf_31 */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1352; /* zero_extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1354; /* zero_extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1356; /* zero_extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1358; /* zero_extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2471 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1360; /* zero_extendv4hiv4si2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5101 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 1694; /* *zero_extendqihi2_64 */
          if (!
#line 5109 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 1695; /* *zero_extendqihi2_31 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern111 (x3))
        {
        case 0:
          if (!
#line 2527 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1363; /* vec_unpacku_hi_v16qi */

        case 1:
          if (!
#line 2538 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1364; /* vec_unpacku_lo_v16qi */

        case 2:
          if (!
#line 2574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1367; /* vec_unpacku_hi_v8hi */

        case 3:
          if (!
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1368; /* vec_unpacku_lo_v8hi */

        case 4:
          if (!
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1371; /* vec_unpacku_hi_v4si */

        case 5:
          if (!
#line 2630 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1372; /* vec_unpacku_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case GTU:
      x3 = XEXP (x1, 0);
      switch (GET_MODE (x3))
        {
        case E_V1QImode:
          if (pattern9 (x1, 
E_V1QImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1152; /* *vec_cmpgtuv1qiv1qi_nocc */
          break;

        case E_V2QImode:
          if (pattern9 (x1, 
E_V2QImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1155; /* *vec_cmpgtuv2qiv2qi_nocc */
          break;

        case E_V4QImode:
          if (pattern9 (x1, 
E_V4QImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1158; /* *vec_cmpgtuv4qiv4qi_nocc */
          break;

        case E_V8QImode:
          if (pattern9 (x1, 
E_V8QImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1161; /* *vec_cmpgtuv8qiv8qi_nocc */
          break;

        case E_V16QImode:
          if (pattern9 (x1, 
E_V16QImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1164; /* *vec_cmpgtuv16qiv16qi_nocc */
          break;

        case E_V1HImode:
          if (pattern9 (x1, 
E_V1HImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1167; /* *vec_cmpgtuv1hiv1hi_nocc */
          break;

        case E_V2HImode:
          if (pattern9 (x1, 
E_V2HImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1170; /* *vec_cmpgtuv2hiv2hi_nocc */
          break;

        case E_V4HImode:
          if (pattern9 (x1, 
E_V4HImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1173; /* *vec_cmpgtuv4hiv4hi_nocc */
          break;

        case E_V8HImode:
          if (pattern9 (x1, 
E_V8HImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1176; /* *vec_cmpgtuv8hiv8hi_nocc */
          break;

        case E_V1SImode:
          if (pattern9 (x1, 
E_V1SImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1179; /* *vec_cmpgtuv1siv1si_nocc */
          break;

        case E_V2SImode:
          if (pattern9 (x1, 
E_V2SImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1182; /* *vec_cmpgtuv2siv2si_nocc */
          break;

        case E_V4SImode:
          if (pattern9 (x1, 
E_V4SImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1185; /* *vec_cmpgtuv4siv4si_nocc */
          break;

        case E_V1DImode:
          if (pattern9 (x1, 
E_V1DImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1188; /* *vec_cmpgtuv1div1di_nocc */
          break;

        case E_V2DImode:
          if (pattern9 (x1, 
E_V2DImode) == 0
              && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1191; /* *vec_cmpgtuv2div2di_nocc */
          break;

        case E_V1TImode:
          if (pattern10 (x1, 
E_V1TImode) == 0
              && 
#line 2017 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1196; /* *vec_cmpgtuv1tiv1ti_nocc_emu */
          break;

        case E_TImode:
          if (pattern10 (x1, 
E_TImode) == 0
              && 
#line 2017 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1197; /* *vec_cmpgtutiti_nocc_emu */
          break;

        default:
          break;
        }
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_DImode)
          && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 1954; /* *sconddi */
        }
      if (!s390_slb_comparison (operands[1], E_DImode)
          || !
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 1956; /* *sconddi_neg */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_SImode))
        {
          *pnum_clobbers = 1;
          return 1955; /* *scondsi */
        }
      if (!s390_slb_comparison (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 1957; /* *scondsi_neg */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_mask_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern169 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !
#line 595 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode)))
            return -1;
          return 513; /* *vec_splatv16qi */

        case E_V8HImode:
          if (pattern169 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 595 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 514; /* *vec_splatv8hi */

        case E_V4SImode:
          if (pattern169 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 595 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 515; /* *vec_splatv4si */

        case E_V4SFmode:
          if (pattern169 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 595 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)))
            return -1;
          return 516; /* *vec_splatv4sf */

        case E_V2DImode:
          if (pattern169 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 595 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 517; /* *vec_splatv2di */

        case E_V2DFmode:
          if (pattern169 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 595 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 518; /* *vec_splatv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !general_operand (operands[1], E_QImode)
              || !
#line 603 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 519; /* *vec_splatsv16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !general_operand (operands[1], E_HImode)
              || !
#line 603 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 520; /* *vec_splatsv8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !general_operand (operands[1], E_SImode)
              || !
#line 603 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 521; /* *vec_splatsv4si */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !general_operand (operands[1], E_SFmode)
              || !
#line 603 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 522; /* *vec_splatsv4sf */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !general_operand (operands[1], E_DImode)
              || !
#line 603 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 523; /* *vec_splatsv2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !general_operand (operands[1], E_DFmode)
              || !
#line 603 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 524; /* *vec_splatsv2df */

        case E_V1TFmode:
          if (!nonimmediate_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !general_operand (operands[1], E_TFmode))
            return -1;
          if (
#line 636 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return 535; /* *vec_tf_to_v1tf_fpr */
          if (!
#line 649 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 536; /* *vec_tf_to_v1tf_vr */

        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !general_operand (operands[1], E_TImode)
              || !
#line 679 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 538; /* *vec_ti_to_v1ti */

        default:
          return -1;
        }

    case BSWAP:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern84 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 627 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 530; /* *vec_splats_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern84 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 627 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 531; /* *vec_splats_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern84 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 627 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 532; /* *vec_splats_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern84 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 627 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 533; /* *vec_splats_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern84 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 627 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 534; /* *vec_splats_bswap_elemv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (register_operand (operands[2], E_V1QImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 849; /* vrotlv1qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return -1;
      return 866; /* *rotlv1qi3 */

    case 1:
      if (register_operand (operands[2], E_V2QImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 850; /* vrotlv2qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return -1;
      return 870; /* *rotlv2qi3 */

    case 2:
      if (register_operand (operands[2], E_V4QImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 851; /* vrotlv4qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return -1;
      return 874; /* *rotlv4qi3 */

    case 3:
      if (register_operand (operands[2], E_V8QImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 852; /* vrotlv8qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return -1;
      return 878; /* *rotlv8qi3 */

    case 4:
      if (register_operand (operands[2], E_V16QImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 853; /* vrotlv16qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return -1;
      return 882; /* *rotlv16qi3 */

    case 5:
      if (register_operand (operands[2], E_V1HImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 854; /* vrotlv1hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return -1;
      return 886; /* *rotlv1hi3 */

    case 6:
      if (register_operand (operands[2], E_V2HImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 855; /* vrotlv2hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return -1;
      return 890; /* *rotlv2hi3 */

    case 7:
      if (register_operand (operands[2], E_V4HImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 856; /* vrotlv4hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return -1;
      return 894; /* *rotlv4hi3 */

    case 8:
      if (register_operand (operands[2], E_V8HImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 857; /* vrotlv8hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return -1;
      return 898; /* *rotlv8hi3 */

    case 9:
      if (register_operand (operands[2], E_V1SImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 858; /* vrotlv1si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return -1;
      return 902; /* *rotlv1si3 */

    case 10:
      if (register_operand (operands[2], E_V2SImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 859; /* vrotlv2si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return -1;
      return 906; /* *rotlv2si3 */

    case 11:
      if (register_operand (operands[2], E_V4SImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 860; /* vrotlv4si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return -1;
      return 910; /* *rotlv4si3 */

    case 12:
      if (register_operand (operands[2], E_V1DImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 861; /* vrotlv1di3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return -1;
      return 914; /* *rotlv1di3 */

    case 13:
      if (register_operand (operands[2], E_V2DImode)
          && 
#line 1385 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 862; /* vrotlv2di3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return -1;
      return 918; /* *rotlv2di3 */

    case 14:
      if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2156; /* *rotldi3 */

    case 15:
      return 2157; /* *rotlsi3 */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  switch (XINT (x2, 1))
    {
    case 8:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 36)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 36)
        return -1;
      return 2234; /* *set_tp */

    case 7:
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 11412 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2268; /* main_pool */

    case 18:
      if (pattern35 (x1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[0] = x3;
      if (!const_int_operand (operands[0], E_VOIDmode)
          || !
#line 12099 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2305; /* *tbeginc_1 */

    case 19:
      if (GET_MODE (x2) != E_CCRAWmode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode
          || !
#line 12116 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2306; /* *tend_1 */

    case 21:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12156 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2309; /* etnd */

    case 22:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12166 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2310; /* ntstg */

    case 25:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12201 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2313; /* efpc */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x2, 0);
          switch (GET_MODE (x7))
            {
            case E_CCVEQmode:
              if (GET_MODE (x3) != E_CCVEQmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (!register_operand (operands[0], E_V16QImode)
                      || !register_operand (operands[1], E_V16QImode)
                      || !scratch_operand (operands[2], E_V16QImode)
                      || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 332; /* *vec_cmpeqv16qi_cconly */

                case E_V8HImode:
                  if (!register_operand (operands[0], E_V8HImode)
                      || !register_operand (operands[1], E_V8HImode)
                      || !scratch_operand (operands[2], E_V8HImode)
                      || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 333; /* *vec_cmpeqv8hi_cconly */

                case E_V4SImode:
                  if (!register_operand (operands[0], E_V4SImode)
                      || !register_operand (operands[1], E_V4SImode)
                      || !scratch_operand (operands[2], E_V4SImode)
                      || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 334; /* *vec_cmpeqv4si_cconly */

                case E_V2DImode:
                  if (!register_operand (operands[0], E_V2DImode)
                      || !register_operand (operands[1], E_V2DImode)
                      || !scratch_operand (operands[2], E_V2DImode)
                      || !
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 335; /* *vec_cmpeqv2di_cconly */

                case E_V4SFmode:
                  if (!register_operand (operands[0], E_V4SFmode)
                      || !register_operand (operands[1], E_V4SFmode)
                      || !scratch_operand (operands[2], E_V4SImode)
                      || !(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 356; /* *vec_cmpeqv4sf_cconly */

                case E_V2DFmode:
                  if (!register_operand (operands[0], E_V2DFmode)
                      || !register_operand (operands[1], E_V2DFmode)
                      || !scratch_operand (operands[2], E_V2DImode)
                      || !
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 357; /* *vec_cmpeqv2df_cconly */

                case E_V1TFmode:
                  if (!register_operand (operands[0], E_V1TFmode)
                      || !register_operand (operands[1], E_V1TFmode)
                      || !scratch_operand (operands[2], E_V1TImode)
                      || !(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 358; /* *vec_cmpeqv1tf_cconly */

                case E_TFmode:
                  if (!register_operand (operands[0], E_TFmode)
                      || !register_operand (operands[1], E_TFmode)
                      || !scratch_operand (operands[2], E_V1TImode)
                      || !(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 359; /* *vec_cmpeqtf_cconly */

                default:
                  return -1;
                }

            case E_CCVIHmode:
              switch (pattern234 (x3, 
E_CCVIHmode))
                {
                case 0:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 336; /* *vec_cmphv16qi_cconly */

                case 1:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 337; /* *vec_cmphv8hi_cconly */

                case 2:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 338; /* *vec_cmphv4si_cconly */

                case 3:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 339; /* *vec_cmphv2di_cconly */

                default:
                  return -1;
                }

            case E_CCVIHUmode:
              switch (pattern234 (x3, 
E_CCVIHUmode))
                {
                case 0:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 340; /* *vec_cmphlv16qi_cconly */

                case 1:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 341; /* *vec_cmphlv8hi_cconly */

                case 2:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 342; /* *vec_cmphlv4si_cconly */

                case 3:
                  if (!
#line 1987 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 343; /* *vec_cmphlv2di_cconly */

                default:
                  return -1;
                }

            case E_CCVFHmode:
              switch (pattern235 (x3, 
E_CCVFHmode))
                {
                case 0:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 360; /* *vec_cmphv4sf_cconly */

                case 1:
                  if (!
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 361; /* *vec_cmphv2df_cconly */

                case 2:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 362; /* *vec_cmphv1tf_cconly */

                case 3:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 363; /* *vec_cmphtf_cconly */

                default:
                  return -1;
                }

            case E_CCVFHEmode:
              switch (pattern235 (x3, 
E_CCVFHEmode))
                {
                case 0:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 364; /* *vec_cmphev4sf_cconly */

                case 1:
                  if (!
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 365; /* *vec_cmphev2df_cconly */

                case 2:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 366; /* *vec_cmphev1tf_cconly */

                case 3:
                  if (!(
#line 2070 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 367; /* *vec_cmphetf_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SET:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x8 = XEXP (x5, 1);
          switch (GET_CODE (x8))
            {
            case EQ:
              if (pattern236 (x1, 
E_CCVEQmode) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern270 (x8, 
E_V16QImode) != 0
                      || !
#line 2036 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 344; /* *vec_cmpeqv16qi_cc */

                case E_V8HImode:
                  if (pattern270 (x8, 
E_V8HImode) != 0
                      || !
#line 2036 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 345; /* *vec_cmpeqv8hi_cc */

                case E_V4SImode:
                  if (pattern270 (x8, 
E_V4SImode) != 0
                      || !
#line 2036 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 346; /* *vec_cmpeqv4si_cc */

                case E_V2DImode:
                  if (pattern270 (x8, 
E_V2DImode) != 0
                      || !
#line 2036 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 347; /* *vec_cmpeqv2di_cc */

                case E_V4SFmode:
                  if (pattern271 (x8, 
E_V4SFmode, 
E_V4SImode) != 0
                      || !(
#line 2119 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 368; /* *vec_cmpeqv4sf_cc */

                case E_V2DFmode:
                  if (pattern271 (x8, 
E_V2DFmode, 
E_V2DImode) != 0
                      || !
#line 2119 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 369; /* *vec_cmpeqv2df_cc */

                case E_V1TFmode:
                  if (pattern271 (x8, 
E_V1TFmode, 
E_V1TImode) != 0
                      || !(
#line 2119 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 370; /* *vec_cmpeqv1tf_cc */

                case E_TFmode:
                  if (pattern271 (x8, 
E_TFmode, 
E_V1TImode) != 0
                      || !(
#line 2119 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 371; /* *vec_cmpeqtf_cc */

                default:
                  return -1;
                }

            case GT:
              x9 = XEXP (x8, 0);
              if (!rtx_equal_p (x9, operands[0]))
                return -1;
              x10 = XEXP (x8, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x7 = XEXP (x2, 0);
              switch (GET_MODE (x7))
                {
                case E_CCVIHmode:
                  if (GET_MODE (x3) != E_CCVIHmode)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern270 (x8, 
E_V16QImode) != 0
                          || !
#line 2046 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 348; /* *vec_cmphv16qi_cc */

                    case E_V8HImode:
                      if (pattern270 (x8, 
E_V8HImode) != 0
                          || !
#line 2046 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 349; /* *vec_cmphv8hi_cc */

                    case E_V4SImode:
                      if (pattern270 (x8, 
E_V4SImode) != 0
                          || !
#line 2046 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 350; /* *vec_cmphv4si_cc */

                    case E_V2DImode:
                      if (pattern270 (x8, 
E_V2DImode) != 0
                          || !
#line 2046 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 351; /* *vec_cmphv2di_cc */

                    default:
                      return -1;
                    }

                case E_CCVFHmode:
                  if (GET_MODE (x3) != E_CCVFHmode)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern271 (x8, 
E_V4SFmode, 
E_V4SImode) != 0
                          || !(
#line 2130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                        return -1;
                      return 372; /* *vec_cmphv4sf_cc */

                    case E_V2DFmode:
                      if (pattern271 (x8, 
E_V2DFmode, 
E_V2DImode) != 0
                          || !
#line 2130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                        return -1;
                      return 373; /* *vec_cmphv2df_cc */

                    case E_V1TFmode:
                      if (pattern271 (x8, 
E_V1TFmode, 
E_V1TImode) != 0
                          || !(
#line 2130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                        return -1;
                      return 374; /* *vec_cmphv1tf_cc */

                    case E_TFmode:
                      if (pattern271 (x8, 
E_TFmode, 
E_V1TImode) != 0
                          || !(
#line 2130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                        return -1;
                      return 375; /* *vec_cmphtf_cc */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case GTU:
              if (pattern236 (x1, 
E_CCVIHUmode) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern270 (x8, 
E_V16QImode) != 0
                      || !
#line 2056 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 352; /* *vec_cmphlv16qi_cc */

                case E_V8HImode:
                  if (pattern270 (x8, 
E_V8HImode) != 0
                      || !
#line 2056 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 353; /* *vec_cmphlv8hi_cc */

                case E_V4SImode:
                  if (pattern270 (x8, 
E_V4SImode) != 0
                      || !
#line 2056 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 354; /* *vec_cmphlv4si_cc */

                case E_V2DImode:
                  if (pattern270 (x8, 
E_V2DImode) != 0
                      || !
#line 2056 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 355; /* *vec_cmphlv2di_cc */

                default:
                  return -1;
                }

            case GE:
              if (pattern236 (x1, 
E_CCVFHEmode) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern271 (x8, 
E_V4SFmode, 
E_V4SImode) != 0
                      || !(
#line 2141 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 376; /* *vec_cmphev4sf_cc */

                case E_V2DFmode:
                  if (pattern271 (x8, 
E_V2DFmode, 
E_V2DImode) != 0
                      || !
#line 2141 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 377; /* *vec_cmphev2df_cc */

                case E_V1TFmode:
                  if (pattern271 (x8, 
E_V1TFmode, 
E_V1TImode) != 0
                      || !(
#line 2141 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 378; /* *vec_cmphev1tf_cc */

                case E_TFmode:
                  if (pattern271 (x8, 
E_TFmode, 
E_V1TImode) != 0
                      || !(
#line 2141 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 379; /* *vec_cmphetf_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case USE:
          if (!memory_operand (operands[0], E_BLKmode)
              || !memory_operand (operands[1], E_BLKmode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 1403 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
            return -1;
          return 1464; /* *clc */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case SET:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x8 = XEXP (x5, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!const0_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && (
#line 1001 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1429; /* *tstdi_extimm */
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 1043 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_ZARCH && !TARGET_EXTIMM))
                return -1;
              return 1433; /* *tstdi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !const0_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              if (
#line 1001 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                return 1430; /* *tstsi_extimm */
              if (!
#line 1054 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && !TARGET_EXTIMM))
                return -1;
              return 1434; /* *tstsi */

            case E_HImode:
              if (!const0_operand (operands[1], E_HImode)
                  || !register_operand (operands[2], E_HImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_HImode)
                  && 
#line 1104 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1439; /* *tsthiCCT */
              if (!s_operand (operands[0], E_HImode)
                  || !
#line 1146 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1443; /* *tsthi */

            case E_QImode:
              if (!const0_operand (operands[1], E_QImode)
                  || !register_operand (operands[2], E_QImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_QImode)
                  && 
#line 1104 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1440; /* *tstqiCCT */
              if (!s_operand (operands[0], E_QImode)
                  || !
#line 1146 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1444; /* *tstqi */

            default:
              return -1;
            }

        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && const0_operand (operands[1], E_DImode)
                  && scratch_operand (operands[2], E_DImode)
                  && (
#line 1030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1431; /* *tstdi_cconly_extimm */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && const0_operand (operands[1], E_SImode)
                  && scratch_operand (operands[2], E_SImode))
                {
                  if (
#line 1030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                    return 1432; /* *tstsi_cconly_extimm */
                  if (
#line 1068 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1435; /* *tstsi_cconly */
                }
              break;

            case E_HImode:
              if (const0_operand (operands[1], E_HImode)
                  && scratch_operand (operands[2], E_HImode))
                {
                  if (nonimmediate_operand (operands[0], E_HImode)
                      && 
#line 1118 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                    return 1441; /* *tsthiCCT_cconly */
                  if (s_operand (operands[0], E_HImode)
                      && 
#line 1159 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1445; /* *tsthi_cconly */
                }
              break;

            case E_QImode:
              if (s_operand (operands[0], E_QImode)
                  && const0_operand (operands[1], E_QImode)
                  && scratch_operand (operands[2], E_QImode)
                  && 
#line 1159 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1446; /* *tstqi_cconly */
              break;

            default:
              break;
            }
          x7 = XEXP (x2, 0);
          if (GET_MODE (x7) != E_CCZmode
              || GET_MODE (x3) != E_CCZmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !const0_operand (operands[1], E_TFmode)
                  || !register_operand (operands[2], E_TFmode)
                  || !(
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1465; /* *cmptf_ccz_0 */

            case E_FPRX2mode:
              if (!register_operand (operands[0], E_FPRX2mode)
                  || !const0_operand (operands[1], E_FPRX2mode)
                  || !register_operand (operands[2], E_FPRX2mode)
                  || !(
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1466; /* *cmpfprx2_ccz_0 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !const0_operand (operands[1], E_DFmode)
                  || !register_operand (operands[2], E_DFmode)
                  || !
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1467; /* *cmpdf_ccz_0 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !const0_operand (operands[1], E_SFmode)
                  || !register_operand (operands[2], E_SFmode)
                  || !
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1468; /* *cmpsf_ccz_0 */

            case E_TDmode:
              if (!register_operand (operands[0], E_TDmode)
                  || !const0_operand (operands[1], E_TDmode)
                  || !register_operand (operands[2], E_TDmode)
                  || !(
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1469; /* *cmptd_ccz_0 */

            case E_DDmode:
              if (!register_operand (operands[0], E_DDmode)
                  || !const0_operand (operands[1], E_DDmode)
                  || !register_operand (operands[2], E_DDmode)
                  || !(
#line 1465 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1470; /* *cmpdd_ccz_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_111 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_101 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_104 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_105 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_106 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_107 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 34:
          res = recog_108 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 18:
          if (pattern7 (x1, 
19, 
E_DFmode, 
18, 
17) == 0
              && pattern293 (x1, 
23, 
E_DFmode, 
22, 
21, 
20) == 0
              && pattern294 (x1, 
27, 
E_DFmode, 
26, 
25, 
24) == 0
              && pattern295 (x1, 
E_DFmode, 
31, 
30, 
29, 
28) == 0)
            {
              x2 = XVECEXP (x1, 0, 0);
              x3 = XEXP (x2, 1);
              x4 = XVECEXP (x3, 0, 0);
              operands[0] = x4;
              if (const_int_operand (operands[0], E_VOIDmode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (memory_operand (operands[1], E_BLKmode))
                    {
                      x7 = XEXP (x5, 1);
                      x8 = XVECEXP (x7, 0, 0);
                      if (rtx_equal_p (x8, operands[0])
                          && 
#line 12070 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
                        return 2303; /* tbegin_1 */
                    }
                }
            }
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          res = recog_109 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 3:
              if (XINT (x7, 1) != 9)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (pattern180 (x10) != 0)
                return -1;
              x11 = XVECEXP (x7, 0, 1);
              operands[2] = x11;
              x12 = XVECEXP (x7, 0, 2);
              operands[3] = x12;
              x8 = XVECEXP (x7, 0, 0);
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x13 = XEXP (x10, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x13, 1);
              if (!rtx_equal_p (x15, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern275 (x7, 
E_DImode) != 0)
                    return -1;
                  if (
#line 11010 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return 2246; /* *atomic_compare_and_swapdi_1 */
                  if (!
#line 11028 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2247; /* *atomic_compare_and_swapdi_2 */

                case E_SImode:
                  if (pattern275 (x7, 
E_SImode) != 0
                      || !
#line 11049 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2248; /* *atomic_compare_and_swapsi_3 */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x7, 1) != 10)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != CLOBBER)
                return -1;
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 33
                  || GET_MODE (x16) != E_CCmode)
                return -1;
              x8 = XVECEXP (x7, 0, 0);
              switch (GET_CODE (x8))
                {
                case AND:
                  switch (pattern217 (x7))
                    {
                    case 0:
                      if (!(
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2249; /* atomic_fetch_anddi_iaf */

                    case 1:
                      if (!
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2253; /* atomic_fetch_andsi_iaf */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern217 (x7))
                    {
                    case 0:
                      if (!(
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2250; /* atomic_fetch_ordi_iaf */

                    case 1:
                      if (!
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2254; /* atomic_fetch_orsi_iaf */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern217 (x7))
                    {
                    case 0:
                      if (!(
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2251; /* atomic_fetch_xordi_iaf */

                    case 1:
                      if (!
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2255; /* atomic_fetch_xorsi_iaf */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern217 (x7))
                    {
                    case 0:
                      if (!(
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2252; /* atomic_fetch_adddi_iaf */

                    case 1:
                      if (!
#line 11089 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2256; /* atomic_fetch_addsi_iaf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          if (pnum_clobbers != NULL)
            {
              res = recog_110 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 15
              || GET_MODE (x9) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x17 = XEXP (x6, 0);
          if (GET_CODE (x17) != SCRATCH)
            return -1;
          x3 = XEXP (x2, 1);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode)
              || !
#line 11661 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2283; /* stack_restore_from_fpr */

        default:
          return -1;
        }

    case TRAP_IF:
      x18 = XEXP (x1, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XEXP (x1, 0);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 1L)
            return -1;
          return 2179; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[0] = x19;
          if (s390_comparison (operands[0], E_VOIDmode))
            {
              x20 = XEXP (x19, 1);
              if (x20 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x21 = XEXP (x19, 0);
                  operands[1] = x21;
                  if (cc_reg_operand (operands[1], E_VOIDmode))
                    return 2180; /* condtrap */
                }
            }
          x21 = XEXP (x19, 0);
          operands[1] = x21;
          x20 = XEXP (x19, 1);
          operands[2] = x20;
          if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && nonmemory_operand (operands[2], E_DImode)
                      && (
#line 9629 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2181; /* *cmp_and_trap_signed_intdi */
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && nonmemory_operand (operands[2], E_SImode)
                      && 
#line 9629 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return 2182; /* *cmp_and_trap_signed_intsi */
                  break;

                default:
                  break;
                }
            }
          if (!s390_unsigned_integer_comparison (operands[0], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !general_operand (operands[2], E_DImode)
                  || !(
#line 9643 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2183; /* *cmp_and_trap_unsigned_intdi */

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !general_operand (operands[2], E_SImode)
                  || !
#line 9643 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 2184; /* *cmp_and_trap_unsigned_intsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2214; /* blockage */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2258; /* nop_lr0 */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2259; /* nop_lr1 */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2260; /* nop_2_byte */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2261; /* nop_4_byte */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2262; /* nop_6_byte */

            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!consttable_operand (operands[0], E_VOIDmode))
                return -1;
              return 2263; /* *pool_entry */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2264; /* pool_align */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != CONST_INT)
                return -1;
              switch (XWINT (x2, 0))
                {
                case 1L:
                  return 2265; /* pool_section_start */

                case 0L:
                  return 2266; /* pool_section_end */

                default:
                  return -1;
                }

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2270; /* pool */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x2))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x2;
                  if (!nonmemory_operand (operands[0], E_SImode)
                      || !
#line 12139 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
                    return -1;
                  return 2307; /* *tabort_1 */

                case PLUS:
                  if (GET_MODE (x2) != E_SImode)
                    return -1;
                  x9 = XEXP (x2, 0);
                  operands[0] = x9;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x3 = XEXP (x2, 1);
                  operands[1] = x3;
                  if (!const_int_operand (operands[1], E_SImode)
                      || !
#line 12147 "../../gcc/config/s390/s390.md"
(TARGET_HTM && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[1]), 'J', "J")))
                    return -1;
                  return 2308; /* *tabort_1_plus */

                default:
                  return -1;
                }

            case 24:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 12195 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2312; /* sfpc */

            case 27:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2319; /* osc_break */

            default:
              return -1;
            }

        case 3:
          if (XINT (x1, 1) != 23)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 12185 "../../gcc/config/s390/s390.md"
((TARGET_ZEC12 || TARGET_HTM) && INTVAL (operands[2]) < 16))
            return -1;
          return 2311; /* *ppa */

        default:
          return -1;
        }

    case CALL:
      x19 = XEXP (x1, 0);
      if (GET_CODE (x19) != MEM
          || GET_MODE (x19) != E_QImode)
        return -1;
      x18 = XEXP (x1, 1);
      if (!const_int_operand (x18, E_VOIDmode))
        return -1;
      x21 = XEXP (x19, 0);
      switch (GET_CODE (x21))
        {
        case REG:
          if (REGNO (x21) != 1)
            return -1;
          operands[0] = x18;
          if (!
#line 10403 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (PATTERN (insn), 0), 0)) == Pmode))
            return -1;
          return 2215; /* *sibcall_br */

        case CONST:
        case SYMBOL_REF:
          operands[0] = x21;
          if (!bras_sym_operand (operands[0], E_VOIDmode))
            return -1;
          operands[1] = x18;
          if (
#line 10432 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2216; /* *sibcall_brc */
          if (!
#line 10440 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2217; /* *sibcall_brcl */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 2257; /* nop */

    case RETURN:
      if (!
#line 11459 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
        return -1;
      return 2271; /* return */

    case SIMPLE_RETURN:
      if (!
#line 11459 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
        return -1;
      return 2272; /* simple_return */

    case PREFETCH:
      x19 = XEXP (x1, 0);
      operands[0] = x19;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x18 = XEXP (x1, 1);
      operands[1] = x18;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x22 = XEXP (x1, 2);
      operands[2] = x22;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 11673 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      return 2284; /* prefetch */

    default:
      return -1;
    }
}
