/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern3 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern3 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern3 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern3 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern3 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern3 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern3 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern3 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern3 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern3 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern3 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern28 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern31 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern30 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern30 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern30 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern44 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern17 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern17 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern17 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern17 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern17 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern17 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern17 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern17 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V1TFmode:
      if (pattern17 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern17 (x1, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCUmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCUmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  return 0;
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG)
    return -1;
  return 0;
}

int
pattern107 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern110 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[2], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const0_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x10 = XEXP (x3, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != i1
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != SIGN_EXTEND
      || GET_MODE (x13) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x14 = XEXP (x7, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x11, 0);
  operands[0] = x15;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x16 = XEXP (x13, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern170 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 2;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SCRATCH)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case SUBREG:
        case MEM:
          operands[3] = x7;
          if (!memory_operand (operands[3], E_VOIDmode))
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SCRATCH)
            return -1;
          return 1;

        case CONST:
          if (GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 17
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          x5 = XEXP (x4, 0);
          switch (GET_CODE (x5))
            {
            case SCRATCH:
              return 2;

            case REG:
            case SUBREG:
              operands[3] = x5;
              if (!register_operand (operands[3], E_VOIDmode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern243 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern252 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!bras_sym_operand (operands[0], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x12 = XEXP (x2, 0);
  switch (GET_MODE (x12))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern17 (x3, 
E_V16QImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 234; /* vec_srabv16qi */

    case E_V8HImode:
      if (pattern17 (x3, 
E_V8HImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 235; /* vec_srabv8hi */

    case E_V4SImode:
      if (pattern17 (x3, 
E_V4SImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 236; /* vec_srabv4si */

    case E_V2DImode:
      if (pattern17 (x3, 
E_V2DImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 237; /* vec_srabv2di */

    case E_V1TImode:
      if (pattern17 (x3, 
E_V1TImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 238; /* vec_srabv1ti */

    case E_TImode:
      if (pattern126 (x3, 
E_V1TImode, 
E_TImode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 239; /* vec_srabti */

    case E_V2DFmode:
      if (pattern126 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 240; /* vec_srabv2df */

    case E_V4SFmode:
      if (pattern126 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
          || !(
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 241; /* vec_srabv4sf */

    case E_V1TFmode:
      if (pattern126 (x3, 
E_V1TImode, 
E_V1TFmode) != 0
          || !(
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 31 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 242; /* vec_srabv1tf */

    case E_TFmode:
      if (pattern126 (x3, 
E_V1TImode, 
E_TFmode) != 0
          || !(
#line 1133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 32 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 243; /* vec_srabtf */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 60:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !memory_operand (operands[1], E_QImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 5; /* vec_insert_and_zerov16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !memory_operand (operands[1], E_HImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 6; /* vec_insert_and_zerov8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 7; /* vec_insert_and_zerov4si */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 8; /* vec_insert_and_zerov2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !memory_operand (operands[1], E_DFmode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 9; /* vec_insert_and_zerov2df */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !memory_operand (operands[1], E_SFmode)
              || !(
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 27 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 10; /* vec_insert_and_zerov4sf */

        default:
          return -1;
        }

    case 72:
      switch (pattern47 (x3))
        {
        case 0:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 70; /* vec_extendv16qi */

        case 1:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 71; /* vec_extendv8hi */

        case 2:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 72; /* vec_extendv4si */

        default:
          return -1;
        }

    case 76:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 94; /* vec_unpackhv16qi */

        case 1:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 95; /* vec_unpackhv8hi */

        case 2:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 96; /* vec_unpackhv4si */

        default:
          return -1;
        }

    case 77:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 97; /* vec_unpackh_lv16qi */

        case 1:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 98; /* vec_unpackh_lv8hi */

        case 2:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 99; /* vec_unpackh_lv4si */

        default:
          return -1;
        }

    case 78:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 100; /* vec_unpacklv16qi */

        case 1:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 101; /* vec_unpacklv8hi */

        case 2:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 102; /* vec_unpacklv4si */

        default:
          return -1;
        }

    case 79:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 103; /* vec_unpackl_lv16qi */

        case 1:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 104; /* vec_unpackl_lv8hi */

        case 2:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 105; /* vec_unpackl_lv4si */

        default:
          return -1;
        }

    case 114:
      switch (pattern47 (x3))
        {
        case 0:
          if (!
#line 1508 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 296; /* vistrv16qi */

        case 1:
          if (!
#line 1508 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 297; /* vistrv8hi */

        case 2:
          if (!
#line 1508 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 298; /* vistrv4si */

        default:
          return -1;
        }

    case 125:
      if (GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 1860 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 322; /* vflls */

    case 132:
      if (GET_MODE (x3) != E_FPRX2mode
          || !register_operand (operands[0], E_FPRX2mode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!general_operand (operands[1], E_TFmode)
          || !
#line 914 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 569; /* tf_to_fprx2 */

    case 37:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          if (
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 806; /* popcountv16qi2_vxe */
          if (!
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 810; /* popcountv16qi2_vx */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 807; /* popcountv8hi2_vxe */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 808; /* popcountv4si2_vxe */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1266 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 809; /* popcountv2di2_vxe */

        case E_DImode:
          if (pattern103 (x3, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 11778 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 702 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2291; /* *popcountdi_z196 */

        case E_SImode:
          if (pattern103 (x3, pnum_clobbers, 
E_SImode) != 0
              || !
#line 11778 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2292; /* *popcountsi_z196 */

        case E_HImode:
          if (pattern103 (x3, pnum_clobbers, 
E_HImode) != 0
              || !
#line 11778 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2293; /* *popcounthi_z196 */

        case E_QImode:
          if (pattern103 (x3, pnum_clobbers, 
E_QImode) != 0
              || !
#line 11778 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2294; /* *popcountqi_z196 */

        default:
          return -1;
        }

    case 38:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1383; /* floorv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1388; /* floorv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1393; /* floorv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1398; /* floortf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1764; /* floortf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1769; /* floorfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1774; /* floordf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1779; /* floorsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1788; /* floortd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1793; /* floordd2 */

        default:
          return -1;
        }

    case 39:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1384; /* btruncv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1389; /* btruncv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1394; /* btruncv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1399; /* btrunctf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1765; /* btrunctf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1770; /* btruncfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1775; /* btruncdf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1780; /* btruncsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1789; /* btrunctd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1794; /* btruncdd2 */

        default:
          return -1;
        }

    case 40:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1385; /* roundv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1390; /* roundv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1395; /* roundv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1400; /* roundtf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1766; /* roundtf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1771; /* roundfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1776; /* rounddf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1781; /* roundsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1790; /* roundtd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1795; /* rounddd2 */

        default:
          return -1;
        }

    case 41:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1386; /* ceilv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1391; /* ceilv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1396; /* ceilv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1401; /* ceiltf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1767; /* ceiltf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1772; /* ceilfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1777; /* ceildf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1782; /* ceilsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1791; /* ceiltd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1796; /* ceildd2 */

        default:
          return -1;
        }

    case 42:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1387; /* nearbyintv4sf2 */

        case 1:
          if (!
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1392; /* nearbyintv2df2 */

        case 2:
          if (!(
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1397; /* nearbyintv1tf2 */

        case 3:
          if ((
#line 2898 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1402; /* nearbyinttf2_vr */
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1768; /* nearbyinttf2_fpr */

        case 4:
          if (!(
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1773; /* nearbyintfprx22 */

        case 5:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1778; /* nearbyintdf2 */

        case 6:
          if (!
#line 5611 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 1783; /* nearbyintsf2 */

        case 7:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1792; /* nearbyinttd2 */

        case 8:
          if (!
#line 5637 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1797; /* nearbyintdd2 */

        default:
          return -1;
        }

    case 43:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 2915 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1403; /* rintv4sf2 */

        case 1:
          if (!
#line 2915 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1404; /* rintv2df2 */

        case 2:
          if (!(
#line 2915 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1405; /* rintv1tf2 */

        case 3:
          if ((
#line 2915 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1406; /* rinttf2_vr */
          if (!
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE))
            return -1;
          return 1784; /* rinttf2_fpr */

        case 4:
          if (!
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE))
            return -1;
          return 1785; /* rintfprx22 */

        case 5:
          return 1786; /* rintdf2 */

        case 6:
          return 1787; /* rintsf2 */

        case 7:
          if (!
#line 5647 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1798; /* rinttd2 */

        case 8:
          if (!
#line 5647 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1799; /* rintdd2 */

        default:
          return -1;
        }

    case 30:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (pattern80 (x3))
        {
        case 0:
          return 1502; /* *get_tp_31 */

        case 1:
          if (!
#line 1976 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1503; /* *get_tp_64 */

        default:
          return -1;
        }

    case 5:
      if (GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      return 1552; /* *cc_to_int */

    case 4:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_CCUmode))
        return -1;
      *pnum_clobbers = 1;
      return 1573; /* cmpint */

    case 20:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 2240; /* mem_thread_fence_1 */

    case 21:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_DImode)
              && 
#line 10890 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2241; /* atomic_loaddi_1 */
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 10937 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2243; /* atomic_storedi_1 */

        case E_TImode:
          if (GET_MODE (x3) != E_TImode)
            return -1;
          if (register_operand (operands[0], E_TImode)
              && memory_operand (operands[1], E_TImode)
              && 
#line 10904 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2242; /* atomic_loadti_1 */
          if (!memory_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 10951 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2244; /* atomic_storeti_1 */

        default:
          return -1;
        }

    case 15:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11402 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2267; /* main_base_64 */

    case 14:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11422 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2269; /* reload_base_64 */

    case 33:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2277; /* stack_protect_setdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2278; /* stack_protect_setsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern3 (x3, 
E_V1QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 608; /* mulv1qi3 */

        case E_V2QImode:
          if (pattern3 (x3, 
E_V2QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 609; /* mulv2qi3 */

        case E_V4QImode:
          if (pattern3 (x3, 
E_V4QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 610; /* mulv4qi3 */

        case E_V8QImode:
          if (pattern3 (x3, 
E_V8QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 611; /* mulv8qi3 */

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 612; /* mulv16qi3 */

        case E_V1HImode:
          if (pattern3 (x3, 
E_V1HImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 613; /* mulv1hi3 */

        case E_V2HImode:
          if (pattern3 (x3, 
E_V2HImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 614; /* mulv2hi3 */

        case E_V4HImode:
          if (pattern3 (x3, 
E_V4HImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 615; /* mulv4hi3 */

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 616; /* mulv8hi3 */

        case E_V1SImode:
          if (pattern3 (x3, 
E_V1SImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 617; /* mulv1si3 */

        case E_V2SImode:
          if (pattern3 (x3, 
E_V2SImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 618; /* mulv2si3 */

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0
              || !
#line 1129 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 619; /* mulv4si3 */

        case E_V4SFmode:
          if (pattern3 (x3, 
E_V4SFmode) != 0
              || !(
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1091; /* mulv4sf3 */

        case E_V2DFmode:
          if (pattern3 (x3, 
E_V2DFmode) != 0
              || !
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1092; /* mulv2df3 */

        case E_V1TFmode:
          if (pattern3 (x3, 
E_V1TFmode) != 0
              || !(
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1093; /* mulv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1094; /* multf3_vr */
          if (!nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 7283 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1975; /* multf3_fpr */

        case E_FPRX2mode:
          if (pattern174 (x3, 
E_FPRX2mode) != 0
              || !(
#line 7283 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1976; /* mulfprx23 */

        case E_DFmode:
          if (pattern174 (x3, 
E_DFmode) != 0
              || !
#line 7283 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1977; /* muldf3 */

        case E_SFmode:
          if (pattern174 (x3, 
E_SFmode) != 0
              || !
#line 7283 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1978; /* mulsf3 */

        case E_TDmode:
          if (pattern174 (x3, 
E_TDmode) != 0
              || !(
#line 7283 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1979; /* multd3 */

        case E_DDmode:
          if (pattern174 (x3, 
E_DDmode) != 0
              || !(
#line 7283 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1980; /* muldd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_TImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (nonimmediate_operand (operands[2], E_DImode)
          && register_operand (operands[1], E_DImode)
          && 
#line 7136 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return 1965; /* mulditi3 */
      if (!register_operand (operands[2], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !
#line 7149 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return -1;
      return 1966; /* mulditi3_2 */

    case ZERO_EXTEND:
      if (pattern110 (x3, 
E_DImode, 
E_TImode) != 0
          || !
#line 689 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1973; /* umulditi3 */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern33 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 620; /* negv1qi2 */

        case 1:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 621; /* negv2qi2 */

        case 2:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 622; /* negv4qi2 */

        case 3:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 623; /* negv8qi2 */

        case 4:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 624; /* negv16qi2 */

        case 5:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 625; /* negv1hi2 */

        case 6:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 626; /* negv2hi2 */

        case 7:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 627; /* negv4hi2 */

        case 8:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 628; /* negv8hi2 */

        case 9:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 629; /* negv1si2 */

        case 10:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 630; /* negv2si2 */

        case 11:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 631; /* negv4si2 */

        case 12:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 632; /* negv1di2 */

        case 13:
          if (!
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 633; /* negv2di2 */

        case 14:
          if (!(
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1119; /* negv1sf2 */

        case 15:
          if (!(
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1120; /* negv2sf2 */

        case 16:
          if (!(
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1121; /* negv4sf2 */

        case 17:
          if (!
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1122; /* negv1df2 */

        case 18:
          if (!
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1123; /* negv2df2 */

        case 19:
          if (!(
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1124; /* negv1tf2 */

        case 20:
          if ((
#line 1805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1125; /* negtf2_vr */
          if ((
#line 8959 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2089; /* *negtf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2095; /* *negtf2 */

        case 21:
          if (
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 2078; /* *negdi2 */
            }
          if (!
#line 8848 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2080; /* *negdi2_31 */

        case 22:
          *pnum_clobbers = 1;
          return 2079; /* *negsi2 */

        case 23:
          if ((
#line 8959 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2090; /* *negfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2096; /* *negfprx22 */

        case 24:
          if (
#line 8959 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2091; /* *negdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2097; /* *negdf2 */

        case 25:
          if (
#line 8959 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2092; /* *negsf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2098; /* *negsf2 */

        case 26:
          if (!(
#line 8959 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2093; /* *negtd2_nocc */

        case 27:
          if (!(
#line 8959 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2094; /* *negdd2_nocc */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern155 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1786 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1111; /* neg_fmav4sf4 */

            case E_V2DFmode:
              if (pattern155 (x3, 
E_V2DFmode) != 0
                  || !
#line 1786 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1112; /* neg_fmav2df4 */

            case E_V1TFmode:
              if (pattern155 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1786 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1113; /* neg_fmav1tf4 */

            case E_TFmode:
              if (pattern155 (x3, 
E_TFmode) != 0
                  || !(
#line 1786 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1114; /* neg_fmatf4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern156 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1797 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1115; /* neg_fmsv4sf4 */

            case E_V2DFmode:
              if (pattern156 (x3, 
E_V2DFmode) != 0
                  || !
#line 1797 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1116; /* neg_fmsv2df4 */

            case E_V1TFmode:
              if (pattern156 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1797 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1117; /* neg_fmsv1tf4 */

            case E_TFmode:
              if (pattern156 (x3, 
E_TFmode) != 0
                  || !(
#line 1797 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1118; /* neg_fmstf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V1SFmode:
              if (pattern108 (x3, 
E_V1SFmode) != 0
                  || !(
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1133; /* negabsv1sf2 */

            case E_V2SFmode:
              if (pattern108 (x3, 
E_V2SFmode) != 0
                  || !(
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1134; /* negabsv2sf2 */

            case E_V4SFmode:
              if (pattern108 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1135; /* negabsv4sf2 */

            case E_V1DFmode:
              if (pattern108 (x3, 
E_V1DFmode) != 0
                  || !
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1136; /* negabsv1df2 */

            case E_V2DFmode:
              if (pattern108 (x3, 
E_V2DFmode) != 0
                  || !
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1137; /* negabsv2df2 */

            case E_V1TFmode:
              if (pattern108 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1138; /* negabsv1tf2 */

            case E_TFmode:
              if (pattern108 (x3, 
E_TFmode) != 0)
                return -1;
              if ((
#line 1833 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1139; /* negabstf2 */
              if ((
#line 9200 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2141; /* *negabstf2_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9211 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2147; /* *negabstf2 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern108 (x3, 
E_DImode) != 0
                  || !
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2131; /* *negabsdi2 */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern108 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2132; /* *negabssi2 */

            case E_FPRX2mode:
              if (pattern108 (x3, 
E_FPRX2mode) != 0)
                return -1;
              if ((
#line 9200 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2142; /* *negabsfprx22_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9211 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2148; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern108 (x3, 
E_DFmode) != 0)
                return -1;
              if (
#line 9200 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2143; /* *negabsdf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9211 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2149; /* *negabsdf2 */

            case E_SFmode:
              if (pattern108 (x3, 
E_SFmode) != 0)
                return -1;
              if (
#line 9200 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2144; /* *negabssf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9211 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2150; /* *negabssf2 */

            case E_TDmode:
              if (pattern108 (x3, 
E_TDmode) != 0
                  || !(
#line 9200 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2145; /* *negabstd2_nocc */

            case E_DDmode:
              if (pattern108 (x3, 
E_DDmode) != 0
                  || !(
#line 9200 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2146; /* *negabsdd2_nocc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9131 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2126; /* *negabsdi2_sign */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 8806 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2073; /* *negdi2_sign */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2805 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1377; /* floatunsv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 2805 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1378; /* floatunsv4siv4sf2 */

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (
#line 5439 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 1734; /* *floatunsdidf2_z13 */
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || DImode != DImode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1740; /* *floatunsdidf2 */

        case 1:
          if (!
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || SImode != DImode)))
            return -1;
          return 1741; /* *floatunssidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 5439 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 674 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 1735; /* *floatunssisf2_z13 */
          if (!
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || SImode != DImode)))
            return -1;
          return 1743; /* *floatunssisf2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || DImode != DImode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1742; /* *floatunsdisf2 */

        default:
          return -1;
        }

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || DImode != DImode)) && (
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1736; /* *floatunsditf2 */

        case 1:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || SImode != DImode)) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1737; /* *floatunssitf2 */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || DImode != DImode)) && (
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1738; /* *floatunsdifprx22 */

        case 1:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || SImode != DImode)) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1739; /* *floatunssifprx22 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || DImode != DImode)) && (
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1744; /* *floatunsditd2 */

        case 1:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || SImode != DImode)) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1745; /* *floatunssitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || DImode != DImode)) && (
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 1746; /* *floatunsdidd2 */

        case 1:
          if (!(
#line 5451 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || SImode != DImode)) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1747; /* *floatunssidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x9))
            {
            case SET:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != MINUS
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != ZERO_EXTEND
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x13 = XEXP (x10, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[2])
                  || !
#line 6441 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 1898; /* *subdi3_zero_cc */

            case CLOBBER:
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 6454 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 1899; /* *subdi3_zero_cconly */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              switch (pattern226 (x1))
                {
                case 0:
                  if (!(
#line 6551 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1905; /* *subdi3_borrow_cc */

                case 1:
                  if (!
#line 6551 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  return 1906; /* *subsi3_borrow_cc */

                case 2:
                  if (!(
#line 6568 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1907; /* *subdi3_borrow_cconly */

                case 3:
                  if (!
#line 6568 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  return 1908; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern226 (x1))
                    {
                    case 0:
                      if ((
#line 6586 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 1909; /* *subdi3_cc */
                      break;

                    case 1:
                      if (
#line 6586 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        return 1910; /* *subsi3_cc */
                      break;

                    case 2:
                      if ((
#line 6620 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 1913; /* *subdi3_cconly */
                      break;

                    case 3:
                      if (
#line 6620 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        return 1914; /* *subsi3_cconly */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x7;
              x9 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x9))
                {
                case SET:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != MINUS)
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  x13 = XEXP (x10, 0);
                  if (!rtx_equal_p (x13, operands[1]))
                    return -1;
                  x11 = XEXP (x10, 1);
                  if (!rtx_equal_p (x11, operands[2]))
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern272 (x10, 
E_TFmode) != 0
                          || !(
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 1926; /* *subtf3_cc */

                    case E_FPRX2mode:
                      if (pattern272 (x10, 
E_FPRX2mode) != 0
                          || !(
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 1927; /* *subfprx23_cc */

                    case E_DFmode:
                      if (pattern272 (x10, 
E_DFmode) != 0
                          || !
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 1928; /* *subdf3_cc */

                    case E_SFmode:
                      if (pattern272 (x10, 
E_SFmode) != 0
                          || !
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 1929; /* *subsf3_cc */

                    case E_TDmode:
                      if (pattern272 (x10, 
E_TDmode) != 0
                          || !(
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 1930; /* *subtd3_cc */

                    case E_DDmode:
                      if (pattern272 (x10, 
E_DDmode) != 0
                          || !(
#line 6723 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 1931; /* *subdd3_cc */

                    default:
                      return -1;
                    }

                case CLOBBER:
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern254 (
E_TFmode) != 0
                          || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 1932; /* *subtf3_cconly */

                    case E_FPRX2mode:
                      if (pattern254 (
E_FPRX2mode) != 0
                          || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 1933; /* *subfprx23_cconly */

                    case E_DFmode:
                      if (pattern254 (
E_DFmode) != 0
                          || !
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 1934; /* *subdf3_cconly */

                    case E_SFmode:
                      if (pattern254 (
E_SFmode) != 0
                          || !
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 1935; /* *subsf3_cconly */

                    case E_TDmode:
                      if (pattern254 (
E_TDmode) != 0
                          || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 1936; /* *subtd3_cconly */

                    case E_DDmode:
                      if (pattern254 (
E_DDmode) != 0
                          || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 1937; /* *subdd3_cconly */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern144 (x1, 
MINUS))
        {
        case 0:
          if (pattern282 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 6681 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1918; /* *subvdi3_ccoverflow */

        case 1:
          if (pattern282 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 6681 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
            return -1;
          return 1919; /* *subvsi3_ccoverflow */

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != MINUS)
        return -1;
      x13 = XEXP (x10, 0);
      if (GET_CODE (x13) != MINUS)
        return -1;
      x15 = XEXP (x5, 0);
      operands[1] = x15;
      x16 = XEXP (x5, 1);
      operands[2] = x16;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      x17 = XEXP (x13, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x13, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x11 = XEXP (x10, 1);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (pattern273 (x1, 
E_DImode) != 0
              || !(
#line 6867 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1950; /* *subdi3_slb_cc */

        case E_SImode:
          if (pattern273 (x1, 
E_SImode) != 0
              || !
#line 6867 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          return 1951; /* *subsi3_slb_cc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern92 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern248 (x4, 
E_DImode) != 0
                  || !(
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1635; /* *rxsbg_di_noshift */

            case E_SImode:
              if (pattern248 (x4, 
E_SImode) != 0
                  || !
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1637; /* *rxsbg_si_noshift */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4495 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1639; /* *rxsbg_di_rotl */

        case 2:
          if (!(
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1641; /* *rxsbg_di_srl_bitmask */

        case 3:
          if (!
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1643; /* *rxsbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1645; /* *rxsbg_di_sll_bitmask */

        case 5:
          if (!
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1647; /* *rxsbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern95 (x1))
        {
        case 0:
          if (!(
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1649; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1651; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern95 (x1))
        {
        case 0:
          if (!(
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1653; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1655; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern116 (x1) == 0
          && 
#line 4587 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 1657; /* *rxsbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern117 (x1) == 0
          && 
#line 8651 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2064; /* *xc */
        }
      operands[1] = x5;
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 8495 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2058; /* *xordi3 */

        case 1:
          if (!
#line 8565 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2061; /* *xorsi3 */

        case 2:
          if (!
#line 8598 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2062; /* *xorhi3 */

        case 3:
          if (!
#line 8628 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2063; /* *xorqi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MEM
      || pattern97 (x4) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  switch (pattern256 (x1))
    {
    case 0:
      if (!(
#line 3496 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 1548; /* *cpymem_long */

    case 1:
      if (!(
#line 3496 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 1549; /* *cpymem_long */

    case 2:
      if (!
#line 3509 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
        return -1;
      return 1550; /* *cpymem_long_31z */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (pnum_clobbers == NULL
              || pattern97 (x4) != 0)
            return -1;
          switch (pattern256 (x1))
            {
            case 0:
              if (!(
#line 3496 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1548; /* *cpymem_long */

            case 1:
              if (!(
#line 3496 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1549; /* *cpymem_long */

            case 2:
              if (!
#line 3509 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 1550; /* *cpymem_long_31z */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x9) != E_CCUmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG)
            return -1;
          x12 = XEXP (x9, 1);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SUBREG)
            return -1;
          x14 = XEXP (x4, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 33
              || GET_MODE (x14) != E_CCUmode)
            return -1;
          x15 = XEXP (x11, 0);
          operands[2] = x15;
          x16 = XEXP (x13, 0);
          operands[3] = x16;
          x17 = XEXP (x5, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x6, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (SUBREG_BYTE (x11))
            {
            case 0:
              if (maybe_ne (SUBREG_BYTE (x13), 0))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_TImode:
                  if (pattern291 (x9, 
E_TImode, 
E_DImode) != 0
                      || !(
#line 3946 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                    return -1;
                  return 1570; /* *cmpmem_long */

                case E_DImode:
                  if (pattern291 (x9, 
E_DImode, 
E_SImode) != 0
                      || !(
#line 3946 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                    return -1;
                  return 1571; /* *cmpmem_long */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x11) != E_SImode
                  || maybe_ne (SUBREG_BYTE (x13), 4)
                  || GET_MODE (x13) != E_SImode
                  || !register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !register_operand (operands[2], E_TImode)
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 3959 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1572; /* *cmpmem_long_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x19 = XEXP (x2, 1);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 0L)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE
              || pattern102 (x1) != 0
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x5, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[3]))
            {
            case E_DImode:
              if (!scratch_operand (operands[3], E_DImode)
                  || !(
#line 3644 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1560; /* *clrmem_short */

            case E_SImode:
              if (!scratch_operand (operands[3], E_SImode)
                  || !(
#line 3644 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1561; /* *clrmem_short */

            default:
              return -1;
            }

        case LABEL_REF:
          if (pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[2] = x20;
          switch (pattern269 (x1))
            {
            case 0:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2315; /* split_stack_calldi */

            case 1:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2316; /* split_stack_callsi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != LABEL_REF)
            return -1;
          x22 = XEXP (x19, 2);
          if (GET_CODE (x22) != PC
              || pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[5] = x20;
          x23 = XEXP (x21, 0);
          operands[2] = x23;
          switch (pattern269 (x1))
            {
            case 0:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2317; /* split_stack_cond_calldi */

            case 1:
              if (!
#line 685 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2318; /* split_stack_cond_callsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      switch (pattern36 (x1))
        {
        case 0:
          if (!(
#line 990 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 995 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_44 (insn, operands);

        case 1:
          if (!(
#line 1060 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1065 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_46 (insn, operands);

        case 2:
          if (!(
#line 1060 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1065 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_47 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return NULL;
      switch (pattern163 (x3))
        {
        case 0:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V8HImode)
   && !memory_operand (operands[1], V8HImode))))
            return NULL;
          return gen_split_132 (insn, operands);

        case 1:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V4SImode)
   && !memory_operand (operands[1], V4SImode))))
            return NULL;
          return gen_split_133 (insn, operands);

        case 2:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V4SFmode)
   && !memory_operand (operands[1], V4SFmode))))
            return NULL;
          return gen_split_134 (insn, operands);

        case 3:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V2DImode)
   && !memory_operand (operands[1], V2DImode))))
            return NULL;
          return gen_split_135 (insn, operands);

        case 4:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V2DFmode)
   && !memory_operand (operands[1], V2DFmode))))
            return NULL;
          return gen_split_136 (insn, operands);

        case 5:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V1TImode)
   && !memory_operand (operands[1], V1TImode))))
            return NULL;
          return gen_split_137 (insn, operands);

        case 6:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V1TFmode)
   && !memory_operand (operands[1], V1TFmode))))
            return NULL;
          return gen_split_138 (insn, operands);

        case 7:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], TImode)
   && !memory_operand (operands[1], TImode))))
            return NULL;
          return gen_split_139 (insn, operands);

        case 8:
          if (!(
#line 3189 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3194 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], TFmode)
   && !memory_operand (operands[1], TFmode))))
            return NULL;
          return gen_split_140 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      if (pattern38 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (GET_CODE (x8) == CONST_INT
                  && XWINT (x8, 0) == 2147483647L
                  && register_operand (operands[0], E_SImode)
                  && GET_MODE (x3) == E_SImode)
                {
                  operands[1] = x6;
                  if (address_operand (operands[1], E_QImode)
                      && (
#line 2387 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT) && 
#line 2389 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return gen_split_154 (insn, operands);
                  if (nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 4980 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed))
                    return gen_split_206 (insn, operands);
                }
              operands[1] = x8;
              if (rtx_equal_p (x6, operands[0]))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (s_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && immediate_operand (operands[1], E_SImode)
                          && 
#line 7841 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return gen_split_222 (insn, operands);
                      break;

                    case E_HImode:
                      if (s_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && immediate_operand (operands[1], E_HImode)
                          && 
#line 7886 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return gen_split_223 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case SUBREG:
            case MEM:
              operands[1] = x8;
              if (memory_operand (operands[1], E_VOIDmode)
                  && memory_operand (operands[0], E_VOIDmode)
                  && rtx_equal_p (x6, operands[0])
                  && 
#line 7978 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
                return gen_split_226 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x8) == CONST_INT
              && XWINT (x8, 0) == 2147483647L
              && register_operand (operands[0], E_DImode)
              && GET_MODE (x3) == E_DImode)
            {
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 0)
                  && GET_MODE (x6) == E_DImode)
                {
                  x9 = XEXP (x6, 0);
                  operands[1] = x9;
                  if (memory_operand (operands[1], E_SImode)
                      && (
#line 4945 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4947 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return gen_split_204 (insn, operands);
                }
              operands[1] = x6;
              if (nonimmediate_operand (operands[1], E_DImode)
                  && 
#line 4980 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed))
                return gen_split_205 (insn, operands);
            }
          if (!rtx_equal_p (x6, operands[0])
              || !s_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          operands[1] = x8;
          if (!immediate_operand (operands[1], E_DImode)
              || !
#line 7701 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_221 (insn, operands);

        case NOT:
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern231 (x3, 
E_DImode) != 0
                  || !((
#line 7936 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 7943 "../../gcc/config/s390/s390.md"
( 1)))
                return NULL;
              return gen_split_224 (insn, operands);

            case E_SImode:
              if (pattern231 (x3, 
E_SImode) != 0
                  || !(
#line 7936 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 7943 "../../gcc/config/s390/s390.md"
( 1)))
                return NULL;
              return gen_split_225 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 4
          || pattern101 (x1) != 0)
        return NULL;
      x10 = XVECEXP (x3, 0, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_CCUmode)
          || !
#line 3975 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_190 (insn, operands);

    case COMPARE:
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 33)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 4
              || GET_MODE (x6) != E_SImode
              || pattern210 (x1) != 0
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x4, 1);
          x12 = XVECEXP (x11, 0, 0);
          if (!rtx_equal_p (x12, operands[1])
              || !(
#line 3988 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)) && 
#line 3990 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_191 (insn, operands);

        case ASHIFTRT:
          if (GET_MODE (x6) != E_DImode)
            return NULL;
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != ASHIFT
              || GET_MODE (x9) != E_DImode)
            return NULL;
          x13 = XEXP (x9, 0);
          if (GET_CODE (x13) != SUBREG
              || maybe_ne (SUBREG_BYTE (x13), 0)
              || GET_MODE (x13) != E_DImode)
            return NULL;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != UNSPEC
              || XVECLEN (x14, 0) != 1
              || XINT (x14, 1) != 4
              || GET_MODE (x14) != E_SImode)
            return NULL;
          x15 = XEXP (x9, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return NULL;
          x16 = XEXP (x6, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return NULL;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != SIGN_EXTEND
              || GET_MODE (x11) != E_DImode
              || pattern289 (x1) != 0
              || !register_operand (operands[0], E_DImode))
            return NULL;
          x17 = XEXP (x11, 0);
          x18 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x18, operands[1])
              || !(
#line 4023 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_ZARCH) && 
#line 4025 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_193 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      x19 = XEXP (x3, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern72 (x1))
        {
        case 0:
          if (!((
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 4212 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 1:
          if (!(
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 4212 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x19 = XEXP (x3, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4237 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 1:
          if (!
#line 4237 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_197 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      if (pattern38 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case LSHIFTRT:
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != ASHIFT)
            return NULL;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x16 = XEXP (x6, 1);
          operands[2] = x16;
          x20 = XEXP (x8, 0);
          operands[3] = x20;
          x21 = XEXP (x8, 1);
          operands[4] = x21;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern257 (x3, 
E_DImode) != 0
                  || !(
#line 4452 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return NULL;
              return gen_split_200 (insn, operands);

            case E_SImode:
              if (pattern257 (x3, 
E_SImode) != 0
                  || !
#line 4452 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
                return NULL;
              return gen_split_201 (insn, operands);

            default:
              return NULL;
            }

        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x6, operands[0]))
            return NULL;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          switch (pattern194 (x3))
            {
            case 0:
              if (!
#line 8104 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_227 (insn, operands);

            case 1:
              if (!
#line 8195 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_228 (insn, operands);

            case 2:
              if (!
#line 8238 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_229 (insn, operands);

            case 3:
              if (!
#line 8388 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
                return NULL;
              return gen_split_230 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern46 (x1))
        {
        case 0:
          if (pattern213 (x3, 
E_TImode) != 0
              || !(
#line 5840 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 5842 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_210 (insn, operands);

        case 1:
          if (pattern118 (x3, 
E_DImode) != 0
              || !(
#line 5931 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5933 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_211 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      switch (pattern46 (x1))
        {
        case 0:
          if (pattern218 (x3, 
E_TImode) != 0
              || !(
#line 6387 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6389 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_212 (insn, operands);

        case 1:
          if (pattern218 (x3, 
E_DImode) != 0
              || !(
#line 6478 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 6480 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_213 (insn, operands);

        default:
          return NULL;
        }

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern38 (x1) != 0)
        return NULL;
      switch (GET_CODE (x3))
        {
        case SIGN_EXTEND:
          switch (pattern182 (x3))
            {
            case 0:
              if ((
#line 4006 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4008 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_192 (insn, operands);
              break;

            case 1:
              if (((
#line 4880 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 4882 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_202 (insn, operands);
              break;

            case 2:
              if ((
#line 4880 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 4882 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_203 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          if (GET_MODE (x3) == E_SImode
              && register_operand (operands[0], E_SImode))
            {
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (s_operand (operands[1], E_HImode)
                  && (
#line 5065 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5067 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_207 (insn, operands);
            }
          break;

        default:
          break;
        }
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          if (s390_alc_comparison (operands[1], E_DImode)
              && (
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6909 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return gen_split_214 (insn, operands);
          if (!s390_slb_comparison (operands[1], E_DImode)
              || !(
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6923 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_216 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          if (s390_alc_comparison (operands[1], E_SImode)
              && 
#line 6909 "../../gcc/config/s390/s390.md"
( reload_completed))
            return gen_split_215 (insn, operands);
          if (!s390_slb_comparison (operands[1], E_SImode)
              || !
#line 6923 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_217 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern39 (x4) != 0)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_CCZ1mode)
          || !
#line 6981 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_218 (insn, operands);

    case XOR:
      if (pattern38 (x1) != 0)
        return NULL;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return NULL;
      switch (pattern194 (x3))
        {
        case 0:
          if (!
#line 8513 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_235 (insn, operands);

        case 1:
          if (!
#line 8583 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_236 (insn, operands);

        case 2:
          if (!
#line 8613 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_237 (insn, operands);

        case 3:
          if (!
#line 8660 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
            return NULL;
          return gen_split_238 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      if (pattern40 (x1) != 0)
        return NULL;
      if (
#line 8861 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && reload_completed
   && ((REG_P (operands[0]) && REG_P (operands[1])
       && REGNO (operands[0]) == REGNO (operands[1]))
      || s390_split_ok_p (operands[0], operands[1], DImode, 0))))
        return gen_split_239 (insn, operands);
      if (!
#line 8894 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)
   && reload_completed))
        return NULL;
      return gen_split_240 (insn, operands);

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      if (!s390_eqne_operator (x6, E_VOIDmode))
        return NULL;
      operands[0] = x6;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 33
          || GET_MODE (x9) != E_CCRAWmode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != LABEL_REF)
        return NULL;
      x19 = XEXP (x3, 2);
      if (GET_CODE (x19) != PC)
        return NULL;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != PC)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET
          || pattern232 (x1) != 0)
        return NULL;
      return gen_split_249 (insn, operands);

    default:
      return NULL;
    }
}
