/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern17 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern17 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern17 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern17 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          if (!register_operand (operands[1], E_V1QImode)
              || !register_operand (operands[2], E_V1QImode))
            return -1;
          return 0;

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2QImode)
              || !register_operand (operands[2], E_V2QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (pattern14 (x3, 
E_V4QImode, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern14 (x3, 
E_V8QImode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern14 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          if (!register_operand (operands[1], E_V1HImode)
              || !register_operand (operands[2], E_V1HImode))
            return -1;
          return 5;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode)
              || !register_operand (operands[2], E_V2HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern14 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern14 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          if (!register_operand (operands[1], E_V1SImode)
              || !register_operand (operands[2], E_V1SImode))
            return -1;
          return 9;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern14 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern54 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern54 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern61 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern61 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  return 0;
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 26)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != LABEL_REF)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != USE)
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern99 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern112 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern112 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern118 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern118 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern118 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern118 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (XWINT (x5, 0) != 64L)
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern134 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern134 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  return 0;
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern149 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_DImode:
              if (!immediate_operand (operands[2], E_DImode))
                return -1;
              return 6;

            case E_SImode:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 10;

        case E_TDmode:
          if (!register_operand (operands[1], E_TDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 11;

        case E_DDmode:
          if (!register_operand (operands[1], E_DDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonmemory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[4]))
    {
    case E_DImode:
      if (!scratch_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern203 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 5
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  operands[1] = x8;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x6, 1);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  x11 = XEXP (x2, 0);
  operands[3] = x11;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern254 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern286 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern295 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 13);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern22 (x1))
    {
    case 0:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 222; /* vec_sralv16qiv16qi */

    case 1:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 226; /* vec_sralv16qiv8hi */

    case 2:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 230; /* vec_sralv16qiv4si */

    case 3:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 223; /* vec_sralv8hiv16qi */

    case 4:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 227; /* vec_sralv8hiv8hi */

    case 5:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 231; /* vec_sralv8hiv4si */

    case 6:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 224; /* vec_sralv4siv16qi */

    case 7:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 228; /* vec_sralv4siv8hi */

    case 8:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 232; /* vec_sralv4siv4si */

    case 9:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 225; /* vec_sralv2div16qi */

    case 10:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 229; /* vec_sralv2div8hi */

    case 11:
      if (!
#line 1121 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 233; /* vec_sralv2div4si */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_DImode
      || pattern108 (x2, 
E_SImode) != 0
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4383 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
    return 1628; /* *risbgn_sidi_ior_and_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4383 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
    return -1;
  *pnum_clobbers = 1;
  return 1629; /* *risbg_sidi_ior_and_lshiftrt */
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern128 (x2, 
E_V1QImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 674; /* notandv1qi3 */

        case E_V2QImode:
          if (pattern128 (x2, 
E_V2QImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 675; /* notandv2qi3 */

        case E_V4QImode:
          if (pattern128 (x2, 
E_V4QImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 676; /* notandv4qi3 */

        case E_V8QImode:
          if (pattern128 (x2, 
E_V8QImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 677; /* notandv8qi3 */

        case E_V16QImode:
          if (pattern128 (x2, 
E_V16QImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 678; /* notandv16qi3 */

        case E_V1HImode:
          if (pattern128 (x2, 
E_V1HImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 679; /* notandv1hi3 */

        case E_V2HImode:
          if (pattern128 (x2, 
E_V2HImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 680; /* notandv2hi3 */

        case E_V4HImode:
          if (pattern128 (x2, 
E_V4HImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 681; /* notandv4hi3 */

        case E_V8HImode:
          if (pattern128 (x2, 
E_V8HImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 682; /* notandv8hi3 */

        case E_V1SImode:
          if (pattern128 (x2, 
E_V1SImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 683; /* notandv1si3 */

        case E_V2SImode:
          if (pattern128 (x2, 
E_V2SImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 684; /* notandv2si3 */

        case E_V4SImode:
          if (pattern128 (x2, 
E_V4SImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 685; /* notandv4si3 */

        case E_V1DImode:
          if (pattern128 (x2, 
E_V1DImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 686; /* notandv1di3 */

        case E_V2DImode:
          if (pattern128 (x2, 
E_V2DImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 687; /* notandv2di3 */

        case E_V1SFmode:
          if (pattern128 (x2, 
E_V1SFmode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 688; /* notandv1sf3 */

        case E_V2SFmode:
          if (pattern128 (x2, 
E_V2SFmode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 689; /* notandv2sf3 */

        case E_V4SFmode:
          if (pattern128 (x2, 
E_V4SFmode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 690; /* notandv4sf3 */

        case E_V1DFmode:
          if (pattern128 (x2, 
E_V1DFmode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 691; /* notandv1df3 */

        case E_V2DFmode:
          if (pattern128 (x2, 
E_V2DFmode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 692; /* notandv2df3 */

        case E_V1TFmode:
          if (pattern128 (x2, 
E_V1TFmode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 693; /* notandv1tf3 */

        case E_V1TImode:
          if (pattern128 (x2, 
E_V1TImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 694; /* notandv1ti3 */

        case E_TImode:
          if (pattern128 (x2, 
E_TImode) != 0
              || !
#line 1194 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 695; /* notandti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern128 (x2, 
E_DImode) != 0
              || !(
#line 8355 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2050; /* *nanddi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern128 (x2, 
E_SImode) != 0
              || !
#line 8355 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2052; /* *nandsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern82 (x2, 
E_V1QImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 718; /* ior_notv1qi3 */

        case E_V2QImode:
          if (pattern82 (x2, 
E_V2QImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 719; /* ior_notv2qi3 */

        case E_V4QImode:
          if (pattern82 (x2, 
E_V4QImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 720; /* ior_notv4qi3 */

        case E_V8QImode:
          if (pattern82 (x2, 
E_V8QImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 721; /* ior_notv8qi3 */

        case E_V16QImode:
          if (pattern82 (x2, 
E_V16QImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 722; /* ior_notv16qi3 */

        case E_V1HImode:
          if (pattern82 (x2, 
E_V1HImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 723; /* ior_notv1hi3 */

        case E_V2HImode:
          if (pattern82 (x2, 
E_V2HImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 724; /* ior_notv2hi3 */

        case E_V4HImode:
          if (pattern82 (x2, 
E_V4HImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 725; /* ior_notv4hi3 */

        case E_V8HImode:
          if (pattern82 (x2, 
E_V8HImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 726; /* ior_notv8hi3 */

        case E_V1SImode:
          if (pattern82 (x2, 
E_V1SImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 727; /* ior_notv1si3 */

        case E_V2SImode:
          if (pattern82 (x2, 
E_V2SImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 728; /* ior_notv2si3 */

        case E_V4SImode:
          if (pattern82 (x2, 
E_V4SImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 729; /* ior_notv4si3 */

        case E_V1DImode:
          if (pattern82 (x2, 
E_V1DImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 730; /* ior_notv1di3 */

        case E_V2DImode:
          if (pattern82 (x2, 
E_V2DImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 731; /* ior_notv2di3 */

        case E_V1SFmode:
          if (pattern82 (x2, 
E_V1SFmode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 732; /* ior_notv1sf3 */

        case E_V2SFmode:
          if (pattern82 (x2, 
E_V2SFmode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 733; /* ior_notv2sf3 */

        case E_V4SFmode:
          if (pattern82 (x2, 
E_V4SFmode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 734; /* ior_notv4sf3 */

        case E_V1DFmode:
          if (pattern82 (x2, 
E_V1DFmode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 735; /* ior_notv1df3 */

        case E_V2DFmode:
          if (pattern82 (x2, 
E_V2DFmode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 736; /* ior_notv2df3 */

        case E_V1TFmode:
          if (pattern82 (x2, 
E_V1TFmode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 737; /* ior_notv1tf3 */

        case E_V1TImode:
          if (pattern82 (x2, 
E_V1TImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 738; /* ior_notv1ti3 */

        case E_TImode:
          if (pattern82 (x2, 
E_TImode) != 0
              || !
#line 1214 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 739; /* ior_notti3 */

        case E_DImode:
          if (pattern83 (x2, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8315 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2038; /* *orcdi */

        case E_SImode:
          if (pattern83 (x2, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8315 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2040; /* *orcsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_23 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (x3))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && immediate_operand (operands[1], E_QImode)
                  && immediate_operand (operands[2], E_QImode)
                  && 
#line 923 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], false))))
                return 1423; /* *tmqi_mem */
              break;

            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && immediate_operand (operands[1], E_DImode)
                  && immediate_operand (operands[2], E_DImode)
                  && 
#line 937 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], DImode, HImode, 0) >= 0))
                return 1424; /* *tmdi_reg */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && immediate_operand (operands[2], E_SImode)
                  && 
#line 953 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], SImode, HImode, 0) >= 0))
                return 1425; /* *tmsi_reg */
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x5;
          switch (pattern154 (x3))
            {
            case 0:
              if (!
#line 7642 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 1997; /* *anddi3_cconly */

            case 1:
              if (!
#line 7770 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2008; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x2, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern132 (x3))
            {
            case 0:
              if (!(
#line 8305 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2033; /* *andcdi_cconly */

            case 1:
              if (!
#line 8305 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2035; /* *andcsi_cconly */

            case 2:
              if (!(
#line 8345 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2045; /* *nordi_cconly */

            case 3:
              if (!
#line 8345 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2047; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_DImode)
                  || !
#line 1207 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_ZARCH))
                return -1;
              return 1449; /* *cmpdi_ccs_sign */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 1247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1452; /* *cmpdi_ccs_signhi_rl */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 1247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10))
                    return -1;
                  return 1453; /* *cmpdi_ccs_signhi_rl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SImode:
          if (!memory_operand (operands[1], E_HImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 1223 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode)))
            return -1;
          return 1450; /* *cmpsi_ccs_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) == MEM
          && GET_MODE (x4) == E_HImode)
        {
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (larl_operand (operands[1], E_SImode)
                      && 
#line 1285 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1456; /* *cmpsi_ccu_zerohi_rlsi */
                  if (larl_operand (operands[1], E_DImode)
                      && 
#line 1298 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1458; /* *cmpsi_ccu_zerohi_rldi */
                }
              break;

            case E_DImode:
              if (larl_operand (operands[1], E_DImode)
                  && register_operand (operands[0], E_DImode)
                  && (
#line 1298 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1457; /* *cmpdi_ccu_zerohi_rldi */
              break;

            default:
              break;
            }
        }
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 1310 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCURmode) && TARGET_ZARCH))
        return -1;
      return 1459; /* *cmpdi_ccu_zero */

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != AND
              || GET_MODE (x5) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x10 = XEXP (x5, 1);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_DImode)
              || !
#line 4335 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 1619; /* *insv_z10_noshift_cconly */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (pattern154 (x3))
            {
            case 0:
              if (!
#line 8056 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2019; /* *iordi3_cconly */

            case 1:
              if (!
#line 8138 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2022; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern132 (x3))
            {
            case 0:
              if (!(
#line 8305 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2034; /* *orcdi_cconly */

            case 1:
              if (!
#line 8305 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2036; /* *orcsi_cconly */

            case 2:
              if (!(
#line 8345 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2046; /* *nanddi_cconly */

            case 3:
              if (!
#line 8345 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2048; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_24 (x1, insn, pnum_clobbers);

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x2, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 6454 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1899; /* *subdi3_zero_cconly */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x6, operands[1]))
                return -1;
              switch (pattern188 (x3))
                {
                case 0:
                  if (!(
#line 6568 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1907; /* *subdi3_borrow_cconly */

                case 1:
                  if (!
#line 6568 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1908; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern188 (x3))
                    {
                    case 0:
                      if ((
#line 6620 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        {
                          *pnum_clobbers = 1;
                          return 1913; /* *subdi3_cconly */
                        }
                      break;

                    case 1:
                      if (
#line 6620 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        {
                          *pnum_clobbers = 1;
                          return 1914; /* *subsi3_cconly */
                        }
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (x3))
                {
                case E_TFmode:
                  if (!nonimmediate_operand (operands[1], E_TFmode)
                      || !general_operand (operands[2], E_TFmode)
                      || !const0_operand (operands[3], E_TFmode)
                      || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1932; /* *subtf3_cconly */

                case E_FPRX2mode:
                  if (!nonimmediate_operand (operands[1], E_FPRX2mode)
                      || !general_operand (operands[2], E_FPRX2mode)
                      || !const0_operand (operands[3], E_FPRX2mode)
                      || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1933; /* *subfprx23_cconly */

                case E_DFmode:
                  if (!nonimmediate_operand (operands[1], E_DFmode)
                      || !general_operand (operands[2], E_DFmode)
                      || !const0_operand (operands[3], E_DFmode)
                      || !
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1934; /* *subdf3_cconly */

                case E_SFmode:
                  if (!nonimmediate_operand (operands[1], E_SFmode)
                      || !general_operand (operands[2], E_SFmode)
                      || !const0_operand (operands[3], E_SFmode)
                      || !
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1935; /* *subsf3_cconly */

                case E_TDmode:
                  if (!nonimmediate_operand (operands[1], E_TDmode)
                      || !general_operand (operands[2], E_TDmode)
                      || !const0_operand (operands[3], E_TDmode)
                      || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1936; /* *subtd3_cconly */

                case E_DDmode:
                  if (!nonimmediate_operand (operands[1], E_DDmode)
                      || !general_operand (operands[2], E_DDmode)
                      || !const0_operand (operands[3], E_DDmode)
                      || !(
#line 6739 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1937; /* *subdd3_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern154 (x3))
        {
        case 0:
          if (!
#line 8481 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2057; /* *xordi3_cconly */

        case 1:
          if (!
#line 8548 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2060; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != XOR)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !(
#line 8759 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2068; /* *nxordi_cconly */

        case E_SImode:
          if (GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 8759 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2069; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XEXP (x2, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x3))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && (
#line 8829 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2076; /* *negdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 8829 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2077; /* *negsi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          switch (pattern133 (x3))
            {
            case 0:
              if (!(
#line 8950 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2085; /* *negtf2_cconly */

            case 1:
              if (!(
#line 8950 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2086; /* *negfprx22_cconly */

            case 2:
              if (!
#line 8950 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2087; /* *negdf2_cconly */

            case 3:
              if (!
#line 8950 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2088; /* *negsf2_cconly */

            default:
              return -1;
            }

        case ABS:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x6 = XEXP (x2, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x3))
                {
                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 9154 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2129; /* *negabsdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 9154 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2130; /* *negabssi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          switch (GET_MODE (x3))
            {
            case E_TFmode:
              if (GET_MODE (x4) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !const0_operand (operands[2], E_TFmode)
                  || !(
#line 9191 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2137; /* *negabstf2_cconly */

            case E_FPRX2mode:
              if (GET_MODE (x4) != E_FPRX2mode
                  || !register_operand (operands[1], E_FPRX2mode)
                  || !const0_operand (operands[2], E_FPRX2mode)
                  || !(
#line 9191 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2138; /* *negabsfprx22_cconly */

            case E_DFmode:
              if (GET_MODE (x4) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !const0_operand (operands[2], E_DFmode)
                  || !
#line 9191 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2139; /* *negabsdf2_cconly */

            case E_SFmode:
              if (GET_MODE (x4) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !const0_operand (operands[2], E_SFmode)
                  || !
#line 9191 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2140; /* *negabssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XEXP (x2, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && (
#line 9030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2103; /* *absdi2_cconly */
                }
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && 
#line 9030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                {
                  *pnum_clobbers = 1;
                  return 2104; /* *abssi2_cconly */
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      switch (pattern133 (x3))
        {
        case 0:
          if (!(
#line 9075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2111; /* *abstf2_cconly */

        case 1:
          if (!(
#line 9075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2112; /* *absfprx22_cconly */

        case 2:
          if (!
#line 9075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2113; /* *absdf2_cconly */

        case 3:
          if (!
#line 9075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2114; /* *abssf2_cconly */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9392 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2165; /* *ashrdi3_31_cconly */
            }
          if (!(
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2168; /* *ashrdi3_cconly */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2171; /* *ashrsi3_cconly */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 11760 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
        return -1;
      *pnum_clobbers = 1;
      return 2289; /* *popcountdi_z15_cconly */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 740; /* xorv1qi3 */
          break;

        case 1:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 741; /* xorv2qi3 */
          break;

        case 2:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 742; /* xorv4qi3 */
          break;

        case 3:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 743; /* xorv8qi3 */
          break;

        case 4:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 744; /* xorv16qi3 */
          break;

        case 5:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 745; /* xorv1hi3 */
          break;

        case 6:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 746; /* xorv2hi3 */
          break;

        case 7:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 747; /* xorv4hi3 */
          break;

        case 8:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 748; /* xorv8hi3 */
          break;

        case 9:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 749; /* xorv1si3 */
          break;

        case 10:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 750; /* xorv2si3 */
          break;

        case 11:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 751; /* xorv4si3 */
          break;

        case 12:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 752; /* xorv1di3 */
          break;

        case 13:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 753; /* xorv2di3 */
          break;

        case 14:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 754; /* xorv1sf3 */
          break;

        case 15:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 755; /* xorv2sf3 */
          break;

        case 16:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 756; /* xorv4sf3 */
          break;

        case 17:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 757; /* xorv1df3 */
          break;

        case 18:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 758; /* xorv2df3 */
          break;

        case 19:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 759; /* xorv1tf3 */
          break;

        case 20:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 760; /* xorv1ti3 */
          break;

        case 21:
          if (
#line 1224 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 761; /* xorti3 */
          break;

        case 22:
          if (
#line 8495 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2058; /* *xordi3 */
            }
          break;

        case 23:
          if (
#line 8598 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2062; /* *xorhi3 */
            }
          break;

        case 24:
          if (
#line 8628 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2063; /* *xorqi3 */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern129 (x3) == 0
          && 
#line 4587 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1657; /* *rxsbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 8565 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2061; /* *xorsi3 */

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          switch (pattern135 (x3))
            {
            case 0:
              if (!(
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1635; /* *rxsbg_di_noshift */

            case 1:
              if (!
#line 4480 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 1637; /* *rxsbg_si_noshift */

            default:
              return -1;
            }

        case ROTATE:
          if (pattern81 (x3) != 0
              || !contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode)
              || !
#line 4495 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1639; /* *rxsbg_di_rotl */

        case LSHIFTRT:
          switch (pattern109 (x3))
            {
            case 0:
              if (!(
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1641; /* *rxsbg_di_srl_bitmask */

            case 1:
              if (!
#line 4510 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1643; /* *rxsbg_si_srl_bitmask */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern109 (x3))
            {
            case 0:
              if (!(
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1645; /* *rxsbg_di_sll_bitmask */

            case 1:
              if (!
#line 4530 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1647; /* *rxsbg_si_sll_bitmask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern29 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1649; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4548 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1651; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern29 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1653; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4567 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1655; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  switch (GET_MODE (x9))
    {
    case E_DImode:
      if (pattern252 (x3, 
E_DImode) != 0)
        return -1;
      x10 = XEXP (x8, 1);
      if (rtx_equal_p (x10, operands[1])
          && (
#line 6011 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1857; /* *adddi3_carry1_cc */
      if (!rtx_equal_p (x10, operands[2])
          || !(
#line 6051 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1861; /* *adddi3_carry2_cc */

    case E_SImode:
      if (pattern252 (x3, 
E_SImode) != 0)
        return -1;
      x10 = XEXP (x8, 1);
      if (rtx_equal_p (x10, operands[1])
          && 
#line 6011 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return 1858; /* *addsi3_carry1_cc */
      if (!rtx_equal_p (x10, operands[2])
          || !
#line 6051 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 1862; /* *addsi3_carry2_cc */

    case E_TFmode:
      if (pattern253 (x1, 
E_TFmode) != 0
          || !(
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1884; /* *addtf3_cc */

    case E_FPRX2mode:
      if (pattern253 (x1, 
E_FPRX2mode) != 0
          || !(
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1885; /* *addfprx23_cc */

    case E_DFmode:
      if (pattern253 (x1, 
E_DFmode) != 0
          || !
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 1886; /* *adddf3_cc */

    case E_SFmode:
      if (pattern253 (x1, 
E_SFmode) != 0
          || !
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 1887; /* *addsf3_cc */

    case E_TDmode:
      if (pattern253 (x1, 
E_TDmode) != 0
          || !(
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1888; /* *addtd3_cc */

    case E_DDmode:
      if (pattern253 (x1, 
E_DDmode) != 0
          || !(
#line 6278 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1889; /* *adddd3_cc */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (SUBREG_BYTE (x4))
    {
    case 0:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ROTATE:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1593; /* *risbg_and_subregdi_rotr */
              if (!
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1599; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1595; /* *risbg_and_subregdi_rotr */
              if (!
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1601; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4174 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1597; /* *risbg_and_subregdi_rotr */
              if (!
#line 4187 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1603; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != CONST_INT
              || XWINT (x8, 0) != 2147483647L
              || !
#line 4945 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1679; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!nonzero_shift_count_operand (operands[2], E_DImode)
              || !
#line 4397 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 1631; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 2);
          operands[2] = x9;
          if (!nonzero_shift_count_operand (operands[2], E_SImode)
              || !
#line 4411 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 1633; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 67:
          switch (pattern143 (x1, 
66))
            {
            case 0:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 24; /* *vec_packs_ccv8hi */

            case 1:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 25; /* *vec_packs_ccv4si */

            case 2:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 26; /* *vec_packs_ccv2di */

            default:
              return -1;
            }

        case 70:
          switch (pattern143 (x1, 
69))
            {
            case 0:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 30; /* *vec_packsu_ccv8hi */

            case 1:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 31; /* *vec_packsu_ccv4si */

            case 2:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 32; /* *vec_packsu_ccv2di */

            default:
              return -1;
            }

        case 128:
          if (GET_MODE (x3) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 33
              || GET_MODE (x6) != E_CCRAWmode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[0], E_V4SImode)
                  || !(
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 324; /* *vftciv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[0], E_V2DImode)
                  || !
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 325; /* *vftciv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !(
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 326; /* *vftciv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !(
#line 1933 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 327; /* *vftcitf_cconly */

            default:
              return -1;
            }

        case 127:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern44 (x7, 
128, 
2, 
UNSPEC) != 0)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_MODE (x9) != E_CCRAWmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!const_int_operand (operands[2], E_HImode))
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 1959 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 328; /* vftciv4sf */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 1959 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 329; /* vftciv2df */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || GET_MODE (x3) != E_V1TFmode
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 1959 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 330; /* vftciv1tf */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x3) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 1959 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 331; /* vftcitf */

            default:
              return -1;
            }

        case 1:
          if (pattern38 (x1) != 0
              || !s_operand (operands[1], E_BLKmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 1577; /* *sethighpartsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (
#line 4059 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 1578; /* *sethighpartdi_64 */
              if (!
#line 4069 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 1579; /* *sethighpartdi_31 */

            default:
              return -1;
            }

        case 44:
          if (pattern101 (x1) != 0
              || !address_operand (operands[1], E_VOIDmode)
              || !immediate_operand (operands[2], E_SImode)
              || !
#line 12212 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2314; /* lcbb */

        default:
          return -1;
        }

    case 3:
      if (pattern68 (x1, 
3) != 0
          || !const_mask_operand (operands[3], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 108:
          switch (pattern277 (x1, 
109))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 281; /* *vfaesv16qi */

            case 1:
              if (!
#line 1317 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 282; /* *vfaesv8hi */

            case 2:
              if (!
#line 1317 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 283; /* *vfaesv4si */

            default:
              return -1;
            }

        case 110:
          switch (pattern277 (x1, 
111))
            {
            case 0:
              if (!
#line 2277 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1257; /* vec_vfeesv16qi */

            case 1:
              if (!
#line 2277 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1258; /* vec_vfeesv8hi */

            case 2:
              if (!
#line 2277 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1259; /* vec_vfeesv4si */

            default:
              return -1;
            }

        case 112:
          switch (pattern277 (x1, 
113))
            {
            case 0:
              if (!
#line 2303 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1260; /* vec_vfenesv16qi */

            case 1:
              if (!
#line 2303 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1261; /* vec_vfenesv8hi */

            case 2:
              if (!
#line 2303 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1262; /* vec_vfenesv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 114:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x9 = XEXP (x7, 1);
          if (pattern152 (x9, 
E_CCRAWmode, 
115, 
UNSPEC, 
1) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x3) != E_V16QImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1519 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 299; /* *vistrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1519 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 300; /* *vistrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1519 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 301; /* *vistrsv4si */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern88 (x7) != 0
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_CCUmode))
            return -1;
          return 1573; /* cmpint */

        case 37:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern88 (x7) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 11778 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 702 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2291; /* *popcountdi_z196 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 11778 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2292; /* *popcountsi_z196 */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 11778 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2293; /* *popcounthi_z196 */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 11778 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2294; /* *popcountqi_z196 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (pattern68 (x1, 
4) != 0)
        return -1;
      x13 = XVECEXP (x3, 0, 3);
      operands[4] = x13;
      if (!const_mask_operand (operands[4], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x14 = XVECEXP (x9, 0, 3);
      if (!rtx_equal_p (x14, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 116:
          if (XINT (x9, 1) != 117)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern290 (x3, 
E_V16QImode) != 0
                  || !
#line 1576 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 305; /* *vstrcsv16qi */

            case E_V8HImode:
              if (pattern290 (x3, 
E_V8HImode) != 0
                  || !
#line 1576 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 306; /* *vstrcsv8hi */

            case E_V4SImode:
              if (pattern290 (x3, 
E_V4SImode) != 0
                  || !
#line 1576 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 307; /* *vstrcsv4si */

            default:
              return -1;
            }

        case 118:
          if (GET_MODE (x3) != E_V16QImode
              || XINT (x9, 1) != 119
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[3], E_V16QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !register_operand (operands[2], E_V16QImode)
                  || !
#line 1697 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 308; /* vec_vstrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !
#line 1697 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 309; /* vec_vstrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !register_operand (operands[2], E_V4SImode)
                  || !
#line 1697 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 310; /* vec_vstrsv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return recog_61 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_51 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_54 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_52 (x1, insn, pnum_clobbers);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 33)
        return -1;
      return recog_25 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_63 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_71 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_57 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_53 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_65 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_60 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 811; /* clzv1qi2 */

        case 1:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 812; /* clzv2qi2 */

        case 2:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 813; /* clzv4qi2 */

        case 3:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 814; /* clzv8qi2 */

        case 4:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 815; /* clzv16qi2 */

        case 5:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 816; /* clzv1hi2 */

        case 6:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 817; /* clzv2hi2 */

        case 7:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 818; /* clzv4hi2 */

        case 8:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 819; /* clzv8hi2 */

        case 9:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 820; /* clzv1si2 */

        case 10:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 821; /* clzv2si2 */

        case 11:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 822; /* clzv4si2 */

        case 12:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 823; /* clzv1di2 */

        case 13:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 824; /* clzv2di2 */

        case 14:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 825; /* clzv1sf2 */

        case 15:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 826; /* clzv2sf2 */

        case 16:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 827; /* clzv4sf2 */

        case 17:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 828; /* clzv1df2 */

        case 18:
          if (!
#line 1364 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 829; /* clzv2df2 */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 830; /* ctzv1qi2 */

        case 1:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 831; /* ctzv2qi2 */

        case 2:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 832; /* ctzv4qi2 */

        case 3:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 833; /* ctzv8qi2 */

        case 4:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 834; /* ctzv16qi2 */

        case 5:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 835; /* ctzv1hi2 */

        case 6:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 836; /* ctzv2hi2 */

        case 7:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 837; /* ctzv4hi2 */

        case 8:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 838; /* ctzv8hi2 */

        case 9:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 839; /* ctzv1si2 */

        case 10:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 840; /* ctzv2si2 */

        case 11:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 841; /* ctzv4si2 */

        case 12:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 842; /* ctzv1di2 */

        case 13:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 843; /* ctzv2di2 */

        case 14:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 844; /* ctzv1sf2 */

        case 15:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 845; /* ctzv2sf2 */

        case 16:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 846; /* ctzv4sf2 */

        case 17:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 847; /* ctzv1df2 */

        case 18:
          if (!
#line 1373 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 848; /* ctzv2df2 */

        default:
          return -1;
        }

    case ROTATE:
      return recog_59 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_58 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_55 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_56 (x1, insn, pnum_clobbers);

    case SMIN:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 979; /* sminv1qi3 */

        case 1:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 980; /* sminv2qi3 */

        case 2:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 981; /* sminv4qi3 */

        case 3:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 982; /* sminv8qi3 */

        case 4:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 983; /* sminv16qi3 */

        case 5:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 984; /* sminv1hi3 */

        case 6:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 985; /* sminv2hi3 */

        case 7:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 986; /* sminv4hi3 */

        case 8:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 987; /* sminv8hi3 */

        case 9:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 988; /* sminv1si3 */

        case 10:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 989; /* sminv2si3 */

        case 11:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 990; /* sminv4si3 */

        case 12:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 991; /* sminv1di3 */

        case 13:
          if (!
#line 1513 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 992; /* sminv2di3 */

        case 14:
          if (!
#line 1884 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1145; /* *sminv4sf3_vxe */

        case 15:
          if (
#line 1884 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1146; /* *sminv2df3_vxe */
          if (!
#line 1893 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1149; /* *sminv2df3_vx */

        case 16:
          if (!
#line 1884 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1147; /* *sminv1tf3_vxe */

        case 17:
          if (!
#line 1884 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1148; /* *smintf3_vxe */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 993; /* smaxv1qi3 */

        case 1:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 994; /* smaxv2qi3 */

        case 2:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 995; /* smaxv4qi3 */

        case 3:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 996; /* smaxv8qi3 */

        case 4:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 997; /* smaxv16qi3 */

        case 5:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 998; /* smaxv1hi3 */

        case 6:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 999; /* smaxv2hi3 */

        case 7:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1000; /* smaxv4hi3 */

        case 8:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1001; /* smaxv8hi3 */

        case 9:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1002; /* smaxv1si3 */

        case 10:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1003; /* smaxv2si3 */

        case 11:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1004; /* smaxv4si3 */

        case 12:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1005; /* smaxv1di3 */

        case 13:
          if (!
#line 1522 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1006; /* smaxv2di3 */

        case 14:
          if (!
#line 1848 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1140; /* *smaxv4sf3_vxe */

        case 15:
          if (
#line 1848 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1141; /* *smaxv2df3_vxe */
          if (!
#line 1857 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1144; /* *smaxv2df3_vx */

        case 16:
          if (!
#line 1848 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1142; /* *smaxv1tf3_vxe */

        case 17:
          if (!
#line 1848 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1143; /* *smaxtf3_vxe */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1007; /* uminv1qi3 */

        case 1:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1008; /* uminv2qi3 */

        case 2:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1009; /* uminv4qi3 */

        case 3:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1010; /* uminv8qi3 */

        case 4:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1011; /* uminv16qi3 */

        case 5:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1012; /* uminv1hi3 */

        case 6:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1013; /* uminv2hi3 */

        case 7:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1014; /* uminv4hi3 */

        case 8:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1015; /* uminv8hi3 */

        case 9:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1016; /* uminv1si3 */

        case 10:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1017; /* uminv2si3 */

        case 11:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1018; /* uminv4si3 */

        case 12:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1019; /* uminv1di3 */

        case 13:
          if (!
#line 1531 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1020; /* uminv2di3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1021; /* umaxv1qi3 */

        case 1:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1022; /* umaxv2qi3 */

        case 2:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1023; /* umaxv4qi3 */

        case 3:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1024; /* umaxv8qi3 */

        case 4:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1025; /* umaxv16qi3 */

        case 5:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1026; /* umaxv1hi3 */

        case 6:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1027; /* umaxv2hi3 */

        case 7:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1028; /* umaxv4hi3 */

        case 8:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1029; /* umaxv8hi3 */

        case 9:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1030; /* umaxv1si3 */

        case 10:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1031; /* umaxv2si3 */

        case 11:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1032; /* umaxv4si3 */

        case 12:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1033; /* umaxv1di3 */

        case 13:
          if (!
#line 1540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1034; /* umaxv2di3 */

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern3 (x2, 
E_V4SFmode) != 0
              || !(
#line 1734 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1095; /* divv4sf3 */

        case E_V2DFmode:
          if (pattern3 (x2, 
E_V2DFmode) != 0
              || !
#line 1734 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1096; /* divv2df3 */

        case E_V1TFmode:
          if (pattern3 (x2, 
E_V1TFmode) != 0
              || !(
#line 1734 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 72 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1097; /* divv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x2) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if (register_operand (operands[2], E_TFmode)
              && (
#line 1734 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 73 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1098; /* divtf3_vr */
          if (!general_operand (operands[2], E_TFmode)
              || !(
#line 7588 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1990; /* divtf3_fpr */

        case E_FPRX2mode:
          if (pattern85 (x2, 
E_FPRX2mode) != 0
              || !(
#line 7588 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1991; /* divfprx23 */

        case E_DFmode:
          if (pattern85 (x2, 
E_DFmode) != 0
              || !
#line 7588 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1992; /* divdf3 */

        case E_SFmode:
          if (pattern85 (x2, 
E_SFmode) != 0
              || !
#line 7588 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 1993; /* divsf3 */

        case E_TDmode:
          if (pattern85 (x2, 
E_TDmode) != 0
              || !(
#line 7588 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1994; /* divtd3 */

        case E_DDmode:
          if (pattern85 (x2, 
E_DDmode) != 0
              || !(
#line 7588 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1995; /* divdd3 */

        default:
          return -1;
        }

    case SQRT:
      return recog_67 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_70 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_72 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_64 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_69 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_66 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 2835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1379; /* fix_truncv2dfv2di2 */

        case 1:
          if (!(
#line 2835 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1380; /* fix_truncv4sfv4si2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 2867 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1381; /* fixuns_truncv2dfv2di2 */

        case 1:
          if (!(
#line 2867 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1382; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_31 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL
          || XWINT (x6, 0) != 0L)
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!(
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1606; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4210 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1607; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1608; /* *pre_z10_extvdi */

        case 1:
          *pnum_clobbers = 1;
          return 1609; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 5469 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1748; /* truncdfsf2 */

            case E_TFmode:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[1], E_TFmode)
                  || !
#line 5487 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 1750; /* trunctfsf2_fpr */

            default:
              return -1;
            }

        case E_DFmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 5487 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 1749; /* trunctfdf2_fpr */

        case E_SDmode:
          if (!register_operand (operands[0], E_SDmode)
              || GET_MODE (x2) != E_SDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5518 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 1752; /* truncddsd2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_62 (x1, insn, pnum_clobbers);

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      if (!const_int_operand (x5, E_VOIDmode))
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 1)
            return -1;
          operands[1] = x5;
          if (!
#line 10463 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (XEXP (PATTERN (insn), 1), 0), 0)) == Pmode))
            return -1;
          return 2218; /* *sibcall_value_br */

        case CONST:
        case SYMBOL_REF:
          operands[1] = x7;
          if (!bras_sym_operand (operands[1], E_VOIDmode))
            return -1;
          operands[2] = x5;
          if (
#line 10493 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2219; /* *sibcall_value_brc */
          if (!
#line 10502 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2220; /* *sibcall_value_brcl */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_68 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 11768 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      *pnum_clobbers = 1;
      return 2290; /* *popcountdi_z15 */

    case COPYSIGN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (pattern3 (x2, 
E_TFmode) != 0
              || !(
#line 11935 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2295; /* copysigntf3_fpr */

        case E_FPRX2mode:
          if (pattern3 (x2, 
E_FPRX2mode) != 0
              || !(
#line 11935 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2296; /* copysignfprx23 */

        case E_DFmode:
          if (pattern3 (x2, 
E_DFmode) != 0
              || !
#line 11935 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2297; /* copysigndf3 */

        case E_SFmode:
          if (pattern3 (x2, 
E_SFmode) != 0
              || !
#line 11935 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2298; /* copysignsf3 */

        case E_TDmode:
          if (pattern3 (x2, 
E_TDmode) != 0
              || !(
#line 11935 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2299; /* copysigntd3 */

        case E_DDmode:
          if (pattern3 (x2, 
E_DDmode) != 0
              || !(
#line 11935 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2300; /* copysigndd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
