/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 16
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 17
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 16
      || GET_MODE (x8) != i2)
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != i4
      || GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != i3
      || GET_MODE (x12) != i2)
    return -1;
  x13 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x13) != CLOBBER)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != i1)
    return -1;
  return 0;
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern21 (x3, 
E_V16QImode); /* [-1, 2] */

    case E_V8HImode:
      res = pattern21 (x3, 
E_V8HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4SImode:
      res = pattern21 (x3, 
E_V4SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_V2DImode:
      res = pattern21 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 33
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  return 0;
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern51 (x1, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern51 (x1, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern51 (x1, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, int *pnum_clobbers, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern71 (x6); /* [-1, 1] */
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 33
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x4, 0);
  operands[0] = x12;
  x13 = XEXP (x3, 0);
  switch (GET_CODE (x13))
    {
    case GT:
    case LE:
      operands[5] = x13;
      if (!s390_brx_operator (operands[5], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      x16 = XEXP (x13, 1);
      if (GET_CODE (x16) != SUBREG)
        return -1;
      x17 = XEXP (x8, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x18 = XEXP (x14, 0);
      operands[1] = x18;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      x20 = XEXP (x7, 0);
      operands[3] = x20;
      x21 = XEXP (x9, 0);
      operands[4] = x21;
      x22 = XEXP (x16, 0);
      if (!rtx_equal_p (x22, operands[2]))
        return -1;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XEXP (x17, 0);
      if (!rtx_equal_p (x24, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x15))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x17), 0))
            return -1;
          switch (SUBREG_BYTE (x16))
            {
            case 8:
              return pattern76 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

            case 4:
              if (pattern76 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x15) != E_SImode
              || maybe_ne (SUBREG_BYTE (x16), 12)
              || GET_MODE (x16) != E_SImode
              || maybe_ne (SUBREG_BYTE (x17), 4)
              || GET_MODE (x17) != E_SImode
              || GET_MODE (x14) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x8) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case NE:
      x16 = XEXP (x13, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x17 = XEXP (x8, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      x20 = XEXP (x7, 0);
      operands[2] = x20;
      x21 = XEXP (x9, 0);
      operands[3] = x21;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern77 (x8, 
E_SImode) != 0)
            return -1;
          return 3;

        case E_DImode:
          if (pattern77 (x8, 
E_DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern127 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  return 0;
}

int
pattern137 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x4, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x5, 0);
  operands[2] = x12;
  x13 = XEXP (x8, 0);
  operands[0] = x13;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x7, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x9, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  return pattern170 (); /* [-1, 1] */
}

int
pattern177 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          return pattern176 (x3, 
E_TFmode); /* [-1, 0] */

        case E_FPRX2mode:
          if (pattern176 (x3, 
E_FPRX2mode) != 0)
            return -1;
          return 1;

        case E_DFmode:
          if (pattern176 (x3, 
E_DFmode) != 0)
            return -1;
          return 2;

        case E_SFmode:
          if (pattern176 (x3, 
E_SFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !const0_operand (operands[2], E_TFmode)
              || !scratch_operand (operands[0], E_TFmode))
            return -1;
          return 4;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || !const0_operand (operands[2], E_FPRX2mode)
              || !scratch_operand (operands[0], E_FPRX2mode))
            return -1;
          return 5;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !const0_operand (operands[2], E_DFmode)
              || !scratch_operand (operands[0], E_DFmode))
            return -1;
          return 6;

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !const0_operand (operands[2], E_SFmode)
              || !scratch_operand (operands[0], E_SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], E_V1TImode)
      || !const0_operand (operands[4], E_V1TImode)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  x7 = XEXP (x4, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x3, 1);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 0);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  switch (GET_MODE (x11))
    {
    case E_DImode:
      return pattern211 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern211 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern242 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const0_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern255 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern285 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern294 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern22 (x1))
    {
    case 0:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 244; /* vec_srlv16qiv16qi */

    case 1:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 248; /* vec_srlv16qiv8hi */

    case 2:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 252; /* vec_srlv16qiv4si */

    case 3:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 245; /* vec_srlv8hiv16qi */

    case 4:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 249; /* vec_srlv8hiv8hi */

    case 5:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 253; /* vec_srlv8hiv4si */

    case 6:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 246; /* vec_srlv4siv16qi */

    case 7:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 250; /* vec_srlv4siv8hi */

    case 8:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 254; /* vec_srlv4siv4si */

    case 9:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 247; /* vec_srlv2div16qi */

    case 10:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 251; /* vec_srlv2div8hi */

    case 11:
      if (!
#line 1145 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 255; /* vec_srlv2div4si */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case ZERO_EXTEND:
      if (pattern164 (x1, 
E_V4SImode, 
E_DImode, 
E_SImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_V4SImode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 38; /* vec_scatter_elementv4si_DI */

        case E_SFmode:
          if (GET_MODE (x5) != E_SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 39; /* vec_scatter_elementv4sf_DI */

        default:
          return -1;
        }

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x7), 4)
          || pattern164 (x1, 
E_V2DImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_V2DImode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 40; /* vec_scatter_elementv2di_SI */

        case E_DFmode:
          if (GET_MODE (x5) != E_DFmode
              || !register_operand (operands[0], E_V2DFmode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 41; /* vec_scatter_elementv2df_SI */

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_mask_operand (operands[3], E_QImode)
          || !address_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      x12 = XVECEXP (x11, 0, 0);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (pattern265 (x1, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 42; /* vec_scatter_elementv4si_SI */

        case E_DImode:
          if (pattern265 (x1, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 43; /* vec_scatter_elementv2di_DI */

        case E_DFmode:
          if (pattern266 (x1, 
E_V2DFmode, 
E_DFmode, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 44; /* vec_scatter_elementv2df_DI */

        case E_SFmode:
          if (pattern266 (x1, 
E_V4SFmode, 
E_SFmode, 
E_V4SImode, 
E_SImode) != 0
              || !(
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 45; /* vec_scatter_elementv4sf_SI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_22 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!general_operand (x3, E_DImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              if (
#line 1174 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode) && TARGET_ZARCH))
                return 1447; /* *cmpdi_cct */
              if ((
#line 1262 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1454; /* *cmpdi_ccs */
              if (
#line 1327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode) && TARGET_ZARCH))
                return 1460; /* *cmpdi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 6637 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1915; /* *subdi3_cconly2 */

        case E_SImode:
          if (!general_operand (x3, E_SImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_SImode))
            {
              if (
#line 1188 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode)))
                return 1448; /* *cmpsi_cct */
              if (
#line 1262 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1455; /* *cmpsi_ccs */
              if (
#line 1346 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)))
                return 1461; /* *cmpsi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 6637 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
            return -1;
          *pnum_clobbers = 1;
          return 1916; /* *subsi3_cconly2 */

        case E_HImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_HImode)
              || !
#line 1366 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], HImode)))
            return -1;
          return 1462; /* *cmphi_ccu */

        case E_QImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 1382 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], QImode)))
            return -1;
          return 1463; /* *cmpqi_ccu */

        case E_TFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TFmode))
            return -1;
          operands[1] = x3;
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1477; /* *cmptf_ccs */
          if (register_operand (operands[1], E_TFmode)
              && 
#line 1503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_VXE))
            return 1483; /* *cmptf_ccs */
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1484; /* *cmptf_ccsfps */
          if (!register_operand (operands[1], E_TFmode)
              || !
#line 1529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_VXE))
            return -1;
          return 1490; /* *cmptf_ccsfps */

        case E_FPRX2mode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_FPRX2mode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 1478; /* *cmpfprx2_ccs */
          if (!(
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1485; /* *cmpfprx2_ccsfps */

        case E_DFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1479; /* *cmpdf_ccs */
          if (!
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1486; /* *cmpdf_ccsfps */

        case E_SFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1480; /* *cmpsf_ccs */
          if (!
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1487; /* *cmpsf_ccsfps */

        case E_TDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_TDmode))
            return -1;
          if ((
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1481; /* *cmptd_ccs */
          if (!(
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1488; /* *cmptd_ccsfps */

        case E_DDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DDmode))
            return -1;
          if ((
#line 1488 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1482; /* *cmpdd_ccs */
          if (!(
#line 1514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1489; /* *cmpdd_ccsfps */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !general_operand (operands[2], E_DImode)
              || !(
#line 6129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1869; /* *adddi3_cconly2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !general_operand (operands[2], E_SImode)
              || !
#line 6129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1870; /* *addsi3_cconly2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[4] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern202 (x3, 
E_V1QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1263; /* *vec_sel0v1qi */
          if (!all_ones_operand (operands[4], E_V1QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1304; /* *vec_sel1v1qi */

        case E_V2QImode:
          if (pattern202 (x3, 
E_V2QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1264; /* *vec_sel0v2qi */
          if (!all_ones_operand (operands[4], E_V2QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1305; /* *vec_sel1v2qi */

        case E_V4QImode:
          if (pattern202 (x3, 
E_V4QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1265; /* *vec_sel0v4qi */
          if (!all_ones_operand (operands[4], E_V4QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1306; /* *vec_sel1v4qi */

        case E_V8QImode:
          if (pattern202 (x3, 
E_V8QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1266; /* *vec_sel0v8qi */
          if (!all_ones_operand (operands[4], E_V8QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1307; /* *vec_sel1v8qi */

        case E_V16QImode:
          if (pattern202 (x3, 
E_V16QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V16QImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1267; /* *vec_sel0v16qi */
          if (!all_ones_operand (operands[4], E_V16QImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1308; /* *vec_sel1v16qi */

        case E_V1HImode:
          if (pattern202 (x3, 
E_V1HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1HImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1268; /* *vec_sel0v1hi */
          if (!all_ones_operand (operands[4], E_V1HImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1309; /* *vec_sel1v1hi */

        case E_V2HImode:
          if (pattern202 (x3, 
E_V2HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2HImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1269; /* *vec_sel0v2hi */
          if (!all_ones_operand (operands[4], E_V2HImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1310; /* *vec_sel1v2hi */

        case E_V4HImode:
          if (pattern202 (x3, 
E_V4HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4HImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1270; /* *vec_sel0v4hi */
          if (!all_ones_operand (operands[4], E_V4HImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1311; /* *vec_sel1v4hi */

        case E_V8HImode:
          if (pattern202 (x3, 
E_V8HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8HImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1271; /* *vec_sel0v8hi */
          if (!all_ones_operand (operands[4], E_V8HImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1312; /* *vec_sel1v8hi */

        case E_V1SImode:
          if (pattern202 (x3, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1272; /* *vec_sel0v1si */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1313; /* *vec_sel1v1si */

        case E_V2SImode:
          if (pattern202 (x3, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1273; /* *vec_sel0v2si */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1314; /* *vec_sel1v2si */

        case E_V4SImode:
          if (pattern202 (x3, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1274; /* *vec_sel0v4si */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1315; /* *vec_sel1v4si */

        case E_V1DImode:
          if (pattern202 (x3, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1275; /* *vec_sel0v1di */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1316; /* *vec_sel1v1di */

        case E_V2DImode:
          if (pattern202 (x3, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1276; /* *vec_sel0v2di */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1317; /* *vec_sel1v2di */

        case E_V1SFmode:
          if (pattern203 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1277; /* *vec_sel0v1sf */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1318; /* *vec_sel1v1sf */

        case E_V2SFmode:
          if (pattern203 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1278; /* *vec_sel0v2sf */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1319; /* *vec_sel1v2sf */

        case E_V4SFmode:
          if (pattern203 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1279; /* *vec_sel0v4sf */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1320; /* *vec_sel1v4sf */

        case E_V1DFmode:
          if (pattern203 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1280; /* *vec_sel0v1df */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1321; /* *vec_sel1v1df */

        case E_V2DFmode:
          if (pattern203 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1281; /* *vec_sel0v2df */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1322; /* *vec_sel1v2df */

        case E_V1TFmode:
          if (pattern204 (x3, 
E_V1TFmode) != 0
              || !
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1282; /* *vec_sel0v1tf */

        case E_V1TImode:
          if (pattern204 (x3, 
E_V1TImode) != 0
              || !
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1283; /* *vec_sel0v1ti */

        case E_TImode:
          if (pattern204 (x3, 
E_TImode) != 0
              || !
#line 2387 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1284; /* *vec_sel0ti */

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern205 (x3, 
E_V1QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1285; /* *vec_sel0v1qi */
          if (!all_ones_operand (operands[4], E_V1QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1323; /* *vec_sel1v1qi */

        case E_V2QImode:
          if (pattern205 (x3, 
E_V2QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1286; /* *vec_sel0v2qi */
          if (!all_ones_operand (operands[4], E_V2QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1324; /* *vec_sel1v2qi */

        case E_V4QImode:
          if (pattern205 (x3, 
E_V4QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1287; /* *vec_sel0v4qi */
          if (!all_ones_operand (operands[4], E_V4QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1325; /* *vec_sel1v4qi */

        case E_V8QImode:
          if (pattern205 (x3, 
E_V8QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1288; /* *vec_sel0v8qi */
          if (!all_ones_operand (operands[4], E_V8QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1326; /* *vec_sel1v8qi */

        case E_V16QImode:
          if (pattern205 (x3, 
E_V16QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V16QImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1289; /* *vec_sel0v16qi */
          if (!all_ones_operand (operands[4], E_V16QImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1327; /* *vec_sel1v16qi */

        case E_V1HImode:
          if (pattern205 (x3, 
E_V1HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1HImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1290; /* *vec_sel0v1hi */
          if (!all_ones_operand (operands[4], E_V1HImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1328; /* *vec_sel1v1hi */

        case E_V2HImode:
          if (pattern205 (x3, 
E_V2HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2HImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1291; /* *vec_sel0v2hi */
          if (!all_ones_operand (operands[4], E_V2HImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1329; /* *vec_sel1v2hi */

        case E_V4HImode:
          if (pattern205 (x3, 
E_V4HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4HImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1292; /* *vec_sel0v4hi */
          if (!all_ones_operand (operands[4], E_V4HImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1330; /* *vec_sel1v4hi */

        case E_V8HImode:
          if (pattern205 (x3, 
E_V8HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8HImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1293; /* *vec_sel0v8hi */
          if (!all_ones_operand (operands[4], E_V8HImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1331; /* *vec_sel1v8hi */

        case E_V1SImode:
          if (pattern205 (x3, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1294; /* *vec_sel0v1si */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1332; /* *vec_sel1v1si */

        case E_V2SImode:
          if (pattern205 (x3, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1295; /* *vec_sel0v2si */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1333; /* *vec_sel1v2si */

        case E_V4SImode:
          if (pattern205 (x3, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1296; /* *vec_sel0v4si */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1334; /* *vec_sel1v4si */

        case E_V1DImode:
          if (pattern205 (x3, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1297; /* *vec_sel0v1di */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1335; /* *vec_sel1v1di */

        case E_V2DImode:
          if (pattern205 (x3, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1298; /* *vec_sel0v2di */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1336; /* *vec_sel1v2di */

        case E_V1SFmode:
          if (pattern206 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1299; /* *vec_sel0v1sf */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1337; /* *vec_sel1v1sf */

        case E_V2SFmode:
          if (pattern206 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1300; /* *vec_sel0v2sf */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1338; /* *vec_sel1v2sf */

        case E_V4SFmode:
          if (pattern206 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1301; /* *vec_sel0v4sf */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1339; /* *vec_sel1v4sf */

        case E_V1DFmode:
          if (pattern206 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1302; /* *vec_sel0v1df */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1340; /* *vec_sel1v1df */

        case E_V2DFmode:
          if (pattern206 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2399 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1303; /* *vec_sel0v2df */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2423 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1341; /* *vec_sel1v2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return 864; /* *ashrv1qi3 */
      if (!register_operand (operands[2], E_V1QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 933; /* vashrv1qi3 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return 868; /* *ashrv2qi3 */
      if (!register_operand (operands[2], E_V2QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 934; /* vashrv2qi3 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return 872; /* *ashrv4qi3 */
      if (!register_operand (operands[2], E_V4QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 935; /* vashrv4qi3 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return 876; /* *ashrv8qi3 */
      if (!register_operand (operands[2], E_V8QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 936; /* vashrv8qi3 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return 880; /* *ashrv16qi3 */
      if (!register_operand (operands[2], E_V16QImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 937; /* vashrv16qi3 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return 884; /* *ashrv1hi3 */
      if (!register_operand (operands[2], E_V1HImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 938; /* vashrv1hi3 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return 888; /* *ashrv2hi3 */
      if (!register_operand (operands[2], E_V2HImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 939; /* vashrv2hi3 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return 892; /* *ashrv4hi3 */
      if (!register_operand (operands[2], E_V4HImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 940; /* vashrv4hi3 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return 896; /* *ashrv8hi3 */
      if (!register_operand (operands[2], E_V8HImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 941; /* vashrv8hi3 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return 900; /* *ashrv1si3 */
      if (!register_operand (operands[2], E_V1SImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 942; /* vashrv1si3 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return 904; /* *ashrv2si3 */
      if (!register_operand (operands[2], E_V2SImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 943; /* vashrv2si3 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return 908; /* *ashrv4si3 */
      if (!register_operand (operands[2], E_V4SImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 944; /* vashrv4si3 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return 912; /* *ashrv1di3 */
      if (!register_operand (operands[2], E_V1DImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 945; /* vashrv1di3 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1413 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return 916; /* *ashrv2di3 */
      if (!register_operand (operands[2], E_V2DImode)
          || !
#line 1454 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 946; /* vashrv2di3 */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_DImode) != 0)
        return -1;
      if (
#line 9392 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2164; /* *ashrdi3_31 */
        }
      if (!
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2167; /* *ashrdi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2170; /* *ashrsi3 */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case EQ:
      switch (pattern11 (x1))
        {
        case 0:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1150; /* *vec_cmpeqv1qiv1qi_nocc */
          break;

        case 1:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1153; /* *vec_cmpeqv2qiv2qi_nocc */
          break;

        case 2:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1156; /* *vec_cmpeqv4qiv4qi_nocc */
          break;

        case 3:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1159; /* *vec_cmpeqv8qiv8qi_nocc */
          break;

        case 4:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1162; /* *vec_cmpeqv16qiv16qi_nocc */
          break;

        case 5:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1165; /* *vec_cmpeqv1hiv1hi_nocc */
          break;

        case 6:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1168; /* *vec_cmpeqv2hiv2hi_nocc */
          break;

        case 7:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1171; /* *vec_cmpeqv4hiv4hi_nocc */
          break;

        case 8:
          if (
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1174; /* *vec_cmpeqv8hiv8hi_nocc */
          break;

        case 9:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1SImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1177; /* *vec_cmpeqv1siv1si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1SFmode)
                  && (
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1198; /* *vec_cmpeqv1sf_quiet_nocc */
            }
          break;

        case 10:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1180; /* *vec_cmpeqv2siv2si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2SFmode)
                  && (
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1199; /* *vec_cmpeqv2sf_quiet_nocc */
            }
          break;

        case 11:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V4SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V4SImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1183; /* *vec_cmpeqv4siv4si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V4SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V4SFmode)
                  && (
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 59 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1200; /* *vec_cmpeqv4sf_quiet_nocc */
            }
          break;

        case 12:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1DImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1186; /* *vec_cmpeqv1div1di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1DFmode)
                  && 
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1201; /* *vec_cmpeqv1df_quiet_nocc */
            }
          break;

        case 13:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2DImode)
                  && 
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1189; /* *vec_cmpeqv2div2di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2DFmode)
                  && 
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1202; /* *vec_cmpeqv2df_quiet_nocc */
            }
          break;

        case 14:
          if (
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1192; /* *vec_cmpeqv1tiv1ti_nocc_emu */
          break;

        case 15:
          if ((
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1203; /* *vec_cmpeqv1tf_quiet_nocc */
          break;

        case 16:
          if ((
#line 2055 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 61 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1204; /* *vec_cmpeqtf_quiet_nocc */
          break;

        case 17:
          if (
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1193; /* *vec_cmpeqtiti_nocc_emu */
          break;

        default:
          break;
        }
      break;

    case GT:
      res = recog_32 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GE:
      res = recog_33 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
      res = recog_34 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (!(
#line 6992 "../../gcc/config/s390/s390.md"
(TARGET_Z13) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1959; /* *cstoreccdi_z13 */

        case 1:
          if (!
#line 6992 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 1960; /* *cstoreccsi_z13 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != ABS
          || !register_operand (operands[1], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !(
#line 9019 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2101; /* *absdi2_cc */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 9019 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2102; /* *abssi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern191 (x1))
        {
        case 0:
          if (!(
#line 9030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2103; /* *absdi2_cconly */

        case 1:
          if (!
#line 9030 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2104; /* *abssi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
    {
      switch (pattern115 (x1))
        {
        case 0:
          if ((
#line 1547 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1491; /* *cmp_and_br_signed_di */
          break;

        case 1:
          if (
#line 1547 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1492; /* *cmp_and_br_signed_si */
          break;

        case 2:
          if ((
#line 1605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1495; /* *icmp_and_br_signed_di */
          break;

        case 3:
          if (
#line 1605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1496; /* *icmp_and_br_signed_si */
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  switch (GET_CODE (x4))
    {
    case GT:
    case LE:
      if (pnum_clobbers == NULL
          || !s390_brx_operator (x4, E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x8, 0);
      operands[1] = x10;
      x11 = XEXP (x5, 0);
      operands[0] = x11;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      operands[6] = x4;
      res = recog_81 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != SUBREG)
        return -1;
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != SUBREG)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      operands[5] = x4;
      x16 = XEXP (x13, 0);
      operands[2] = x16;
      x17 = XEXP (x7, 0);
      operands[3] = x17;
      x18 = XEXP (x14, 0);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x19 = XEXP (x15, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x13))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x15), 0))
            return -1;
          switch (SUBREG_BYTE (x14))
            {
            case 8:
              if (pattern292 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 9729 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2189; /* *brxg_64bit */

            case 4:
              if (pattern292 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 9815 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2191; /* *brx_31bit */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x13) != E_SImode
              || maybe_ne (SUBREG_BYTE (x14), 12)
              || GET_MODE (x14) != E_SImode
              || maybe_ne (SUBREG_BYTE (x15), 4)
              || GET_MODE (x15) != E_SImode
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x9) != E_SImode
              || !
#line 9772 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 2;
          return 2190; /* *brx_64bit */

        default:
          return -1;
        }

    case NE:
    case EQ:
      if (pnum_clobbers != NULL)
        {
          res = recog_82 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x4;
      if (!s390_eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 33
          || GET_MODE (x8) != E_CCRAWmode
          || pattern232 (x1) != 0)
        return -1;
      return 2301; /* *ccraw_to_int */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_CCmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pattern213 (x5, 
E_DImode) != 0
          || !
#line 7119 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1964; /* *muldi3 */

    case E_SImode:
      if (pattern213 (x5, 
E_SImode) != 0)
        return -1;
      return 1969; /* *mulsi3 */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          operands[1] = x5;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (pattern223 (x6, 
E_DImode) != 0
                  || !(
#line 6129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1869; /* *adddi3_cconly2 */

            case E_SImode:
              if (pattern223 (x6, 
E_SImode) != 0
                  || !
#line 6129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
                return -1;
              return 1870; /* *addsi3_cconly2 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[0] = x5;
          res = recog_73 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[2] = x6;
          operands[1] = x5;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case SET:
              x10 = XEXP (x7, 1);
              if (GET_CODE (x10) != MINUS)
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x12 = XEXP (x10, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (pattern250 (x10, 
E_DImode) != 0
                      || !(
#line 6603 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1911; /* *subdi3_cc2 */

                case E_SImode:
                  if (pattern250 (x10, 
E_SImode) != 0
                      || !
#line 6603 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
                    return -1;
                  return 1912; /* *subsi3_cc2 */

                default:
                  return -1;
                }

            case CLOBBER:
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!register_operand (operands[1], E_DImode)
                      || !general_operand (operands[2], E_DImode)
                      || !scratch_operand (operands[0], E_DImode)
                      || !(
#line 6637 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1915; /* *subdi3_cconly2 */

                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !general_operand (operands[2], E_SImode)
                      || !scratch_operand (operands[0], E_SImode)
                      || !
#line 6637 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
                    return -1;
                  return 1916; /* *subsi3_cconly2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case ASHIFT:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != SUBREG
              || maybe_ne (SUBREG_BYTE (x14), 0)
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x13, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x16 = XEXP (x5, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != SIGN_EXTEND
              || GET_MODE (x10) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x9 = XEXP (x7, 0);
          if (!register_operand (x9, E_DImode))
            return -1;
          x17 = XEXP (x14, 0);
          switch (GET_CODE (x17))
            {
            case REG:
            case SUBREG:
            case MEM:
              operands[0] = x17;
              if (!nonimmediate_operand (operands[0], E_SImode))
                return -1;
              x6 = XEXP (x4, 1);
              operands[1] = x6;
              if (!const0_operand (operands[1], E_DImode))
                return -1;
              operands[2] = x9;
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[0])
                  || !
#line 987 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_ZARCH))
                return -1;
              return 1428; /* *tstdi_sign */

            case UNSPEC:
              if (XVECLEN (x17, 0) != 1
                  || XINT (x17, 1) != 4
                  || GET_MODE (x17) != E_SImode)
                return -1;
              x6 = XEXP (x4, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || pattern289 (x1) != 0)
                return -1;
              operands[0] = x9;
              x11 = XEXP (x10, 0);
              x18 = XVECEXP (x11, 0, 0);
              if (!rtx_equal_p (x18, operands[1])
                  || !
#line 4023 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_ZARCH))
                return -1;
              return 1576; /* *cmpint_sign_cc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x13;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x16 = XEXP (x5, 1);
          operands[2] = x16;
          if (!shift_count_operand (operands[2], E_QImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              switch (pattern191 (x1))
                {
                case 0:
                  if ((
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9392 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
                    return 2165; /* *ashrdi3_31_cconly */
                  if (!(
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2168; /* *ashrdi3_cconly */

                case 1:
                  if (!
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
                    return -1;
                  return 2171; /* *ashrsi3_cconly */

                default:
                  return -1;
                }

            case SET:
              x10 = XEXP (x7, 1);
              if (GET_CODE (x10) != ASHIFTRT)
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x12 = XEXP (x10, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (pattern239 (x1))
                {
                case 0:
                  if ((
#line 31 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9392 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
                    return 2166; /* *ashrdi3_31_cc */
                  if (!(
#line 31 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2169; /* *ashrdi3_cc */

                case 1:
                  if (!
#line 31 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
                    return -1;
                  return 2172; /* *ashrsi3_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 4
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET
          || pattern210 (x1) != 0)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      x19 = XVECEXP (x10, 0, 0);
      if (!rtx_equal_p (x19, operands[1])
          || !
#line 3988 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)))
        return -1;
      return 1574; /* *cmpint_cc */

    case IOR:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case AND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x16 = XEXP (x5, 1);
          if (GET_CODE (x16) != AND
              || GET_MODE (x16) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[1] = x14;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x15 = XEXP (x13, 1);
          operands[2] = x15;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x20 = XEXP (x16, 0);
          operands[3] = x20;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x21 = XEXP (x16, 1);
          operands[4] = x21;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case SET:
              x10 = XEXP (x7, 1);
              if (pattern251 (x10, 
AND, 
IOR) != 0)
                return -1;
              x12 = XEXP (x10, 1);
              if (GET_CODE (x12) != AND
                  || GET_MODE (x12) != E_DImode)
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!nonimmediate_operand (operands[0], E_DImode))
                return -1;
              x11 = XEXP (x10, 0);
              x22 = XEXP (x11, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x23 = XEXP (x11, 1);
              if (!rtx_equal_p (x23, operands[2]))
                return -1;
              x24 = XEXP (x12, 0);
              if (!rtx_equal_p (x24, operands[3]))
                return -1;
              x25 = XEXP (x12, 1);
              if (!rtx_equal_p (x25, operands[4])
                  || !
#line 4316 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                return -1;
              return 1618; /* *insv_z10_noshift_cc */

            case CLOBBER:
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 4335 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                return -1;
              return 1619; /* *insv_z10_noshift_cconly */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern147 (x1, 
IOR))
            {
            case 0:
              if (!
#line 8041 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              return 2018; /* *iordi3_cc */

            case 1:
              if (!
#line 8121 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2021; /* *iorsi3_cc */

            case 2:
              if (!
#line 8056 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              return 2019; /* *iordi3_cconly */

            case 3:
              if (!
#line 8138 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2022; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern162 (x1, 
IOR))
            {
            case 0:
              if (!(
#line 8293 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2030; /* *orcdi_cc */

            case 1:
              if (!
#line 8293 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2032; /* *orcsi_cc */

            case 2:
              if (!(
#line 8305 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2034; /* *orcdi_cconly */

            case 3:
              if (!
#line 8305 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2036; /* *orcsi_cconly */

            case 4:
              if (!(
#line 8333 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2042; /* *nanddi_cc */

            case 5:
              if (!
#line 8333 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2044; /* *nandsi_cc */

            case 6:
              if (!(
#line 8345 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2046; /* *nanddi_cconly */

            case 7:
              if (!
#line 8345 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2048; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_77 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_78 (x1, insn, pnum_clobbers);

    case MULT:
      x13 = XEXP (x5, 0);
      if (GET_CODE (x13) != SIGN_EXTEND)
        return -1;
      switch (pattern144 (x1, 
MULT))
        {
        case 0:
          if (pattern283 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 7249 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode) && TARGET_Z14) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1971; /* *mulvdi3_ccoverflow */

        case 1:
          if (pattern283 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 7249 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode) && TARGET_Z14))
            return -1;
          return 1972; /* *mulvsi3_ccoverflow */

        default:
          return -1;
        }

    case AND:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern147 (x1, 
AND))
            {
            case 0:
              if (!
#line 7625 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 1996; /* *anddi3_cc */

            case 1:
              if (!
#line 7749 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2007; /* *andsi3_cc */

            case 2:
              if (!
#line 7642 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              return 1997; /* *anddi3_cconly */

            case 3:
              if (!
#line 7770 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              return 2008; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern162 (x1, 
AND))
            {
            case 0:
              if (!(
#line 8293 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2029; /* *andcdi_cc */

            case 1:
              if (!
#line 8293 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2031; /* *andcsi_cc */

            case 2:
              if (!(
#line 8305 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2033; /* *andcdi_cconly */

            case 3:
              if (!
#line 8305 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2035; /* *andcsi_cconly */

            case 4:
              if (!(
#line 8333 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2041; /* *nordi_cc */

            case 5:
              if (!
#line 8333 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2043; /* *norsi_cc */

            case 6:
              if (!(
#line 8345 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2045; /* *nordi_cconly */

            case 7:
              if (!
#line 8345 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2047; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern147 (x1, 
XOR))
        {
        case 0:
          if (!
#line 8466 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          return 2056; /* *xordi3_cc */

        case 1:
          if (!
#line 8530 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2059; /* *xorsi3_cc */

        case 2:
          if (!
#line 8481 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          return 2057; /* *xordi3_cconly */

        case 3:
          if (!
#line 8548 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2060; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      x13 = XEXP (x5, 0);
      if (GET_CODE (x13) != XOR)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      x15 = XEXP (x13, 1);
      operands[2] = x15;
      switch (pattern190 (x1, 
NOT, 
XOR))
        {
        case 0:
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 1);
          x12 = XEXP (x10, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_DImode:
              if (pattern268 (x1, 
E_DImode) != 0
                  || !(
#line 8747 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2066; /* *nxordi_cc */

            case E_SImode:
              if (pattern268 (x1, 
E_SImode) != 0
                  || !
#line 8747 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2067; /* *nxorsi_cc */

            default:
              return -1;
            }

        case 1:
          if (pattern238 (x13, 
E_DImode) != 0
              || !(
#line 8759 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2068; /* *nxordi_cconly */

        case 2:
          if (pattern238 (x13, 
E_SImode) != 0
              || !
#line 8759 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2069; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      return recog_79 (x1, insn, pnum_clobbers);

    case ABS:
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case ASHIFTRT:
          if (pattern148 (x1, 
ABS) != 0
              || !
#line 8998 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2099; /* *absdi2_sign_cc */

        case REG:
        case SUBREG:
          operands[1] = x13;
          x6 = XEXP (x4, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              res = recog_76 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[2] = x6;
          switch (pattern177 (x1, 
ABS))
            {
            case 0:
              if (!(
#line 9064 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2107; /* *abstf2_cc */

            case 1:
              if (!(
#line 9064 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2108; /* *absfprx22_cc */

            case 2:
              if (!
#line 9064 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2109; /* *absdf2_cc */

            case 3:
              if (!
#line 9064 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2110; /* *abssf2_cc */

            case 4:
              if (!(
#line 9075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2111; /* *abstf2_cconly */

            case 5:
              if (!(
#line 9075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 665 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2112; /* *absfprx22_cconly */

            case 6:
              if (!
#line 9075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2113; /* *absdf2_cconly */

            case 7:
              if (!
#line 9075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2114; /* *abssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case POPCOUNT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case SET:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x10 = XEXP (x7, 1);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 11751 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode (insn, CCTmode)))
            return -1;
          return 2288; /* *popcountdi_z15_cc */

        case CLOBBER:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!scratch_operand (operands[0], E_DImode)
              || !
#line 11760 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2289; /* *popcountdi_z15_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_BLKmode)
      || !memory_operand (operands[1], E_BLKmode))
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (pattern196 (x4, 
2) != 0)
    return NULL;
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!memory_operand (operands[3], E_BLKmode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_BLKmode))
    return NULL;
  x8 = XVECEXP (x4, 0, 1);
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !
#line 2940 "../../gcc/config/s390/s390.md"
(((INTVAL (operands[2]) > 16 && INTVAL (operands[5]) > 16)
    || (INTVAL (operands[2]) + INTVAL (operands[5]) <= 16))
   && s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_18 (insn, operands);
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          if (peep2_current_count >= 2)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (register_operand (operands[0], E_DImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern124 (x4, 
E_DImode) == 0
                          && (
#line 1015 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])) && 
#line 678 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_1 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern125 (x4, 
E_DImode) == 0
                          && 
#line 2136 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_11 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[0], E_SImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern124 (x4, 
E_SImode) == 0
                          && 
#line 1015 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_2 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern125 (x4, 
E_SImode) == 0
                          && 
#line 2363 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_15 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x3) == MEM)
            {
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (address_operand (operands[1], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_DImode:
                      if (register_operand (operands[0], E_DImode)
                          && GET_MODE (x3) == E_DImode
                          && 
#line 2097 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && !FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == DImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_9 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_SImode:
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && 
#line 2325 "../../gcc/config/s390/s390.md"
(!FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == SImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_13 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_HImode:
                      if (register_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && 
#line 2468 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == HImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_16 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_QImode:
                      if (nonimmediate_operand (operands[0], E_QImode)
                          && GET_MODE (x3) == E_QImode
                          && 
#line 2533 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == QImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_17 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[1] = x3;
          if (!memory_operand (operands[1], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !
#line 2148 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && s390_const_int_pool_entry_p (operands[1], nullptr)
   && peep2_reg_dead_p (1, gen_rtx_REG (CCmode, CC_REGNUM))))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_12 (insn, operands);

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          if (peep2_current_count < 2)
            return NULL;
          operands[1] = x3;
          x4 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x4) != SET)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != COMPARE
              || GET_MODE (x6) != E_CCZmode)
            return NULL;
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 33
              || GET_MODE (x7) != E_CCZmode)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern242 (
E_TFmode) != 0
                  || !(
#line 1448 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 658 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_3 (insn, operands);

            case E_FPRX2mode:
              if (pattern242 (
E_FPRX2mode) != 0
                  || !(
#line 1448 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 658 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_4 (insn, operands);

            case E_DFmode:
              if (pattern242 (
E_DFmode) != 0
                  || !
#line 1448 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_5 (insn, operands);

            case E_SFmode:
              if (pattern242 (
E_SFmode) != 0
                  || !
#line 1448 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_6 (insn, operands);

            case E_TDmode:
              if (pattern242 (
E_TDmode) != 0
                  || !(
#line 1448 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_7 (insn, operands);

            case E_DDmode:
              if (pattern242 (
E_DDmode) != 0
                  || !(
#line 1448 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 659 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_8 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 1);
          operands[1] = x12;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case CLOBBER:
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 33
                  || GET_MODE (x14) != E_CCmode
                  || !address_operand (operands[1], E_QImode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !
#line 2123 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_10 (insn, operands);

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 2350 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_14 (insn, operands);

                default:
                  return NULL;
                }

            case USE:
              if (peep2_current_count >= 2)
                {
                  res = peephole2_1 (x1, insn, pmatch_len_);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!plus16_Q_operand (operands[0], E_BLKmode)
                  || !plus16_Q_operand (operands[1], E_BLKmode))
                return NULL;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 2959 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) > 16 && INTVAL (operands[2]) <= 32))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_19 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          if (peep2_current_count < 2)
            return NULL;
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return NULL;
          x15 = XVECEXP (x1, 0, 2);
          if (pattern41 (x15) != 0)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!memory_operand (operands[0], E_BLKmode))
            return NULL;
          x14 = XEXP (x13, 0);
          if (!const_int_operand (x14, E_VOIDmode))
            return NULL;
          x4 = PATTERN (peep2_next_insn (1));
          if (pattern196 (x4, 
3) != 0)
            return NULL;
          x16 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x16) != CLOBBER)
            return NULL;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode)
            return NULL;
          x18 = XVECEXP (x4, 0, 0);
          x19 = XEXP (x18, 0);
          if (!memory_operand (x19, E_BLKmode))
            return NULL;
          x20 = XVECEXP (x4, 0, 1);
          x21 = XEXP (x20, 0);
          if (!const_int_operand (x21, E_VOIDmode))
            return NULL;
          x12 = XEXP (x10, 1);
          switch (GET_CODE (x12))
            {
            case AND:
              if (pattern288 (x1, 
AND) != 0
                  || !
#line 8004 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_20 (insn, operands);

            case IOR:
              if (pattern288 (x1, 
IOR) != 0
                  || !
#line 8414 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_21 (insn, operands);

            case XOR:
              if (pattern288 (x1, 
XOR) != 0
                  || !
#line 8686 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_22 (insn, operands);

            case CONST_INT:
              if (XWINT (x12, 0) != 0L)
                return NULL;
              operands[1] = x14;
              x22 = XEXP (x18, 1);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              operands[2] = x19;
              operands[3] = x21;
              if (!
#line 8724 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[2], operands[1])
   && INTVAL (operands[1]) + INTVAL (operands[3]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_23 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
